/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case TRUNCATE:
      return 0;

    case MINUS:
      res = pattern4 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case CONST_VECTOR:
    case CONST:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern5 (x3, 
E_V8QImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern5 (x3, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4HImode:
          if (pattern5 (x3, 
E_V4HImode) != 0)
            return -1;
          return 5;

        case E_V8HImode:
          if (pattern5 (x3, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V2SImode:
          if (pattern5 (x3, 
E_V2SImode) != 0)
            return -1;
          return 7;

        case E_V4SImode:
          if (pattern5 (x3, 
E_V4SImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern5 (x3, 
E_V2DImode) != 0)
            return -1;
          return 9;

        case E_VNx16QImode:
          if (pattern5 (x3, 
E_VNx16QImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern5 (x3, 
E_VNx8QImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern5 (x3, 
E_VNx4QImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern5 (x3, 
E_VNx2QImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern5 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern5 (x3, 
E_VNx4HImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern5 (x3, 
E_VNx2HImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern5 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern5 (x3, 
E_VNx2SImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern5 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_uminmax_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 5
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  if (!aarch64_call_insn_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XVECEXP (x4, 0, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i3
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern55 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern55 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern55 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern55 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern55 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern55 (x3, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern55 (x3, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern55 (x3, 
E_DFmode) != 0)
        return -1;
      return 7;

    case E_VNx8HFmode:
      if (pattern55 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 8;

    case E_VNx4SFmode:
      if (pattern55 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 9;

    case E_VNx2DFmode:
      if (pattern55 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_qi (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern68 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern68 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern68 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern68 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 3;

    case E_BFmode:
      if (pattern68 (x3, 
E_VNx8BFmode, 
E_VNx8BImode, 
E_BFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern68 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern68 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern68 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern91 (x3, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern91 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern91 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern91 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  return pattern112 (x2); /* [-1, 1] */
}

int
pattern121 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_si (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern160 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern160 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern160 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern170 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[2], E_VNx4SFmode))
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !aarch64_maskload_else_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern91 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern91 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!aarch64_imm2 (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  return pattern203 (x3); /* [-1, 3] */
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XVECEXP (x2, 0, 0);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XVECEXP (x5, 0, 0);
  operands[6] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern206 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern206 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern206 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 0;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[1], E_VNx4DImode))
            return -1;
          return 1;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[1], E_VNx16SImode))
            return -1;
          return 2;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[2], E_VNx8SImode))
            return -1;
          return 4;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[2], E_VNx4DImode))
            return -1;
          return 5;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[2], E_VNx16SImode))
            return -1;
          return 6;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[2], E_VNx8DImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 4);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          return pattern239 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern239 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          res = pattern240 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern240 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 167)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[3] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          res = pattern241 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        case E_VNx2DImode:
          res = pattern241 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 20; /* [20, 23] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern254 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      return pattern257 (x2, 
E_VNx16QImode, 
E_VNx4BImode, 
E_VNx4SImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern257 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_ldff1_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx1TImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern274 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern280 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern280 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern301 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern300 (); /* [-1, 2] */
}

int
pattern303 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_hi_half (operands[2], i2)
      || !aarch64_simd_shll_imm_vec (operands[3], i1))
    return -1;
  return 0;
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern312 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern312 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern312 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern314 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern314 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern314 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern328 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx2DImode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 168:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 306:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x1) != E_QImode
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode))
                return -1;
              return 0;

            case E_HImode:
              if (pattern333 (x1, 
E_SImode, 
E_HImode) != 0)
                return -1;
              return 1;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x1) != E_SImode
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case CONST_VECTOR:
          res = pattern334 (x1);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != i1)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      switch (GET_CODE (operands[2]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (!register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x1) != E_V8QImode
                  || GET_MODE (x2) != E_V8SImode
                  || pattern335 (x4, 
E_V8HImode, 
E_V8SImode) != 0)
                return -1;
              return 6;

            case E_V4HImode:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x1) != E_V4HImode
                  || GET_MODE (x2) != E_V4DImode
                  || pattern336 (x4, 
E_V4SImode, 
E_V4DImode) != 0)
                return -1;
              return 7;

            case E_V2SImode:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x1) != E_V2SImode
                  || GET_MODE (x2) != E_V2TImode
                  || pattern337 (x4, 
E_V2DImode, 
E_V2TImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x1) != E_QImode
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x4) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[1], E_HImode)
                  || !aarch64_int_rnd_operand (operands[3], E_SImode)
                  || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode))
                return -1;
              return 9;

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x1) != E_HImode
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x4) != E_DImode
                  || GET_MODE (x5) != E_DImode
                  || !register_operand (operands[1], E_SImode)
                  || !aarch64_int_rnd_operand (operands[3], E_DImode)
                  || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode))
                return -1;
              return 10;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x1) != E_SImode
                  || GET_MODE (x2) != E_TImode
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode
                  || !register_operand (operands[1], E_DImode)
                  || !aarch64_int_rnd_operand (operands[3], E_TImode)
                  || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern380 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x1) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 5;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 9;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 10;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 11;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 12;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 13;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 14;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 15;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 16;

    default:
      return -1;
    }
}

int
pattern403 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern402 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern402 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern402 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern413 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern420 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern419 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern419 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern419 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern426 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[3], i1)
      || !register_operand (operands[1], E_V8QImode))
    return -1;
  return 0;
}

int
pattern430 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x1, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          return pattern421 (x1); /* [-1, 2] */

        case REG:
        case SUBREG:
          res = pattern422 (x1);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x5 = XEXP (x1, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          operands[4] = x5;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern423 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
                return -1;
              return 6;

            case E_V8HImode:
              if (pattern424 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
                return -1;
              return 7;

            case E_V4SImode:
              if (pattern425 (x1, 
E_V2DImode, 
E_V2TImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          res = pattern429 (x1);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern450 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern205 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern454 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_struct_nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_sve_struct_nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern458 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_vsm_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern463 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_vsb_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern466 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_lshift_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern470 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern470 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern470 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern470 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern479 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern492 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern488 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern488 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern488 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern501 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || GET_MODE (x2) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  return 0;
}

int
pattern504 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!aarch64_imm3 (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern503 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern503 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern518 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !aarch64_simd_reg_or_zero (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || GET_MODE (x3) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HImode))
            return -1;
          return 1;

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DFmode)
          || !aarch64_simd_reg_or_zero (operands[2], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern552 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != NOT)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 4)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern559 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern558 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern558 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern558 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern558 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern569 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern571 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != AND)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  return 0;
}

int
pattern579 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[6], E_VNx4BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[5], E_VNx4BImode)
      || !register_operand (operands[2], E_VNx4SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx4QImode:
      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx4QImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
          || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx4HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern597 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern466 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8QImode:
          if (pattern466 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4QImode:
          if (pattern466 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2QImode:
          if (pattern466 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern466 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern466 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2HImode:
          if (pattern466 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern466 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2SImode:
          if (pattern466 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx2DImode:
          if (pattern466 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern596 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern596 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern596 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern596 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern596 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern596 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern596 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern596 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern596 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern596 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern628 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern627 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern627 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern627 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  return pattern634 (x1); /* [-1, 4] */
}

int
pattern638 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern637 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern637 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern637 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern637 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern637 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern637 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern659 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern664 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[2], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[2], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[2], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern677 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CC_NZCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern676 (x5, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern676 (x5, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern676 (x5, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern676 (x5, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern684 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern682 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern682 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern682 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern682 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    case E_VNx8BFmode:
      if (pattern683 (x1, 
E_VNx8HImode, 
E_VNx8BFmode) != 0)
        return -1;
      return 4;

    case E_VNx8HFmode:
      if (pattern683 (x1, 
E_VNx8HImode, 
E_VNx8HFmode) != 0)
        return -1;
      return 5;

    case E_VNx4SFmode:
      if (pattern683 (x1, 
E_VNx4SImode, 
E_VNx4SFmode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern683 (x1, 
E_VNx2DImode, 
E_VNx2DFmode) != 0)
        return -1;
      return 7;

    case E_VNx32QImode:
      if (!aligned_register_operand (operands[0], E_VNx32QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32QImode
          || pattern681 (x1, 
E_VNx32QImode) != 0)
        return -1;
      return 8;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[0], E_VNx16HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16HImode
          || pattern681 (x1, 
E_VNx16HImode) != 0)
        return -1;
      return 9;

    case E_VNx8SImode:
      if (!aligned_register_operand (operands[0], E_VNx8SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8SImode
          || pattern681 (x1, 
E_VNx8SImode) != 0)
        return -1;
      return 10;

    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx4DImode
          || pattern681 (x1, 
E_VNx4DImode) != 0)
        return -1;
      return 11;

    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[0], E_VNx16BFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16BFmode
          || pattern681 (x1, 
E_VNx16BFmode) != 0)
        return -1;
      return 12;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[0], E_VNx16HFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16HFmode
          || pattern681 (x1, 
E_VNx16HFmode) != 0)
        return -1;
      return 13;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8SFmode
          || pattern681 (x1, 
E_VNx8SFmode) != 0)
        return -1;
      return 14;

    case E_VNx4DFmode:
      if (!aligned_register_operand (operands[0], E_VNx4DFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx4DFmode
          || pattern681 (x1, 
E_VNx4DFmode) != 0)
        return -1;
      return 15;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx64QImode
          || pattern681 (x1, 
E_VNx64QImode) != 0)
        return -1;
      return 16;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32HImode
          || pattern681 (x1, 
E_VNx32HImode) != 0)
        return -1;
      return 17;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16SImode
          || pattern681 (x1, 
E_VNx16SImode) != 0)
        return -1;
      return 18;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8DImode
          || pattern681 (x1, 
E_VNx8DImode) != 0)
        return -1;
      return 19;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32BFmode
          || pattern681 (x1, 
E_VNx32BFmode) != 0)
        return -1;
      return 20;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx32HFmode
          || pattern681 (x1, 
E_VNx32HFmode) != 0)
        return -1;
      return 21;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx16SFmode
          || pattern681 (x1, 
E_VNx16SFmode) != 0)
        return -1;
      return 22;

    case E_VNx8DFmode:
      if (!aligned_register_operand (operands[0], E_VNx8DFmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_VNx8DFmode
          || pattern681 (x1, 
E_VNx8DFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern744 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern743 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern743 (x1, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern743 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern743 (x1, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern743 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern743 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern755 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern760 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 1);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern759 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern759 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern759 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern769 (rtx x1, machine_mode i1, int i2, int i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i4
      || XVECLEN (x2, 0) != i3
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern773 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern781 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern787 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[3], i3)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern796 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx2QImode:
          return pattern795 (x1, 
E_VNx2QImode); /* [-1, 0] */

        case E_VNx2HImode:
          if (pattern795 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 1;

        case E_VNx2SImode:
          if (pattern795 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern795 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        case E_VNx4QImode:
          if (pattern795 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern795 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern795 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125
          || GET_MODE (x4) != E_VNx2DImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_VNx2DImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != TRUNCATE
          || GET_MODE (x7) != E_VNx2SImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[4] = x5;
      if (GET_MODE (x3) != E_VNx2DImode)
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      operands[5] = x8;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_VNx2DImode)
          || !const_1_to_3_operand (operands[3], E_VNx2DImode)
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 7;

    case AND:
      if (GET_MODE (x4) != E_VNx2DImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[5] = x5;
      if (GET_MODE (x3) != E_VNx2DImode)
        return -1;
      x10 = XEXP (x4, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x11 = XEXP (x4, 1);
      operands[4] = x11;
      if (!aarch64_sve_uxtw_immediate (operands[4], E_VNx2DImode)
          || !const_1_to_3_operand (operands[3], E_VNx2DImode)
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern839 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          return pattern837 (x1, 
E_VNx16QImode, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SImode:
          if (pattern837 (x1, 
E_VNx8HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DImode:
          if (pattern837 (x1, 
E_VNx4SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 0);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern838 (x1, 
E_VNx8HImode, 
E_VNx16QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SImode:
          if (pattern838 (x1, 
E_VNx4SImode, 
E_VNx8HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DImode:
          if (pattern838 (x1, 
E_VNx2DImode, 
E_VNx4SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern861 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern867 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!aarch64_sync_memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!aarch64_sync_memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!aarch64_sync_memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern872 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  return pattern871 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern878 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_plus_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_plus_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern885 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern889 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern896 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern904 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern909 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern951 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern957 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern962 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern968 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 98)
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0)
    return -1;
  return 0;
}

int
pattern972 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!memory_operand (operands[2], E_V8QImode)
          || !register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!memory_operand (operands[2], E_V4HImode)
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!memory_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 2;

    case E_V2SImode:
      if (!memory_operand (operands[2], E_V2SImode)
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!memory_operand (operands[2], E_V2SFmode)
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      return 4;

    case E_DFmode:
      if (!memory_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern984 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern989 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[3], E_V4BFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[3], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern998 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern336 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1006 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1014 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1018 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1026 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1030 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1026 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1026 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1026 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1026 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1029 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1029 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1029 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1048 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1053 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1061 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern1060 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1069 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1076 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i4))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1087 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[4] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1027 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1027 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1027 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1027 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return 4;

        case E_VNx4SFmode:
          return 5;

        case E_VNx2DFmode:
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1095 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1092 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1092 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1092 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1093 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SFmode:
          if (pattern1093 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DFmode:
          if (pattern1093 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1112 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1118 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern1126 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SFmode
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1135 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1)
      || pattern973 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern1154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16BImode)
          || !register_operand (operands[3], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8BImode)
          || !register_operand (operands[3], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4BImode)
          || !register_operand (operands[3], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx2BImode
          || !register_operand (operands[2], E_VNx2BImode)
          || !register_operand (operands[3], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1172 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1179 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1179 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1179 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1179 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1190 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i1)
      || !const_scalar_int_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !aarch64_plus_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1195 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_hi_half (operands[4], i2))
    return -1;
  x6 = XEXP (x3, 1);
  return pattern1165 (x6, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1209 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern1215 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_h (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1221 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1228 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_VNx16BImode)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  return pattern1230 (x1, 
i1); /* [-1, 1] */
}

int
pattern1241 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  if (!aarch64_sve_gp_strictness (operands[6], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern450 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern450 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern450 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1259 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1266 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_w (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern1275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16BImode)
      || !register_operand (operands[4], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern1274 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern1274 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern1274 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1284 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !aarch64_carry_operation (operands[3], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1
      || !aarch64_carry_operation (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx2DImode))
    return -1;
  return pattern1328 (x1); /* [-1, 1] */
}

int
pattern1346 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1351 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i2))
    return -1;
  x8 = XEXP (x3, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !aarch64_borrow_operation (operands[4], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  x9 = XEXP (x6, 2);
  operands[5] = x9;
  switch (pattern924 (x2))
    {
    case 0:
      if (!aarch64_simd_shift_imm_si (operands[5], E_SImode)
          || !
#line 6541 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && (UINTVAL (operands[4]) + UINTVAL (operands[5])
       <= GET_MODE_BITSIZE (SImode))))
        return -1;
      return 847; /* *aarch64_bfxilsi_extr */

    case 1:
      if (!aarch64_simd_shift_imm_di (operands[5], E_DImode)
          || !
#line 6541 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && (UINTVAL (operands[4]) + UINTVAL (operands[5])
       <= GET_MODE_BITSIZE (DImode))))
        return -1;
      return 848; /* *aarch64_bfxildi_extr */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      switch (XINT (x4, 1))
        {
        case 315:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6882; /* aarch64_pred_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6885; /* aarch64_pred_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6888; /* aarch64_pred_revbvnx4si */

            case E_VNx2DImode:
              if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6891; /* aarch64_pred_revbvnx2di */

            default:
              return -1;
            }

        case 317:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6883; /* aarch64_pred_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6886; /* aarch64_pred_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6889; /* aarch64_pred_revhvnx4si */

            case E_VNx2DImode:
              if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6892; /* aarch64_pred_revhvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6884; /* aarch64_pred_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6887; /* aarch64_pred_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6890; /* aarch64_pred_revwvnx4si */

            case E_VNx2DImode:
              if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6893; /* aarch64_pred_revwvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              switch (pattern926 (x2, 
E_VNx16QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 8))
                    return -1;
                  return 6894; /* aarch64_sve_revbhw_vnx16qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 8))
                    return -1;
                  return 6913; /* aarch64_sve_revbhw_vnx16qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 8))
                    return -1;
                  return 6932; /* aarch64_sve_revbhw_vnx16qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8QImode:
              switch (pattern926 (x2, 
E_VNx8QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6895; /* aarch64_sve_revbhw_vnx8qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6914; /* aarch64_sve_revbhw_vnx8qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6933; /* aarch64_sve_revbhw_vnx8qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4QImode:
              switch (pattern926 (x2, 
E_VNx4QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6896; /* aarch64_sve_revbhw_vnx4qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6915; /* aarch64_sve_revbhw_vnx4qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6934; /* aarch64_sve_revbhw_vnx4qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2QImode:
              switch (pattern926 (x2, 
E_VNx2QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6897; /* aarch64_sve_revbhw_vnx2qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6916; /* aarch64_sve_revbhw_vnx2qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6935; /* aarch64_sve_revbhw_vnx2qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HImode:
              switch (pattern926 (x2, 
E_VNx8HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6898; /* aarch64_sve_revbhw_vnx8hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6917; /* aarch64_sve_revbhw_vnx8hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6936; /* aarch64_sve_revbhw_vnx8hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HImode:
              switch (pattern926 (x2, 
E_VNx4HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6899; /* aarch64_sve_revbhw_vnx4hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6918; /* aarch64_sve_revbhw_vnx4hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6937; /* aarch64_sve_revbhw_vnx4hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HImode:
              switch (pattern926 (x2, 
E_VNx2HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6900; /* aarch64_sve_revbhw_vnx2hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6919; /* aarch64_sve_revbhw_vnx2hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6938; /* aarch64_sve_revbhw_vnx2hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SImode:
              switch (pattern926 (x2, 
E_VNx4SImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6901; /* aarch64_sve_revbhw_vnx4sivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6920; /* aarch64_sve_revbhw_vnx4sivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6939; /* aarch64_sve_revbhw_vnx4sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SImode:
              switch (pattern926 (x2, 
E_VNx2SImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6902; /* aarch64_sve_revbhw_vnx2sivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6921; /* aarch64_sve_revbhw_vnx2sivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6940; /* aarch64_sve_revbhw_vnx2sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DImode:
              switch (pattern926 (x2, 
E_VNx2DImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6903; /* aarch64_sve_revbhw_vnx2divnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6922; /* aarch64_sve_revbhw_vnx2divnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6941; /* aarch64_sve_revbhw_vnx2divnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HFmode:
              switch (pattern926 (x2, 
E_VNx8HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6904; /* aarch64_sve_revbhw_vnx8hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6923; /* aarch64_sve_revbhw_vnx8hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6942; /* aarch64_sve_revbhw_vnx8hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HFmode:
              switch (pattern926 (x2, 
E_VNx4HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6905; /* aarch64_sve_revbhw_vnx4hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6924; /* aarch64_sve_revbhw_vnx4hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6943; /* aarch64_sve_revbhw_vnx4hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HFmode:
              switch (pattern926 (x2, 
E_VNx2HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6906; /* aarch64_sve_revbhw_vnx2hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6925; /* aarch64_sve_revbhw_vnx2hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6944; /* aarch64_sve_revbhw_vnx2hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx8BFmode:
              switch (pattern926 (x2, 
E_VNx8BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6907; /* aarch64_sve_revbhw_vnx8bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6926; /* aarch64_sve_revbhw_vnx8bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6945; /* aarch64_sve_revbhw_vnx8bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4BFmode:
              switch (pattern926 (x2, 
E_VNx4BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6908; /* aarch64_sve_revbhw_vnx4bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6927; /* aarch64_sve_revbhw_vnx4bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6946; /* aarch64_sve_revbhw_vnx4bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2BFmode:
              switch (pattern926 (x2, 
E_VNx2BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6909; /* aarch64_sve_revbhw_vnx2bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6928; /* aarch64_sve_revbhw_vnx2bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6947; /* aarch64_sve_revbhw_vnx2bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SFmode:
              switch (pattern926 (x2, 
E_VNx4SFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6910; /* aarch64_sve_revbhw_vnx4sfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6929; /* aarch64_sve_revbhw_vnx4sfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6948; /* aarch64_sve_revbhw_vnx4sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SFmode:
              switch (pattern926 (x2, 
E_VNx2SFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6911; /* aarch64_sve_revbhw_vnx2sfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6930; /* aarch64_sve_revbhw_vnx2sfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6949; /* aarch64_sve_revbhw_vnx2sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DFmode:
              switch (pattern926 (x2, 
E_VNx2DFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6912; /* aarch64_sve_revbhw_vnx2dfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6931; /* aarch64_sve_revbhw_vnx2dfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6950; /* aarch64_sve_revbhw_vnx2dfvnx2bi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 26:
          if (pattern850 (x2) != 0
              || !
#line 3464 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12594; /* aarch64_pred_urecpevnx4si */

        case 111:
          if (pattern850 (x2) != 0
              || !
#line 3464 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12595; /* aarch64_pred_ursqrtevnx4si */

        case 316:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern978 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12745; /* aarch64_pred_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern978 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12746; /* aarch64_pred_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern978 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12747; /* aarch64_pred_revdvnx4si */

            case E_VNx2DImode:
              if (pattern978 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12748; /* aarch64_pred_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern978 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12749; /* aarch64_pred_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern978 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12750; /* aarch64_pred_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern978 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12751; /* aarch64_pred_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern978 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12752; /* aarch64_pred_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_11 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern366 (x3))
    {
    case 0:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4586; /* aarch64_rev_reglistv2x8qi */

    case 1:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4587; /* aarch64_rev_reglistv2x4hi */

    case 2:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4588; /* aarch64_rev_reglistv2x2si */

    case 3:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4589; /* aarch64_rev_reglistv2x1di */

    case 4:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4590; /* aarch64_rev_reglistv2x4hf */

    case 5:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4591; /* aarch64_rev_reglistv2x2sf */

    case 6:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4592; /* aarch64_rev_reglistv2x1df */

    case 7:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4593; /* aarch64_rev_reglistv2x4bf */

    case 8:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4594; /* aarch64_rev_reglistv3x8qi */

    case 9:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4595; /* aarch64_rev_reglistv3x4hi */

    case 10:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4596; /* aarch64_rev_reglistv3x2si */

    case 11:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4597; /* aarch64_rev_reglistv3x1di */

    case 12:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4598; /* aarch64_rev_reglistv3x4hf */

    case 13:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4599; /* aarch64_rev_reglistv3x2sf */

    case 14:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4600; /* aarch64_rev_reglistv3x1df */

    case 15:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4601; /* aarch64_rev_reglistv3x4bf */

    case 16:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4602; /* aarch64_rev_reglistv4x8qi */

    case 17:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4603; /* aarch64_rev_reglistv4x4hi */

    case 18:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4604; /* aarch64_rev_reglistv4x2si */

    case 19:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4605; /* aarch64_rev_reglistv4x1di */

    case 20:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4606; /* aarch64_rev_reglistv4x4hf */

    case 21:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4607; /* aarch64_rev_reglistv4x2sf */

    case 22:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4608; /* aarch64_rev_reglistv4x1df */

    case 23:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4609; /* aarch64_rev_reglistv4x4bf */

    case 24:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4610; /* aarch64_rev_reglistv2x16qi */

    case 25:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4611; /* aarch64_rev_reglistv2x8hi */

    case 26:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4612; /* aarch64_rev_reglistv2x4si */

    case 27:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4613; /* aarch64_rev_reglistv2x2di */

    case 28:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4614; /* aarch64_rev_reglistv2x8hf */

    case 29:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4615; /* aarch64_rev_reglistv2x4sf */

    case 30:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4616; /* aarch64_rev_reglistv2x2df */

    case 31:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4617; /* aarch64_rev_reglistv2x8bf */

    case 32:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4618; /* aarch64_rev_reglistv3x16qi */

    case 33:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4619; /* aarch64_rev_reglistv3x8hi */

    case 34:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4620; /* aarch64_rev_reglistv3x4si */

    case 35:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4621; /* aarch64_rev_reglistv3x2di */

    case 36:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4622; /* aarch64_rev_reglistv3x8hf */

    case 37:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4623; /* aarch64_rev_reglistv3x4sf */

    case 38:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4624; /* aarch64_rev_reglistv3x2df */

    case 39:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4625; /* aarch64_rev_reglistv3x8bf */

    case 40:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4626; /* aarch64_rev_reglistv4x16qi */

    case 41:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4627; /* aarch64_rev_reglistv4x8hi */

    case 42:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4628; /* aarch64_rev_reglistv4x4si */

    case 43:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4629; /* aarch64_rev_reglistv4x2di */

    case 44:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4630; /* aarch64_rev_reglistv4x8hf */

    case 45:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4631; /* aarch64_rev_reglistv4x4sf */

    case 46:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4632; /* aarch64_rev_reglistv4x2df */

    case 47:
      if (!
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4633; /* aarch64_rev_reglistv4x8bf */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[1], E_V2x8QImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4434; /* aarch64_vec_store_lanesv2x8qi_lanev8qi */

    case E_V2x4HImode:
      if (!register_operand (operands[1], E_V2x4HImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4435; /* aarch64_vec_store_lanesv2x4hi_lanev4hi */

    case E_V2x2SImode:
      if (!register_operand (operands[1], E_V2x2SImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4436; /* aarch64_vec_store_lanesv2x2si_lanev2si */

    case E_V2x1DImode:
      if (!register_operand (operands[1], E_V2x1DImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4437; /* aarch64_vec_store_lanesv2x1di_lanedi */

    case E_V2x4HFmode:
      if (!register_operand (operands[1], E_V2x4HFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4438; /* aarch64_vec_store_lanesv2x4hf_lanev4hf */

    case E_V2x2SFmode:
      if (!register_operand (operands[1], E_V2x2SFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4439; /* aarch64_vec_store_lanesv2x2sf_lanev2sf */

    case E_V2x1DFmode:
      if (!register_operand (operands[1], E_V2x1DFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4440; /* aarch64_vec_store_lanesv2x1df_lanedf */

    case E_V2x4BFmode:
      if (!register_operand (operands[1], E_V2x4BFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4441; /* aarch64_vec_store_lanesv2x4bf_lanev4bf */

    case E_V2x16QImode:
      if (!register_operand (operands[1], E_V2x16QImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4442; /* aarch64_vec_store_lanesv2x16qi_lanev16qi */

    case E_V2x8HImode:
      if (!register_operand (operands[1], E_V2x8HImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4443; /* aarch64_vec_store_lanesv2x8hi_lanev8hi */

    case E_V2x4SImode:
      if (!register_operand (operands[1], E_V2x4SImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4444; /* aarch64_vec_store_lanesv2x4si_lanev4si */

    case E_V2x2DImode:
      if (!register_operand (operands[1], E_V2x2DImode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4445; /* aarch64_vec_store_lanesv2x2di_lanev2di */

    case E_V2x8HFmode:
      if (!register_operand (operands[1], E_V2x8HFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4446; /* aarch64_vec_store_lanesv2x8hf_lanev8hf */

    case E_V2x4SFmode:
      if (!register_operand (operands[1], E_V2x4SFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4447; /* aarch64_vec_store_lanesv2x4sf_lanev4sf */

    case E_V2x2DFmode:
      if (!register_operand (operands[1], E_V2x2DFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4448; /* aarch64_vec_store_lanesv2x2df_lanev2df */

    case E_V2x8BFmode:
      if (!register_operand (operands[1], E_V2x8BFmode)
          || !
#line 7430 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4449; /* aarch64_vec_store_lanesv2x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern59 (x1))
    {
    case 0:
      if (!(
#line 7386 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1085; /* fmaxhf3 */

    case 1:
      if (!
#line 7386 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1089; /* fmaxsf3 */

    case 2:
      if (!
#line 7386 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1093; /* fmaxdf3 */

    case 3:
      if (!(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2671; /* fmaxv4hf3 */

    case 4:
      if (!(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2679; /* fmaxv8hf3 */

    case 5:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2687; /* fmaxv2sf3 */

    case 6:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2695; /* fmaxv4sf3 */

    case 7:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2699; /* fmaxv2df3 */

    case 8:
      if (!(
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 683 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12221; /* *aarch64_sve_fmaxnmvnx16bf */

    case 9:
      if (!(
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 684 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12225; /* *aarch64_sve_fmaxnmvnx32bf */

    case 10:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12229; /* *aarch64_sve_fmaxnmvnx16hf */

    case 11:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12233; /* *aarch64_sve_fmaxnmvnx8sf */

    case 12:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12237; /* *aarch64_sve_fmaxnmvnx4df */

    case 13:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12241; /* *aarch64_sve_fmaxnmvnx32hf */

    case 14:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12245; /* *aarch64_sve_fmaxnmvnx16sf */

    case 15:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12249; /* *aarch64_sve_fmaxnmvnx8df */

    case 16:
      if (!(
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 683 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12253; /* aarch64_sve_single_fmaxnmvnx16bf */

    case 17:
      if (!(
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 684 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12257; /* aarch64_sve_single_fmaxnmvnx32bf */

    case 18:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12261; /* aarch64_sve_single_fmaxnmvnx16hf */

    case 19:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12265; /* aarch64_sve_single_fmaxnmvnx8sf */

    case 20:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12269; /* aarch64_sve_single_fmaxnmvnx4df */

    case 21:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12273; /* aarch64_sve_single_fmaxnmvnx32hf */

    case 22:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12277; /* aarch64_sve_single_fmaxnmvnx16sf */

    case 23:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12281; /* aarch64_sve_single_fmaxnmvnx8df */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern96 (x1))
    {
    case 0:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10465; /* aarch64_sve_uzpq2vnx16qi */

    case 1:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10475; /* aarch64_sve_uzpq2vnx8qi */

    case 2:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10485; /* aarch64_sve_uzpq2vnx4qi */

    case 3:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10495; /* aarch64_sve_uzpq2vnx2qi */

    case 4:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10505; /* aarch64_sve_uzpq2vnx8hi */

    case 5:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10515; /* aarch64_sve_uzpq2vnx4hi */

    case 6:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10525; /* aarch64_sve_uzpq2vnx2hi */

    case 7:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10535; /* aarch64_sve_uzpq2vnx4si */

    case 8:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10545; /* aarch64_sve_uzpq2vnx2si */

    case 9:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10555; /* aarch64_sve_uzpq2vnx2di */

    case 10:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10565; /* aarch64_sve_uzpq2vnx8hf */

    case 11:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10575; /* aarch64_sve_uzpq2vnx4hf */

    case 12:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10585; /* aarch64_sve_uzpq2vnx2hf */

    case 13:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10595; /* aarch64_sve_uzpq2vnx8bf */

    case 14:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10605; /* aarch64_sve_uzpq2vnx4bf */

    case 15:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10615; /* aarch64_sve_uzpq2vnx2bf */

    case 16:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10625; /* aarch64_sve_uzpq2vnx4sf */

    case 17:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10635; /* aarch64_sve_uzpq2vnx2sf */

    case 18:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3165 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10645; /* aarch64_sve_uzpq2vnx2df */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern66 (x1))
    {
    case 0:
      if (!(
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5158; /* aarch64_frecpsv4hf */

    case 1:
      if (!(
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 182 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5159; /* aarch64_frecpsv8hf */

    case 2:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5160; /* aarch64_frecpsv2sf */

    case 3:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5161; /* aarch64_frecpsv4sf */

    case 4:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5162; /* aarch64_frecpsv2df */

    case 5:
      if (!(
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 184 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5163; /* aarch64_frecpshf */

    case 6:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5164; /* aarch64_frecpssf */

    case 7:
      if (!
#line 8659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5165; /* aarch64_frecpsdf */

    case 8:
      if (!
#line 5408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8482; /* aarch64_sve_frecpsvnx8hf */

    case 9:
      if (!
#line 5408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8484; /* aarch64_sve_frecpsvnx4sf */

    case 10:
      if (!
#line 5408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8486; /* aarch64_sve_frecpsvnx2df */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8988; /* *iorvnx8hf3 */

    case 1:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8991; /* *iorvnx4hf3 */

    case 2:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8994; /* *iorvnx2hf3 */

    case 3:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8997; /* *iorvnx8bf3 */

    case 4:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9000; /* *iorvnx4bf3 */

    case 5:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9003; /* *iorvnx2bf3 */

    case 6:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9006; /* *iorvnx4sf3 */

    case 7:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9009; /* *iorvnx2sf3 */

    case 8:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9012; /* *iorvnx2df3 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern716 (x3, 
E_VNx4BImode, 
E_VNx4SImode, 
E_VNx1SImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11089; /* aarch64_sve_ld1_extendqvnx4si */

    case E_VNx2DImode:
      if (pattern716 (x3, 
E_VNx2BImode, 
E_VNx2DImode, 
E_VNx1DImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11090; /* aarch64_sve_ld1_extendqvnx2di */

    case E_VNx4SFmode:
      if (pattern716 (x3, 
E_VNx4BImode, 
E_VNx4SFmode, 
E_VNx1SImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11091; /* aarch64_sve_ld1_extendqvnx4sf */

    case E_VNx2DFmode:
      if (pattern716 (x3, 
E_VNx2BImode, 
E_VNx2DFmode, 
E_VNx1DImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11092; /* aarch64_sve_ld1_extendqvnx2df */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3638; /* aarch64_ushlv8qi */

    case 1:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3648; /* aarch64_ushlv16qi */

    case 2:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3654; /* aarch64_ushlv4hi */

    case 3:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3664; /* aarch64_ushlv8hi */

    case 4:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3670; /* aarch64_ushlv2si */

    case 5:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3680; /* aarch64_ushlv4si */

    case 6:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3684; /* aarch64_ushlv2di */

    case 7:
      if (!
#line 6308 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3690; /* aarch64_ushldi */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern53 (x1))
    {
    case 0:
      return 1023; /* fcvtzusf3 */

    case 1:
      if (!
#line 7171 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1031; /* fcvtzuhfsi3 */

    case 2:
      return 1025; /* fcvtzudf3 */

    case 3:
      if (!
#line 7171 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1033; /* fcvtzuhfdi3 */

    case 4:
      if (!
#line 7191 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1039; /* fcvtzuhf3 */

    case 5:
      if (!(
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2618; /* fcvtzuv4hf3 */

    case 6:
      if (!(
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2620; /* fcvtzuv8hf3 */

    case 7:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2622; /* fcvtzuv2sf3 */

    case 8:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2624; /* fcvtzuv4sf3 */

    case 9:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2626; /* fcvtzuv2df3 */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12070; /* aarch64_sve_umullbvnx8hi */

    case 1:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12091; /* aarch64_sve_umullbvnx4si */

    case 2:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12112; /* aarch64_sve_umullbvnx2di */

    case 3:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12120; /* aarch64_sve_umullb_lane_vnx4si */

    case 4:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12126; /* aarch64_sve_umullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12866; /* aarch64_sve_bextvnx16qi */

    case 1:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12869; /* aarch64_sve_bextvnx8hi */

    case 2:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12872; /* aarch64_sve_bextvnx4si */

    case 3:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12875; /* aarch64_sve_bextvnx2di */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern117 (x1))
    {
    case 0:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12699; /* aarch64_pred_reduc_andqv_vnx16qi */

    case 1:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12707; /* aarch64_pred_reduc_andqv_vnx8hi */

    case 2:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12715; /* aarch64_pred_reduc_andqv_vnx4si */

    case 3:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12723; /* aarch64_pred_reduc_andqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8QImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4634; /* aarch64_ld1_x3_v8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4635; /* aarch64_ld1_x3_v4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4636; /* aarch64_ld1_x3_v2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4637; /* aarch64_ld1_x3_di */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4638; /* aarch64_ld1_x3_v4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4639; /* aarch64_ld1_x3_v2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4640; /* aarch64_ld1_x3_df */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4BFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4641; /* aarch64_ld1_x3_v4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x16QImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4642; /* aarch64_ld1_x3_v16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4643; /* aarch64_ld1_x3_v8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4644; /* aarch64_ld1_x3_v4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DImode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4645; /* aarch64_ld1_x3_v2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4646; /* aarch64_ld1_x3_v8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4647; /* aarch64_ld1_x3_v4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4648; /* aarch64_ld1_x3_v2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8BFmode)
          || !
#line 7807 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4649; /* aarch64_ld1_x3_v8bf */

    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8QImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4650; /* aarch64_ld1_x4_v8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4651; /* aarch64_ld1_x4_v4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4652; /* aarch64_ld1_x4_v2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4653; /* aarch64_ld1_x4_di */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4654; /* aarch64_ld1_x4_v4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4655; /* aarch64_ld1_x4_v2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4656; /* aarch64_ld1_x4_df */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4BFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4657; /* aarch64_ld1_x4_v4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x16QImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4658; /* aarch64_ld1_x4_v16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4659; /* aarch64_ld1_x4_v8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4660; /* aarch64_ld1_x4_v4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DImode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4661; /* aarch64_ld1_x4_v2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4662; /* aarch64_ld1_x4_v8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4663; /* aarch64_ld1_x4_v4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4664; /* aarch64_ld1_x4_v2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8BFmode)
          || !
#line 7827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4665; /* aarch64_ld1_x4_v8bf */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V8QImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4715; /* aarch64_be_ld1v8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V16QImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4716; /* aarch64_be_ld1v16qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4HImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4717; /* aarch64_be_ld1v4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V8HImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4718; /* aarch64_be_ld1v8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2SImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4719; /* aarch64_be_ld1v2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4SImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4720; /* aarch64_be_ld1v4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2DImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4721; /* aarch64_be_ld1v2di */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4HFmode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4722; /* aarch64_be_ld1v4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8HFmode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4723; /* aarch64_be_ld1v8hf */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4BFmode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4724; /* aarch64_be_ld1v4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8BFmode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4725; /* aarch64_be_ld1v8bf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2SFmode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4726; /* aarch64_be_ld1v2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4SFmode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4727; /* aarch64_be_ld1v4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2DFmode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4728; /* aarch64_be_ld1v2df */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !aarch64_simd_struct_operand (operands[1], E_DImode)
          || !
#line 7907 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4729; /* aarch64_be_ld1di */

    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5131; /* aarch64_simd_ld1v8qi_x2 */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5132; /* aarch64_simd_ld1v4hi_x2 */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5133; /* aarch64_simd_ld1v2si_x2 */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5134; /* aarch64_simd_ld1di_x2 */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5135; /* aarch64_simd_ld1v4hf_x2 */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5136; /* aarch64_simd_ld1v2sf_x2 */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5137; /* aarch64_simd_ld1df_x2 */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5138; /* aarch64_simd_ld1v4bf_x2 */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x16QImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5139; /* aarch64_simd_ld1v16qi_x2 */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5140; /* aarch64_simd_ld1v8hi_x2 */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5141; /* aarch64_simd_ld1v4si_x2 */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DImode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5142; /* aarch64_simd_ld1v2di_x2 */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5143; /* aarch64_simd_ld1v8hf_x2 */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5144; /* aarch64_simd_ld1v4sf_x2 */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5145; /* aarch64_simd_ld1v2df_x2 */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8BFmode)
          || !
#line 8628 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5146; /* aarch64_simd_ld1v8bf_x2 */

    default:
      return -1;
    }
}

 int
recog_210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11753; /* *cond_uqshlvnx16qi_2 */
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11761; /* *cond_uqshlvnx16qi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11769; /* *cond_uqshlvnx16qi_any */
}

 int
recog_217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11616; /* *cond_urshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11661; /* *cond_urshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11701; /* *cond_urshlvnx8hi_any */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11637; /* *cond_uhsubvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11678; /* *cond_uhsubvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11718; /* *cond_uhsubvnx2di_any */
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11610; /* *cond_srshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11656; /* *cond_srshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11696; /* *cond_srshlvnx8hi_any */
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11631; /* *cond_shsubvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11673; /* *cond_shsubvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11713; /* *cond_shsubvnx2di_any */
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1043 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8511; /* *cond_smaxvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8657; /* *cond_smaxvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8761; /* *cond_smaxvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8524; /* *cond_smaxvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8670; /* *cond_smaxvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8774; /* *cond_smaxvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8537; /* *cond_smaxvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8683; /* *cond_smaxvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8787; /* *cond_smaxvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8550; /* *cond_smaxvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8696; /* *cond_smaxvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8800; /* *cond_smaxvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8609; /* *cond_smaxvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8859; /* *cond_smaxvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8616; /* *cond_smaxvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8866; /* *cond_smaxvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8623; /* *cond_smaxvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8873; /* *cond_smaxvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8563; /* *cond_smaxvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8709; /* *cond_smaxvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8813; /* *cond_smaxvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8576; /* *cond_smaxvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8722; /* *cond_smaxvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8826; /* *cond_smaxvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8589; /* *cond_smaxvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8735; /* *cond_smaxvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8839; /* *cond_smaxvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8602; /* *cond_smaxvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8748; /* *cond_smaxvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8852; /* *cond_smaxvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8630; /* *cond_smaxvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8880; /* *cond_smaxvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8637; /* *cond_smaxvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8887; /* *cond_smaxvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8644; /* *cond_smaxvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8894; /* *cond_smaxvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1042 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8503; /* *cond_divvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8649; /* *cond_divvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8753; /* *cond_divvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8516; /* *cond_divvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8662; /* *cond_divvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8766; /* *cond_divvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8529; /* *cond_divvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8675; /* *cond_divvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8779; /* *cond_divvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8542; /* *cond_divvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8688; /* *cond_divvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8792; /* *cond_divvnx2df_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8555; /* *cond_divvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8701; /* *cond_divvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8805; /* *cond_divvnx8bf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8568; /* *cond_divvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8714; /* *cond_divvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8818; /* *cond_divvnx8hf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8581; /* *cond_divvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8727; /* *cond_divvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8831; /* *cond_divvnx4sf_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8594; /* *cond_divvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8740; /* *cond_divvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8844; /* *cond_divvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern466 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7452; /* *cond_ashlvnx16qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7622; /* *cond_ashlvnx16qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7792; /* *cond_ashlvnx16qi_any */

        case E_VNx8QImode:
          if (pattern466 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7469; /* *cond_ashlvnx8qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7639; /* *cond_ashlvnx8qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7809; /* *cond_ashlvnx8qi_any */

        case E_VNx4QImode:
          if (pattern466 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7486; /* *cond_ashlvnx4qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7656; /* *cond_ashlvnx4qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7826; /* *cond_ashlvnx4qi_any */

        case E_VNx2QImode:
          if (pattern466 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7503; /* *cond_ashlvnx2qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7673; /* *cond_ashlvnx2qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7843; /* *cond_ashlvnx2qi_any */

        case E_VNx8HImode:
          if (pattern466 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7520; /* *cond_ashlvnx8hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7690; /* *cond_ashlvnx8hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7860; /* *cond_ashlvnx8hi_any */

        case E_VNx4HImode:
          if (pattern466 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7537; /* *cond_ashlvnx4hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7707; /* *cond_ashlvnx4hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7877; /* *cond_ashlvnx4hi_any */

        case E_VNx2HImode:
          if (pattern466 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7554; /* *cond_ashlvnx2hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7724; /* *cond_ashlvnx2hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7894; /* *cond_ashlvnx2hi_any */

        case E_VNx4SImode:
          if (pattern466 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7571; /* *cond_ashlvnx4si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7741; /* *cond_ashlvnx4si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7911; /* *cond_ashlvnx4si_any */

        case E_VNx2SImode:
          if (pattern466 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7588; /* *cond_ashlvnx2si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7758; /* *cond_ashlvnx2si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7928; /* *cond_ashlvnx2si_any */

        case E_VNx2DImode:
          if (pattern466 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7605; /* *cond_ashlvnx2di_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7775; /* *cond_ashlvnx2di_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7945; /* *cond_ashlvnx2di_any */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern984 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8261; /* *cond_ashlvnx16qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8291; /* *cond_ashlvnx16qi_any_const */

        case E_VNx8QImode:
          if (pattern984 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8264; /* *cond_ashlvnx8qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8294; /* *cond_ashlvnx8qi_any_const */

        case E_VNx4QImode:
          if (pattern984 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8267; /* *cond_ashlvnx4qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8297; /* *cond_ashlvnx4qi_any_const */

        case E_VNx2QImode:
          if (pattern984 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8270; /* *cond_ashlvnx2qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8300; /* *cond_ashlvnx2qi_any_const */

        case E_VNx8HImode:
          if (pattern984 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8273; /* *cond_ashlvnx8hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8303; /* *cond_ashlvnx8hi_any_const */

        case E_VNx4HImode:
          if (pattern984 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8276; /* *cond_ashlvnx4hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8306; /* *cond_ashlvnx4hi_any_const */

        case E_VNx2HImode:
          if (pattern984 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8279; /* *cond_ashlvnx2hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8309; /* *cond_ashlvnx2hi_any_const */

        case E_VNx4SImode:
          if (pattern984 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8282; /* *cond_ashlvnx4si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8312; /* *cond_ashlvnx4si_any_const */

        case E_VNx2SImode:
          if (pattern984 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8285; /* *cond_ashlvnx2si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8315; /* *cond_ashlvnx2si_any_const */

        case E_VNx2DImode:
          if (pattern984 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8288; /* *cond_ashlvnx2di_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8318; /* *cond_ashlvnx2di_any_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x4, 1))
        {
        case 315:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1041 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6951; /* cond_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern1041 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6954; /* cond_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern1041 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6957; /* cond_revbvnx4si */

            case E_VNx2DImode:
              if (pattern1041 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6960; /* cond_revbvnx2di */

            default:
              return -1;
            }

        case 317:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1041 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6952; /* cond_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern1041 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6955; /* cond_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern1041 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6958; /* cond_revhvnx4si */

            case E_VNx2DImode:
              if (pattern1041 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6961; /* cond_revhvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1041 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6953; /* cond_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern1041 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6956; /* cond_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern1041 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6959; /* cond_revwvnx4si */

            case E_VNx2DImode:
              if (pattern1041 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6962; /* cond_revwvnx2di */

            default:
              return -1;
            }

        case 316:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1103 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12753; /* cond_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern1103 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12754; /* cond_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern1103 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12755; /* cond_revdvnx4si */

            case E_VNx2DImode:
              if (pattern1103 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12756; /* cond_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern1103 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12757; /* cond_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern1103 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12758; /* cond_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern1103 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12759; /* cond_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern1103 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12760; /* cond_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      return recog_268 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 320:
          switch (pattern859 (x2))
            {
            case 0:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8105; /* *cond_smulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8107; /* *cond_smulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8109; /* *cond_smulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8111; /* *cond_smulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8113; /* *cond_smulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8115; /* *cond_smulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8117; /* *cond_smulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8119; /* *cond_smulhvnx2di_z */

            default:
              return -1;
            }

        case 321:
          switch (pattern859 (x2))
            {
            case 0:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8106; /* *cond_umulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8108; /* *cond_umulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8110; /* *cond_umulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8112; /* *cond_umulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8114; /* *cond_umulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8116; /* *cond_umulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8118; /* *cond_umulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8120; /* *cond_umulhvnx2di_z */

            default:
              return -1;
            }

        case 399:
          switch (pattern862 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8330; /* *cond_lslvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8333; /* *cond_lslvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8336; /* *cond_lslvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8339; /* *cond_lslvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8342; /* *cond_lslvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8345; /* *cond_lslvnx4si_z */

            default:
              return -1;
            }

        case 400:
          switch (pattern862 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8331; /* *cond_asrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8334; /* *cond_asrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8337; /* *cond_asrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8340; /* *cond_asrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8343; /* *cond_asrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8346; /* *cond_asrvnx4si_z */

            default:
              return -1;
            }

        case 401:
          switch (pattern862 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8332; /* *cond_lsrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8335; /* *cond_lsrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8338; /* *cond_lsrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8341; /* *cond_lsrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8344; /* *cond_lsrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8347; /* *cond_lsrvnx4si_z */

            default:
              return -1;
            }

        case 125:
          return recog_252 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 4:
      return recog_267 (x1, insn, pnum_clobbers);

    case 5:
      return recog_266 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern595 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6709; /* *cond_qabsvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6799; /* *cond_qabsvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6718; /* *cond_qabsvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6808; /* *cond_qabsvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6727; /* *cond_qabsvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6817; /* *cond_qabsvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6736; /* *cond_qabsvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6826; /* *cond_qabsvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6745; /* *cond_qabsvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6835; /* *cond_qabsvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6754; /* *cond_qabsvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6844; /* *cond_qabsvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6763; /* *cond_qabsvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6853; /* *cond_qabsvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6772; /* *cond_qabsvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6862; /* *cond_qabsvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6781; /* *cond_qabsvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6871; /* *cond_qabsvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6790; /* *cond_qabsvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2743 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6880; /* *cond_qabsvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern786 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6280; /* maskstorevnx16qivnx16bi */

        case E_VNx8QImode:
          if (pattern786 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6281; /* maskstorevnx8qivnx8bi */

        case E_VNx4QImode:
          if (pattern786 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6282; /* maskstorevnx4qivnx4bi */

        case E_VNx2QImode:
          if (pattern786 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6283; /* maskstorevnx2qivnx2bi */

        case E_VNx8HImode:
          if (pattern786 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6284; /* maskstorevnx8hivnx8bi */

        case E_VNx4HImode:
          if (pattern786 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6285; /* maskstorevnx4hivnx4bi */

        case E_VNx2HImode:
          if (pattern786 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6286; /* maskstorevnx2hivnx2bi */

        case E_VNx4SImode:
          if (pattern786 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6287; /* maskstorevnx4sivnx4bi */

        case E_VNx2SImode:
          if (pattern786 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6288; /* maskstorevnx2sivnx2bi */

        case E_VNx2DImode:
          if (pattern786 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6289; /* maskstorevnx2divnx2bi */

        case E_VNx8HFmode:
          if (pattern786 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6290; /* maskstorevnx8hfvnx8bi */

        case E_VNx4HFmode:
          if (pattern786 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6291; /* maskstorevnx4hfvnx4bi */

        case E_VNx2HFmode:
          if (pattern786 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6292; /* maskstorevnx2hfvnx2bi */

        case E_VNx8BFmode:
          if (pattern786 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6293; /* maskstorevnx8bfvnx8bi */

        case E_VNx4BFmode:
          if (pattern786 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6294; /* maskstorevnx4bfvnx4bi */

        case E_VNx2BFmode:
          if (pattern786 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6295; /* maskstorevnx2bfvnx2bi */

        case E_VNx4SFmode:
          if (pattern786 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6296; /* maskstorevnx4sfvnx4bi */

        case E_VNx2SFmode:
          if (pattern786 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6297; /* maskstorevnx2sfvnx2bi */

        case E_VNx2DFmode:
          if (pattern786 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6298; /* maskstorevnx2dfvnx2bi */

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8QImode:
          if (pattern853 (x3, 
E_VNx8QImode, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2349 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6323; /* aarch64_store_truncvnx8qivnx8hi */

        case E_VNx4QImode:
          if (pattern853 (x3, 
E_VNx4QImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6324; /* aarch64_store_truncvnx4qivnx4si */

        case E_VNx4HImode:
          if (pattern853 (x3, 
E_VNx4HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6325; /* aarch64_store_truncvnx4hivnx4si */

        case E_VNx2QImode:
          if (pattern853 (x3, 
E_VNx2QImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6326; /* aarch64_store_truncvnx2qivnx2di */

        case E_VNx2HImode:
          if (pattern853 (x3, 
E_VNx2HImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6327; /* aarch64_store_truncvnx2hivnx2di */

        case E_VNx2SImode:
          if (pattern853 (x3, 
E_VNx2SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6328; /* aarch64_store_truncvnx2sivnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3512; /* aarch64_sqrdmlshv4hi */

    case 1:
      if (!
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3516; /* aarch64_sqrdmlshv8hi */

    case 2:
      if (!
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3520; /* aarch64_sqrdmlshv2si */

    case 3:
      if (!
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3524; /* aarch64_sqrdmlshv4si */

    case 4:
      if (!
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3526; /* aarch64_sqrdmlshhi */

    case 5:
      if (!
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3528; /* aarch64_sqrdmlshsi */

    case 6:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11809; /* aarch64_sve_sqrdmlshvnx16qi */

    case 7:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11817; /* aarch64_sve_sqrdmlshvnx8hi */

    case 8:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11825; /* aarch64_sve_sqrdmlshvnx4si */

    case 9:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11833; /* aarch64_sve_sqrdmlshvnx2di */

    case 10:
      if (!
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3532; /* aarch64_sqrdmlsh_lanev4hi */

    case 11:
      if (!
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3552; /* aarch64_sqrdmlsh_laneqv4hi */

    case 12:
      if (!
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3536; /* aarch64_sqrdmlsh_lanev8hi */

    case 13:
      if (!
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3556; /* aarch64_sqrdmlsh_laneqv8hi */

    case 14:
      if (!
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3540; /* aarch64_sqrdmlsh_lanev2si */

    case 15:
      if (!
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3560; /* aarch64_sqrdmlsh_laneqv2si */

    case 16:
      if (!
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3544; /* aarch64_sqrdmlsh_lanev4si */

    case 17:
      if (!
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3564; /* aarch64_sqrdmlsh_laneqv4si */

    case 18:
      if (!
#line 5478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3546; /* aarch64_sqrdmlsh_lanehi */

    case 19:
      if (!
#line 5516 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3566; /* aarch64_sqrdmlsh_laneqhi */

    case 20:
      if (!
#line 5478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3548; /* aarch64_sqrdmlsh_lanesi */

    case 21:
      if (!
#line 5516 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3568; /* aarch64_sqrdmlsh_laneqsi */

    case 22:
      if (!
#line 1467 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11835; /* aarch64_sve_sqrdmlsh_lane_vnx8hi */

    case 23:
      if (!
#line 1467 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11837; /* aarch64_sve_sqrdmlsh_lane_vnx4si */

    case 24:
      if (!
#line 1467 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11839; /* aarch64_sve_sqrdmlsh_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9944; /* while_ulesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9954; /* while_uledivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9964; /* while_ulesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9974; /* while_uledivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9984; /* while_ulesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9994; /* while_uledivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 10004; /* while_ulesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10014; /* while_uledivnx2bi */

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern180 (x1))
    {
    case 0:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11239; /* aarch64_stnt1vnx32qi */

    case 1:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11241; /* aarch64_stnt1vnx16hi */

    case 2:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11243; /* aarch64_stnt1vnx8si */

    case 3:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11245; /* aarch64_stnt1vnx4di */

    case 4:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11247; /* aarch64_stnt1vnx16bf */

    case 5:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11249; /* aarch64_stnt1vnx16hf */

    case 6:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11251; /* aarch64_stnt1vnx8sf */

    case 7:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11253; /* aarch64_stnt1vnx4df */

    case 8:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11255; /* aarch64_stnt1vnx64qi */

    case 9:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11257; /* aarch64_stnt1vnx32hi */

    case 10:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11259; /* aarch64_stnt1vnx16si */

    case 11:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11261; /* aarch64_stnt1vnx8di */

    case 12:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11263; /* aarch64_stnt1vnx32bf */

    case 13:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11265; /* aarch64_stnt1vnx32hf */

    case 14:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11267; /* aarch64_stnt1vnx16sf */

    case 15:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11269; /* aarch64_stnt1vnx8df */

    default:
      return -1;
    }
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10298; /* fold_extract_after_last_vnx16qi */

    case 1:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10300; /* fold_extract_after_last_vnx8hi */

    case 2:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10302; /* fold_extract_after_last_vnx4si */

    case 3:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10304; /* fold_extract_after_last_vnx2di */

    case 4:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10306; /* fold_extract_after_last_vnx8bf */

    case 5:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10308; /* fold_extract_after_last_vnx8hf */

    case 6:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10310; /* fold_extract_after_last_vnx4sf */

    case 7:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10312; /* fold_extract_after_last_vnx2df */

    case 8:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10314; /* aarch64_fold_extract_vector_after_last_vnx16qi */

    case 9:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10316; /* aarch64_fold_extract_vector_after_last_vnx8hi */

    case 10:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10318; /* aarch64_fold_extract_vector_after_last_vnx4si */

    case 11:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10320; /* aarch64_fold_extract_vector_after_last_vnx2di */

    case 12:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10322; /* aarch64_fold_extract_vector_after_last_vnx8bf */

    case 13:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10324; /* aarch64_fold_extract_vector_after_last_vnx8hf */

    case 14:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10326; /* aarch64_fold_extract_vector_after_last_vnx4sf */

    case 15:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10328; /* aarch64_fold_extract_vector_after_last_vnx2df */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3824; /* aarch64_usri_nv8qi */

    case 1:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3828; /* aarch64_usri_nv16qi */

    case 2:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3832; /* aarch64_usri_nv4hi */

    case 3:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3836; /* aarch64_usri_nv8hi */

    case 4:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3840; /* aarch64_usri_nv2si */

    case 5:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3844; /* aarch64_usri_nv4si */

    case 6:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3848; /* aarch64_usri_nv2di */

    case 7:
      if (!
#line 6456 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3852; /* aarch64_usri_ndi */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern55 (x3, 
E_VNx8HFmode) != 0
          || !
#line 7935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9398; /* aarch64_sve_tmadvnx8hf */

    case E_VNx4SFmode:
      if (pattern55 (x3, 
E_VNx4SFmode) != 0
          || !
#line 7935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9399; /* aarch64_sve_tmadvnx4sf */

    case E_VNx2DFmode:
      if (pattern55 (x3, 
E_VNx2DFmode) != 0
          || !
#line 7935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9400; /* aarch64_sve_tmadvnx2df */

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern193 (x1))
    {
    case 0:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12492; /* aarch64_sve_cmlavnx16qi */

    case 1:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12500; /* aarch64_sve_cmlavnx8hi */

    case 2:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12508; /* aarch64_sve_cmlavnx4si */

    case 3:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12516; /* aarch64_sve_cmlavnx2di */

    case 4:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12524; /* aarch64_cmla_lane_vnx8hi */

    case 5:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12532; /* aarch64_cmla_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern195 (x1))
    {
    case 0:
      if (!
#line 3095 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12540; /* aarch64_sve_cdotvnx4si */

    case 1:
      if (!
#line 3095 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12544; /* aarch64_sve_cdotvnx2di */

    case 2:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12548; /* aarch64_cdot_lane_vnx4si */

    case 3:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12552; /* aarch64_cdot_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern183 (x1))
    {
    case 0:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11805; /* aarch64_sve_eortbvnx16qi */

    case 1:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11813; /* aarch64_sve_eortbvnx8hi */

    case 2:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11821; /* aarch64_sve_eortbvnx4si */

    case 3:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11829; /* aarch64_sve_eortbvnx2di */

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern177 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 8))
        return -1;
      *pnum_clobbers = 1;
      return 10932; /* aarch64_sve_pfirstvnx16bi */

    case 1:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
        return -1;
      *pnum_clobbers = 1;
      return 10934; /* aarch64_sve_pfirstvnx8bi */

    case 2:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
        return -1;
      *pnum_clobbers = 1;
      return 10936; /* aarch64_sve_pfirstvnx4bi */

    case 3:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
        return -1;
      *pnum_clobbers = 1;
      return 10938; /* aarch64_sve_pfirstvnx2bi */

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (XVECLEN (x3, 0) != 3)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 126:
      x5 = XVECEXP (x2, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x3, 0, 0);
      operands[6] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[7] = x8;
      if (!aarch64_sve_ptrue_flag (operands[7], E_SImode))
        return -1;
      x9 = XVECEXP (x3, 0, 2);
      switch (GET_CODE (x9))
        {
        case LT:
          switch (pattern1301 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9652; /* *cmpltvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9662; /* *cmpltvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9692; /* *cmpltvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9672; /* *cmpltvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9702; /* *cmpltvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9722; /* *cmpltvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9682; /* *cmpltvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9712; /* *cmpltvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9732; /* *cmpltvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9742; /* *cmpltvnx2di_ptest */

            default:
              return -1;
            }

        case LE:
          switch (pattern1301 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9653; /* *cmplevnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9663; /* *cmplevnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9693; /* *cmplevnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9673; /* *cmplevnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9703; /* *cmplevnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9723; /* *cmplevnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9683; /* *cmplevnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9713; /* *cmplevnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9733; /* *cmplevnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9743; /* *cmplevnx2di_ptest */

            default:
              return -1;
            }

        case EQ:
          switch (pattern1301 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9654; /* *cmpeqvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9664; /* *cmpeqvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9694; /* *cmpeqvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9674; /* *cmpeqvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9704; /* *cmpeqvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9724; /* *cmpeqvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9684; /* *cmpeqvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9714; /* *cmpeqvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9734; /* *cmpeqvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9744; /* *cmpeqvnx2di_ptest */

            default:
              return -1;
            }

        case NE:
          switch (pattern1301 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9655; /* *cmpnevnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9665; /* *cmpnevnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9695; /* *cmpnevnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9675; /* *cmpnevnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9705; /* *cmpnevnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9725; /* *cmpnevnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9685; /* *cmpnevnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9715; /* *cmpnevnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9735; /* *cmpnevnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9745; /* *cmpnevnx2di_ptest */

            default:
              return -1;
            }

        case GE:
          switch (pattern1301 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9656; /* *cmpgevnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9666; /* *cmpgevnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9696; /* *cmpgevnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9676; /* *cmpgevnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9706; /* *cmpgevnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9726; /* *cmpgevnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9686; /* *cmpgevnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9716; /* *cmpgevnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9736; /* *cmpgevnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9746; /* *cmpgevnx2di_ptest */

            default:
              return -1;
            }

        case GT:
          switch (pattern1301 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9657; /* *cmpgtvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9667; /* *cmpgtvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9697; /* *cmpgtvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9677; /* *cmpgtvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9707; /* *cmpgtvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9727; /* *cmpgtvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9687; /* *cmpgtvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9717; /* *cmpgtvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9737; /* *cmpgtvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9747; /* *cmpgtvnx2di_ptest */

            default:
              return -1;
            }

        case LTU:
          switch (pattern1302 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9658; /* *cmplovnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9668; /* *cmplovnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9698; /* *cmplovnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9678; /* *cmplovnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9708; /* *cmplovnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9728; /* *cmplovnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9688; /* *cmplovnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9718; /* *cmplovnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9738; /* *cmplovnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9748; /* *cmplovnx2di_ptest */

            default:
              return -1;
            }

        case LEU:
          switch (pattern1302 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9659; /* *cmplsvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9669; /* *cmplsvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9699; /* *cmplsvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9679; /* *cmplsvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9709; /* *cmplsvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9729; /* *cmplsvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9689; /* *cmplsvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9719; /* *cmplsvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9739; /* *cmplsvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9749; /* *cmplsvnx2di_ptest */

            default:
              return -1;
            }

        case GEU:
          switch (pattern1302 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9660; /* *cmphsvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9670; /* *cmphsvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9700; /* *cmphsvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9680; /* *cmphsvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9710; /* *cmphsvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9730; /* *cmphsvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9690; /* *cmphsvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9720; /* *cmphsvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9740; /* *cmphsvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9750; /* *cmphsvnx2di_ptest */

            default:
              return -1;
            }

        case GTU:
          switch (pattern1302 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9661; /* *cmphivnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9671; /* *cmphivnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9701; /* *cmphivnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9681; /* *cmphivnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9711; /* *cmphivnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9731; /* *cmphivnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9691; /* *cmphivnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9721; /* *cmphivnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9741; /* *cmphivnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9751; /* *cmphivnx2di_ptest */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x9, 0) != 2)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x9, 0, 1);
          operands[3] = x11;
          switch (XINT (x9, 1))
            {
            case 340:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9912; /* *aarch64_pred_cmpeqvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9922; /* *aarch64_pred_cmpeqvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9932; /* *aarch64_pred_cmpeqvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 341:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9913; /* *aarch64_pred_cmpgevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9923; /* *aarch64_pred_cmpgevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9933; /* *aarch64_pred_cmpgevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 342:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9914; /* *aarch64_pred_cmpgtvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9924; /* *aarch64_pred_cmpgtvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9934; /* *aarch64_pred_cmpgtvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 343:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9915; /* *aarch64_pred_cmphivnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9925; /* *aarch64_pred_cmphivnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9935; /* *aarch64_pred_cmphivnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 344:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9916; /* *aarch64_pred_cmphsvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9926; /* *aarch64_pred_cmphsvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9936; /* *aarch64_pred_cmphsvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 345:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9917; /* *aarch64_pred_cmplevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9927; /* *aarch64_pred_cmplevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9937; /* *aarch64_pred_cmplevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 346:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9918; /* *aarch64_pred_cmplovnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9928; /* *aarch64_pred_cmplovnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9938; /* *aarch64_pred_cmplovnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 347:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9919; /* *aarch64_pred_cmplsvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9929; /* *aarch64_pred_cmplsvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9939; /* *aarch64_pred_cmplsvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 348:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9920; /* *aarch64_pred_cmpltvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9930; /* *aarch64_pred_cmpltvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9940; /* *aarch64_pred_cmpltvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 349:
              switch (pattern1333 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9921; /* *aarch64_pred_cmpnevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9931; /* *aarch64_pred_cmpnevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9941; /* *aarch64_pred_cmpnevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 472:
              switch (pattern1334 (x3))
                {
                case 0:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12888; /* *aarch64_pred_matchvnx16qi_ptest */

                case 1:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12890; /* *aarch64_pred_matchvnx8hi_ptest */

                default:
                  return -1;
                }

            case 473:
              switch (pattern1334 (x3))
                {
                case 0:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12889; /* *aarch64_pred_nmatchvnx16qi_ptest */

                case 1:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12891; /* *aarch64_pred_nmatchvnx8hi_ptest */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 299:
      if (pattern1187 (x2) != 0
          || !
#line 10116 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10921; /* *aarch64_brka_ptest */

    case 300:
      if (pattern1187 (x2) != 0
          || !
#line 10116 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10922; /* *aarch64_brkb_ptest */

    case 302:
      if (pattern1188 (x2) != 0
          || !
#line 10247 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10930; /* *aarch64_brkpa_ptest */

    case 303:
      if (pattern1188 (x2) != 0
          || !
#line 10247 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10931; /* *aarch64_brkpb_ptest */

    case 304:
      switch (pattern1189 (x2))
        {
        case 0:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10948; /* *aarch64_sve_pfirstvnx16bi_ptest */

        case 1:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10950; /* *aarch64_sve_pfirstvnx8bi_ptest */

        case 2:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10952; /* *aarch64_sve_pfirstvnx4bi_ptest */

        case 3:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10954; /* *aarch64_sve_pfirstvnx2bi_ptest */

        default:
          return -1;
        }

    case 305:
      switch (pattern1189 (x2))
        {
        case 0:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10949; /* *aarch64_sve_pnextvnx16bi_ptest */

        case 1:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10951; /* *aarch64_sve_pnextvnx8bi_ptest */

        case 2:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10953; /* *aarch64_sve_pnextvnx4bi_ptest */

        case 3:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10955; /* *aarch64_sve_pnextvnx2bi_ptest */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 265; /* *subsi3_uxtw */

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode
              || !register_operand (x5, E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              return 292; /* *sub_lsl_si_uxtw */

            case SIGN_EXTEND:
              switch (pattern986 (x4))
                {
                case 0:
                  return 323; /* *sub_extendqi_shft_si_uxtw */

                case 1:
                  return 325; /* *sub_extendhi_shft_si_uxtw */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern986 (x4))
                {
                case 0:
                  return 324; /* *sub_zero_extendqi_shft_si_uxtw */

                case 1:
                  return 326; /* *sub_zero_extendhi_shft_si_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern791 (x4) != 0)
            return -1;
          return 293; /* *sub_asr_si_uxtw */

        case LSHIFTRT:
          if (pattern791 (x4) != 0)
            return -1;
          return 294; /* *sub_lsr_si_uxtw */

        case SIGN_EXTEND:
          switch (pattern792 (x4))
            {
            case 0:
              return 307; /* *sub_extendqi_si_uxtw */

            case 1:
              return 309; /* *sub_extendhi_si_uxtw */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern792 (x4))
            {
            case 0:
              return 308; /* *sub_zero_extendqi_si_uxtw */

            case 1:
              return 310; /* *sub_zero_extendhi_si_uxtw */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[2] = x6;
          if (!aarch64_borrow_operation (operands[2], E_SImode))
            return -1;
          operands[1] = x5;
          if (!aarch64_reg_or_zero (operands[1], E_SImode))
            return -1;
          return 329; /* *subsi3_carryin_uxtw */

        case AND:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_SImode)
            return -1;
          operands[4] = x5;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!aarch64_imm3 (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 3937 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]),INTVAL (operands[3])) != 0))
            return -1;
          return 348; /* *sub_uxtsi_shift2_uxtw */

        case MULT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 384; /* *msubsi_uxtw */

        default:
          return -1;
        }

    case MINUS:
      if (pattern369 (x3) != 0)
        return -1;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!aarch64_reg_or_zero (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!aarch64_borrow_operation (operands[3], E_SImode))
            return -1;
          return 332; /* *subsi3_carryin_uxtw */

        case GEU:
        case LTU:
          operands[3] = x12;
          if (!aarch64_borrow_operation (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 335; /* *subsi3_carryin_alt_uxtw */

        default:
          return -1;
        }

    case NEG:
      if (pattern369 (x3) != 0)
        return -1;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      if (!aarch64_borrow_operation (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 356; /* *ngcsi_uxtw */

    case SMAX:
      switch (pattern372 (x3, 
SMIN))
        {
        case 0:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1650; /* aarch64_sabdlv8qi */

        case 1:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1652; /* aarch64_sabdlv4hi */

        case 2:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1654; /* aarch64_sabdlv2si */

        case 3:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1656; /* aarch64_sabdl2v16qi_insn */

        case 4:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1658; /* aarch64_sabdl2v8hi_insn */

        case 5:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1660; /* aarch64_sabdl2v4si_insn */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern372 (x3, 
UMIN))
        {
        case 0:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1651; /* aarch64_uabdlv8qi */

        case 1:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1653; /* aarch64_uabdlv4hi */

        case 2:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1655; /* aarch64_uabdlv2si */

        case 3:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1657; /* aarch64_uabdl2v16qi_insn */

        case 4:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1659; /* aarch64_uabdl2v8hi_insn */

        case 5:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1661; /* aarch64_uabdl2v4si_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_457 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XINT (x3, 1))
    {
    case 406:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1403; /* aarch64_fcmla0v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1415; /* aarch64_fcmla0v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1419; /* aarch64_fcmla0v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1431; /* aarch64_fcmla0v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1435; /* aarch64_fcmla0v2df */

        default:
          return -1;
        }

    case 407:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1406; /* aarch64_fcmla90v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1416; /* aarch64_fcmla90v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1422; /* aarch64_fcmla90v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1432; /* aarch64_fcmla90v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1436; /* aarch64_fcmla90v2df */

        default:
          return -1;
        }

    case 408:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1409; /* aarch64_fcmla180v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1417; /* aarch64_fcmla180v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1425; /* aarch64_fcmla180v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1433; /* aarch64_fcmla180v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1437; /* aarch64_fcmla180v2df */

        default:
          return -1;
        }

    case 409:
      switch (pattern484 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1412; /* aarch64_fcmla270v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1418; /* aarch64_fcmla270v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1428; /* aarch64_fcmla270v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1434; /* aarch64_fcmla270v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1438; /* aarch64_fcmla270v2df */

        default:
          return -1;
        }

    case 278:
      switch (pattern487 (x2))
        {
        case 0:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1495; /* sdot_prodv2siv8qi */

        case 1:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1501; /* sdot_prodv4siv16qi */

        case 2:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9200; /* sdot_prodvnx4sivnx16qi */

        case 3:
          if (!
#line 2482 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12218; /* sdot_prodvnx4sivnx8hi */

        case 4:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9202; /* sdot_prodvnx2divnx8hi */

        case 5:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 8 == 16))))
            return -1;
          return 9204; /* aarch64_sdot_prod_lanevnx4sivnx16qi */

        case 6:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 16 == 16))))
            return -1;
          return 9208; /* aarch64_sdot_prod_lanevnx4sivnx8hi */

        case 7:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 8 == 16))))
            return -1;
          return 9206; /* aarch64_sdot_prod_lanevnx2divnx16qi */

        case 8:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 16 == 16))))
            return -1;
          return 9210; /* aarch64_sdot_prod_lanevnx2divnx8hi */

        default:
          return -1;
        }

    case 279:
      switch (pattern487 (x2))
        {
        case 0:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1498; /* udot_prodv2siv8qi */

        case 1:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1502; /* udot_prodv4siv16qi */

        case 2:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9201; /* udot_prodvnx4sivnx16qi */

        case 3:
          if (!
#line 2482 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12219; /* udot_prodvnx4sivnx8hi */

        case 4:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9203; /* udot_prodvnx2divnx8hi */

        case 5:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 8 == 16))))
            return -1;
          return 9205; /* aarch64_udot_prod_lanevnx4sivnx16qi */

        case 6:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 16 == 16))))
            return -1;
          return 9209; /* aarch64_udot_prod_lanevnx4sivnx8hi */

        case 7:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 8 == 16))))
            return -1;
          return 9207; /* aarch64_udot_prod_lanevnx2divnx16qi */

        case 8:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 16 == 16))))
            return -1;
          return 9211; /* aarch64_udot_prod_lanevnx2divnx8hi */

        default:
          return -1;
        }

    case 572:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern485 (x2, 
E_V2SImode, 
E_V8QImode) != 0
                  || !
#line 591 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1503; /* usdot_prodv2siv8qi */

            case E_V4SImode:
              if (pattern485 (x2, 
E_V4SImode, 
E_V16QImode) != 0
                  || !
#line 591 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1506; /* usdot_prodv4siv16qi */

            case E_VNx4SImode:
              if (pattern485 (x2, 
E_VNx4SImode, 
E_VNx16QImode) != 0
                  || !
#line 7341 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM))
                return -1;
              return 9212; /* usdot_prodvnx4sivnx16qi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167
              || GET_MODE (x5) != E_VNx16QImode
              || !register_operand (operands[0], E_VNx4SImode)
              || GET_MODE (x2) != E_VNx4SImode
              || GET_MODE (x3) != E_VNx4SImode
              || pattern1118 (x2) != 0
              || !
#line 7359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM))
            return -1;
          return 9213; /* aarch64_usdot_prod_lanevnx4sivnx16qi */

        default:
          return -1;
        }

    case 578:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (pattern488 (x2, 
E_V2SFmode, 
E_V4BFmode) != 0
              || !
#line 9697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
            return -1;
          return 5250; /* aarch64_bfdotv2sf */

        case E_V4SFmode:
          if (pattern488 (x2, 
E_V4SFmode, 
E_V8BFmode) != 0
              || !
#line 9697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
            return -1;
          return 5251; /* aarch64_bfdotv4sf */

        default:
          return -1;
        }

    case 329:
      switch (pattern489 (x2))
        {
        case 0:
          if (!
#line 9767 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
            return -1;
          return 5263; /* aarch64_simd_smmlav16qi */

        case 1:
          if (!
#line 7414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM && TARGET_NON_STREAMING))
            return -1;
          return 9215; /* aarch64_sve_add_smatmulvnx16qi */

        default:
          return -1;
        }

    case 331:
      switch (pattern489 (x2))
        {
        case 0:
          if (!
#line 9767 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
            return -1;
          return 5264; /* aarch64_simd_ummlav16qi */

        case 1:
          if (!
#line 7414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM && TARGET_NON_STREAMING))
            return -1;
          return 9216; /* aarch64_sve_add_umatmulvnx16qi */

        default:
          return -1;
        }

    case 332:
      switch (pattern489 (x2))
        {
        case 0:
          if (!
#line 9767 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
            return -1;
          return 5265; /* aarch64_simd_usmmlav16qi */

        case 1:
          if (!
#line 7414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM && TARGET_NON_STREAMING))
            return -1;
          return 9217; /* aarch64_sve_add_usmatmulvnx16qi */

        default:
          return -1;
        }

    case 125:
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case ASHIFT:
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (pattern796 (x2))
            {
            case 0:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7980; /* *aarch64_adrvnx2qi_shift */

            case 1:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7981; /* *aarch64_adrvnx2hi_shift */

            case 2:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7982; /* *aarch64_adrvnx2si_shift */

            case 3:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7983; /* *aarch64_adrvnx2di_shift */

            case 4:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7984; /* *aarch64_adrvnx4qi_shift */

            case 5:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7985; /* *aarch64_adrvnx4hi_shift */

            case 6:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7986; /* *aarch64_adrvnx4si_shift */

            case 7:
              if (!
#line 4232 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7987; /* *aarch64_adr_shift_sxtw */

            case 8:
              if (!
#line 4253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7988; /* *aarch64_adr_shift_uxtw */

            default:
              return -1;
            }

        case MULT:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x6 = XEXP (x2, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern988 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9120; /* aarch64_pred_fmavnx16qi */

            case E_VNx8QImode:
              if (pattern988 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9121; /* aarch64_pred_fmavnx8qi */

            case E_VNx4QImode:
              if (pattern988 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9122; /* aarch64_pred_fmavnx4qi */

            case E_VNx2QImode:
              if (pattern988 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9123; /* aarch64_pred_fmavnx2qi */

            case E_VNx8HImode:
              if (pattern988 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9124; /* aarch64_pred_fmavnx8hi */

            case E_VNx4HImode:
              if (pattern988 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9125; /* aarch64_pred_fmavnx4hi */

            case E_VNx2HImode:
              if (pattern988 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9126; /* aarch64_pred_fmavnx2hi */

            case E_VNx4SImode:
              if (pattern988 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9127; /* aarch64_pred_fmavnx4si */

            case E_VNx2SImode:
              if (pattern988 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9128; /* aarch64_pred_fmavnx2si */

            case E_VNx2DImode:
              if (pattern988 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9129; /* aarch64_pred_fmavnx2di */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern619 (x2))
            {
            case 0:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11969; /* *aarch64_sve2_sravnx16qi */

            case 1:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11971; /* *aarch64_sve2_sravnx8hi */

            case 2:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11973; /* *aarch64_sve2_sravnx4si */

            case 3:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11975; /* *aarch64_sve2_sravnx2di */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern619 (x2))
            {
            case 0:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11970; /* *aarch64_sve2_sravnx16qi */

            case 1:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11972; /* *aarch64_sve2_sravnx8hi */

            case 2:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11974; /* *aarch64_sve2_sravnx4si */

            case 3:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11976; /* *aarch64_sve2_sravnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 577:
      if (GET_MODE (x3) != E_VNx4SImode)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 167
          || GET_MODE (x5) != E_VNx16QImode
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (pattern1118 (x2) != 0
          || !
#line 7359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM))
        return -1;
      return 9214; /* aarch64_sudot_prod_lanevnx4sivnx16qi */

    case 223:
      switch (pattern491 (x2))
        {
        case 0:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11977; /* aarch64_sve_add_srshrvnx16qi */

        case 1:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11979; /* aarch64_sve_add_srshrvnx8hi */

        case 2:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11981; /* aarch64_sve_add_srshrvnx4si */

        case 3:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11983; /* aarch64_sve_add_srshrvnx2di */

        default:
          return -1;
        }

    case 224:
      switch (pattern491 (x2))
        {
        case 0:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11978; /* aarch64_sve_add_urshrvnx16qi */

        case 1:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11980; /* aarch64_sve_add_urshrvnx8hi */

        case 2:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11982; /* aarch64_sve_add_urshrvnx4si */

        case 3:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11984; /* aarch64_sve_add_urshrvnx2di */

        default:
          return -1;
        }

    case 488:
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12140; /* aarch64_sve_add_sabdlbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12148; /* aarch64_sve_add_sabdlbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12156; /* aarch64_sve_add_sabdlbvnx2di */

        default:
          return -1;
        }

    case 489:
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12141; /* aarch64_sve_add_sabdltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12149; /* aarch64_sve_add_sabdltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12157; /* aarch64_sve_add_sabdltvnx2di */

        default:
          return -1;
        }

    case 504:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12142; /* aarch64_sve_add_smullbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12150; /* aarch64_sve_add_smullbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12158; /* aarch64_sve_add_smullbvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12164; /* aarch64_sve_add_smullb_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12168; /* aarch64_sve_add_smullb_lane_vnx2di */

        default:
          return -1;
        }

    case 505:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12143; /* aarch64_sve_add_smulltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12151; /* aarch64_sve_add_smulltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12159; /* aarch64_sve_add_smulltvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12165; /* aarch64_sve_add_smullt_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12169; /* aarch64_sve_add_smullt_lane_vnx2di */

        default:
          return -1;
        }

    case 546:
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12144; /* aarch64_sve_add_uabdlbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12152; /* aarch64_sve_add_uabdlbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12160; /* aarch64_sve_add_uabdlbvnx2di */

        default:
          return -1;
        }

    case 547:
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12145; /* aarch64_sve_add_uabdltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12153; /* aarch64_sve_add_uabdltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12161; /* aarch64_sve_add_uabdltvnx2di */

        default:
          return -1;
        }

    case 556:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12146; /* aarch64_sve_add_umullbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12154; /* aarch64_sve_add_umullbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12162; /* aarch64_sve_add_umullbvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12166; /* aarch64_sve_add_umullb_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12170; /* aarch64_sve_add_umullb_lane_vnx2di */

        default:
          return -1;
        }

    case 557:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12147; /* aarch64_sve_add_umulltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12155; /* aarch64_sve_add_umulltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12163; /* aarch64_sve_add_umulltvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12167; /* aarch64_sve_add_umullt_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12171; /* aarch64_sve_add_umullt_lane_vnx2di */

        default:
          return -1;
        }

    case 605:
      if (GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx8HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!register_operand (x6, E_VNx4SFmode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (!register_operand (operands[2], E_VNx8HFmode))
            return -1;
          operands[3] = x6;
          if (!
#line 2580 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12292; /* aarch64_sve_fdotvnx4sfvnx8hf */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167
              || GET_MODE (x5) != E_VNx8HFmode)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_VNx8HFmode))
            return -1;
          x10 = XVECEXP (x5, 0, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          operands[4] = x6;
          if (!
#line 2598 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12293; /* aarch64_fdot_prod_lanevnx4sfvnx8hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_475 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !aarch64_mov_operand (operands[1], E_QImode)
          || !
#line 1514 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], QImode)
    || aarch64_reg_or_zero (operands[1], QImode))))
        return -1;
      return 67; /* *movqi_aarch64 */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !aarch64_mov_operand (operands[1], E_HImode)
          || !
#line 1514 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], HImode)
    || aarch64_reg_or_zero (operands[1], HImode))))
        return -1;
      return 68; /* *movhi_aarch64 */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !aarch64_mov_operand (operands[1], E_SImode)
          || !
#line 1575 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], SImode)
    || aarch64_reg_or_zero (operands[1], SImode))))
        return -1;
      return 69; /* *movsi_aarch64 */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !aarch64_mov_operand (operands[1], E_DImode)
          || !
#line 1613 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], DImode)
    || aarch64_reg_or_zero (operands[1], DImode))))
        return -1;
      return 70; /* *movdi_aarch64 */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !general_operand (operands[1], E_HFmode)
          || !
#line 1789 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], HFmode)))
        return -1;
      return 76; /* *movhf_aarch64 */

    case E_BFmode:
      if (!nonimmediate_operand (operands[0], E_BFmode)
          || !general_operand (operands[1], E_BFmode)
          || !
#line 1789 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], BFmode)))
        return -1;
      return 77; /* *movbf_aarch64 */

    case E_SDmode:
      if (!nonimmediate_operand (operands[0], E_SDmode)
          || !general_operand (operands[1], E_SDmode)
          || !
#line 1812 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], SDmode)))
        return -1;
      return 78; /* *movsd_aarch64 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 1812 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], SFmode)))
        return -1;
      return 79; /* *movsf_aarch64 */

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !general_operand (operands[1], E_DDmode)
          || !
#line 1832 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], DDmode)))
        return -1;
      return 80; /* *movdd_aarch64 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 1832 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], DFmode)))
        return -1;
      return 81; /* *movdf_aarch64 */

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !general_operand (operands[1], E_TDmode)
          || !
#line 1854 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (register_operand (operands[0], TDmode)
    || aarch64_reg_or_fp_zero (operands[1], TDmode))))
        return -1;
      return 82; /* *movtd_aarch64 */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode)
          || !
#line 1854 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (register_operand (operands[0], TFmode)
    || aarch64_reg_or_fp_zero (operands[1], TFmode))))
        return -1;
      return 83; /* *movtf_aarch64 */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8QImode)
       || aarch64_simd_reg_or_zero (operands[1], V8QImode))))
        return -1;
      return 1268; /* *aarch64_simd_movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4HImode)
       || aarch64_simd_reg_or_zero (operands[1], V4HImode))))
        return -1;
      return 1269; /* *aarch64_simd_movv4hi */

    case E_V4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !general_operand (operands[1], E_V4HFmode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4HFmode)
       || aarch64_simd_reg_or_zero (operands[1], V4HFmode))))
        return -1;
      return 1270; /* *aarch64_simd_movv4hf */

    case E_V4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4BFmode)
          || !general_operand (operands[1], E_V4BFmode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4BFmode)
       || aarch64_simd_reg_or_zero (operands[1], V4BFmode))))
        return -1;
      return 1271; /* *aarch64_simd_movv4bf */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2SImode)
       || aarch64_simd_reg_or_zero (operands[1], V2SImode))))
        return -1;
      return 1272; /* *aarch64_simd_movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2SFmode)
       || aarch64_simd_reg_or_zero (operands[1], V2SFmode))))
        return -1;
      return 1273; /* *aarch64_simd_movv2sf */

    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V16QImode)
       || aarch64_simd_reg_or_zero (operands[1], V16QImode))))
        return -1;
      return 1274; /* *aarch64_simd_movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8HImode)
       || aarch64_simd_reg_or_zero (operands[1], V8HImode))))
        return -1;
      return 1275; /* *aarch64_simd_movv8hi */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4SImode)
       || aarch64_simd_reg_or_zero (operands[1], V4SImode))))
        return -1;
      return 1276; /* *aarch64_simd_movv4si */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2DImode)
       || aarch64_simd_reg_or_zero (operands[1], V2DImode))))
        return -1;
      return 1277; /* *aarch64_simd_movv2di */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !general_operand (operands[1], E_V8HFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8HFmode)
       || aarch64_simd_reg_or_zero (operands[1], V8HFmode))))
        return -1;
      return 1278; /* *aarch64_simd_movv8hf */

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !general_operand (operands[1], E_V8BFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8BFmode)
       || aarch64_simd_reg_or_zero (operands[1], V8BFmode))))
        return -1;
      return 1279; /* *aarch64_simd_movv8bf */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4SFmode)
       || aarch64_simd_reg_or_zero (operands[1], V4SFmode))))
        return -1;
      return 1280; /* *aarch64_simd_movv4sf */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2DFmode)
       || aarch64_simd_reg_or_zero (operands[1], V2DFmode))))
        return -1;
      return 1281; /* *aarch64_simd_movv2df */

    case E_V8DImode:
      if (!nonimmediate_operand (operands[0], E_V8DImode)
          || !general_operand (operands[1], E_V8DImode)
          || !
#line 7895 "../../gcc/config/aarch64/aarch64-simd.md"
((register_operand (operands[0], V8DImode)
    || register_operand (operands[1], V8DImode))))
        return -1;
      return 4714; /* *aarch64_movv8di */

    case E_V2x8QImode:
      if (!nonimmediate_operand (operands[0], E_V2x8QImode)
          || !general_operand (operands[1], E_V2x8QImode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8QImode)
       || register_operand (operands[1], V2x8QImode))))
        return -1;
      return 4745; /* *aarch64_movv2x8qi */

    case E_V2x4HImode:
      if (!nonimmediate_operand (operands[0], E_V2x4HImode)
          || !general_operand (operands[1], E_V2x4HImode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4HImode)
       || register_operand (operands[1], V2x4HImode))))
        return -1;
      return 4746; /* *aarch64_movv2x4hi */

    case E_V2x2SImode:
      if (!nonimmediate_operand (operands[0], E_V2x2SImode)
          || !general_operand (operands[1], E_V2x2SImode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2SImode)
       || register_operand (operands[1], V2x2SImode))))
        return -1;
      return 4747; /* *aarch64_movv2x2si */

    case E_V2x1DImode:
      if (!nonimmediate_operand (operands[0], E_V2x1DImode)
          || !general_operand (operands[1], E_V2x1DImode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x1DImode)
       || register_operand (operands[1], V2x1DImode))))
        return -1;
      return 4748; /* *aarch64_movv2x1di */

    case E_V2x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4HFmode)
          || !general_operand (operands[1], E_V2x4HFmode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4HFmode)
       || register_operand (operands[1], V2x4HFmode))))
        return -1;
      return 4749; /* *aarch64_movv2x4hf */

    case E_V2x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2x2SFmode)
          || !general_operand (operands[1], E_V2x2SFmode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2SFmode)
       || register_operand (operands[1], V2x2SFmode))))
        return -1;
      return 4750; /* *aarch64_movv2x2sf */

    case E_V2x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V2x1DFmode)
          || !general_operand (operands[1], E_V2x1DFmode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x1DFmode)
       || register_operand (operands[1], V2x1DFmode))))
        return -1;
      return 4751; /* *aarch64_movv2x1df */

    case E_V2x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4BFmode)
          || !general_operand (operands[1], E_V2x4BFmode)
          || !
#line 7924 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4BFmode)
       || register_operand (operands[1], V2x4BFmode))))
        return -1;
      return 4752; /* *aarch64_movv2x4bf */

    case E_V2x16QImode:
      if (!nonimmediate_operand (operands[0], E_V2x16QImode)
          || !general_operand (operands[1], E_V2x16QImode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x16QImode)
       || register_operand (operands[1], V2x16QImode))))
        return -1;
      return 4753; /* *aarch64_movv2x16qi */

    case E_V2x8HImode:
      if (!nonimmediate_operand (operands[0], E_V2x8HImode)
          || !general_operand (operands[1], E_V2x8HImode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8HImode)
       || register_operand (operands[1], V2x8HImode))))
        return -1;
      return 4754; /* *aarch64_movv2x8hi */

    case E_V2x4SImode:
      if (!nonimmediate_operand (operands[0], E_V2x4SImode)
          || !general_operand (operands[1], E_V2x4SImode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4SImode)
       || register_operand (operands[1], V2x4SImode))))
        return -1;
      return 4755; /* *aarch64_movv2x4si */

    case E_V2x2DImode:
      if (!nonimmediate_operand (operands[0], E_V2x2DImode)
          || !general_operand (operands[1], E_V2x2DImode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2DImode)
       || register_operand (operands[1], V2x2DImode))))
        return -1;
      return 4756; /* *aarch64_movv2x2di */

    case E_V2x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V2x8HFmode)
          || !general_operand (operands[1], E_V2x8HFmode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8HFmode)
       || register_operand (operands[1], V2x8HFmode))))
        return -1;
      return 4757; /* *aarch64_movv2x8hf */

    case E_V2x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4SFmode)
          || !general_operand (operands[1], E_V2x4SFmode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4SFmode)
       || register_operand (operands[1], V2x4SFmode))))
        return -1;
      return 4758; /* *aarch64_movv2x4sf */

    case E_V2x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2x2DFmode)
          || !general_operand (operands[1], E_V2x2DFmode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2DFmode)
       || register_operand (operands[1], V2x2DFmode))))
        return -1;
      return 4759; /* *aarch64_movv2x2df */

    case E_V2x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V2x8BFmode)
          || !general_operand (operands[1], E_V2x8BFmode)
          || !
#line 7937 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8BFmode)
       || register_operand (operands[1], V2x8BFmode))))
        return -1;
      return 4760; /* *aarch64_movv2x8bf */

    case E_OImode:
      if (!nonimmediate_operand (operands[0], E_OImode)
          || !general_operand (operands[1], E_OImode)
          || !
#line 7950 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))))
        return -1;
      return 4761; /* *aarch64_movoi */

    case E_V3x8QImode:
      if (!nonimmediate_operand (operands[0], E_V3x8QImode)
          || !general_operand (operands[1], E_V3x8QImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8QImode)
       || register_operand (operands[1], V3x8QImode))))
        return -1;
      return 4762; /* *aarch64_movv3x8qi */

    case E_V3x4HImode:
      if (!nonimmediate_operand (operands[0], E_V3x4HImode)
          || !general_operand (operands[1], E_V3x4HImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4HImode)
       || register_operand (operands[1], V3x4HImode))))
        return -1;
      return 4763; /* *aarch64_movv3x4hi */

    case E_V3x2SImode:
      if (!nonimmediate_operand (operands[0], E_V3x2SImode)
          || !general_operand (operands[1], E_V3x2SImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2SImode)
       || register_operand (operands[1], V3x2SImode))))
        return -1;
      return 4764; /* *aarch64_movv3x2si */

    case E_V3x1DImode:
      if (!nonimmediate_operand (operands[0], E_V3x1DImode)
          || !general_operand (operands[1], E_V3x1DImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x1DImode)
       || register_operand (operands[1], V3x1DImode))))
        return -1;
      return 4765; /* *aarch64_movv3x1di */

    case E_V3x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4HFmode)
          || !general_operand (operands[1], E_V3x4HFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4HFmode)
       || register_operand (operands[1], V3x4HFmode))))
        return -1;
      return 4766; /* *aarch64_movv3x4hf */

    case E_V3x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V3x2SFmode)
          || !general_operand (operands[1], E_V3x2SFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2SFmode)
       || register_operand (operands[1], V3x2SFmode))))
        return -1;
      return 4767; /* *aarch64_movv3x2sf */

    case E_V3x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V3x1DFmode)
          || !general_operand (operands[1], E_V3x1DFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x1DFmode)
       || register_operand (operands[1], V3x1DFmode))))
        return -1;
      return 4768; /* *aarch64_movv3x1df */

    case E_V3x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4BFmode)
          || !general_operand (operands[1], E_V3x4BFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4BFmode)
       || register_operand (operands[1], V3x4BFmode))))
        return -1;
      return 4769; /* *aarch64_movv3x4bf */

    case E_V3x16QImode:
      if (!nonimmediate_operand (operands[0], E_V3x16QImode)
          || !general_operand (operands[1], E_V3x16QImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x16QImode)
       || register_operand (operands[1], V3x16QImode))))
        return -1;
      return 4770; /* *aarch64_movv3x16qi */

    case E_V3x8HImode:
      if (!nonimmediate_operand (operands[0], E_V3x8HImode)
          || !general_operand (operands[1], E_V3x8HImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8HImode)
       || register_operand (operands[1], V3x8HImode))))
        return -1;
      return 4771; /* *aarch64_movv3x8hi */

    case E_V3x4SImode:
      if (!nonimmediate_operand (operands[0], E_V3x4SImode)
          || !general_operand (operands[1], E_V3x4SImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4SImode)
       || register_operand (operands[1], V3x4SImode))))
        return -1;
      return 4772; /* *aarch64_movv3x4si */

    case E_V3x2DImode:
      if (!nonimmediate_operand (operands[0], E_V3x2DImode)
          || !general_operand (operands[1], E_V3x2DImode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2DImode)
       || register_operand (operands[1], V3x2DImode))))
        return -1;
      return 4773; /* *aarch64_movv3x2di */

    case E_V3x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V3x8HFmode)
          || !general_operand (operands[1], E_V3x8HFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8HFmode)
       || register_operand (operands[1], V3x8HFmode))))
        return -1;
      return 4774; /* *aarch64_movv3x8hf */

    case E_V3x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4SFmode)
          || !general_operand (operands[1], E_V3x4SFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4SFmode)
       || register_operand (operands[1], V3x4SFmode))))
        return -1;
      return 4775; /* *aarch64_movv3x4sf */

    case E_V3x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V3x2DFmode)
          || !general_operand (operands[1], E_V3x2DFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2DFmode)
       || register_operand (operands[1], V3x2DFmode))))
        return -1;
      return 4776; /* *aarch64_movv3x2df */

    case E_V3x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V3x8BFmode)
          || !general_operand (operands[1], E_V3x8BFmode)
          || !
#line 7963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8BFmode)
       || register_operand (operands[1], V3x8BFmode))))
        return -1;
      return 4777; /* *aarch64_movv3x8bf */

    case E_CImode:
      if (!nonimmediate_operand (operands[0], E_CImode)
          || !general_operand (operands[1], E_CImode)
          || !
#line 7975 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], CImode)
       || register_operand (operands[1], CImode))))
        return -1;
      return 4778; /* *aarch64_movci */

    case E_V4x8QImode:
      if (!nonimmediate_operand (operands[0], E_V4x8QImode)
          || !general_operand (operands[1], E_V4x8QImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8QImode)
       || register_operand (operands[1], V4x8QImode))))
        return -1;
      return 4779; /* *aarch64_movv4x8qi */

    case E_V4x4HImode:
      if (!nonimmediate_operand (operands[0], E_V4x4HImode)
          || !general_operand (operands[1], E_V4x4HImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4HImode)
       || register_operand (operands[1], V4x4HImode))))
        return -1;
      return 4780; /* *aarch64_movv4x4hi */

    case E_V4x2SImode:
      if (!nonimmediate_operand (operands[0], E_V4x2SImode)
          || !general_operand (operands[1], E_V4x2SImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2SImode)
       || register_operand (operands[1], V4x2SImode))))
        return -1;
      return 4781; /* *aarch64_movv4x2si */

    case E_V4x1DImode:
      if (!nonimmediate_operand (operands[0], E_V4x1DImode)
          || !general_operand (operands[1], E_V4x1DImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x1DImode)
       || register_operand (operands[1], V4x1DImode))))
        return -1;
      return 4782; /* *aarch64_movv4x1di */

    case E_V4x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4HFmode)
          || !general_operand (operands[1], E_V4x4HFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4HFmode)
       || register_operand (operands[1], V4x4HFmode))))
        return -1;
      return 4783; /* *aarch64_movv4x4hf */

    case E_V4x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x2SFmode)
          || !general_operand (operands[1], E_V4x2SFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2SFmode)
       || register_operand (operands[1], V4x2SFmode))))
        return -1;
      return 4784; /* *aarch64_movv4x2sf */

    case E_V4x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V4x1DFmode)
          || !general_operand (operands[1], E_V4x1DFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x1DFmode)
       || register_operand (operands[1], V4x1DFmode))))
        return -1;
      return 4785; /* *aarch64_movv4x1df */

    case E_V4x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4BFmode)
          || !general_operand (operands[1], E_V4x4BFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4BFmode)
       || register_operand (operands[1], V4x4BFmode))))
        return -1;
      return 4786; /* *aarch64_movv4x4bf */

    case E_V4x16QImode:
      if (!nonimmediate_operand (operands[0], E_V4x16QImode)
          || !general_operand (operands[1], E_V4x16QImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x16QImode)
       || register_operand (operands[1], V4x16QImode))))
        return -1;
      return 4787; /* *aarch64_movv4x16qi */

    case E_V4x8HImode:
      if (!nonimmediate_operand (operands[0], E_V4x8HImode)
          || !general_operand (operands[1], E_V4x8HImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8HImode)
       || register_operand (operands[1], V4x8HImode))))
        return -1;
      return 4788; /* *aarch64_movv4x8hi */

    case E_V4x4SImode:
      if (!nonimmediate_operand (operands[0], E_V4x4SImode)
          || !general_operand (operands[1], E_V4x4SImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4SImode)
       || register_operand (operands[1], V4x4SImode))))
        return -1;
      return 4789; /* *aarch64_movv4x4si */

    case E_V4x2DImode:
      if (!nonimmediate_operand (operands[0], E_V4x2DImode)
          || !general_operand (operands[1], E_V4x2DImode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2DImode)
       || register_operand (operands[1], V4x2DImode))))
        return -1;
      return 4790; /* *aarch64_movv4x2di */

    case E_V4x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8HFmode)
          || !general_operand (operands[1], E_V4x8HFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8HFmode)
       || register_operand (operands[1], V4x8HFmode))))
        return -1;
      return 4791; /* *aarch64_movv4x8hf */

    case E_V4x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4SFmode)
          || !general_operand (operands[1], E_V4x4SFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4SFmode)
       || register_operand (operands[1], V4x4SFmode))))
        return -1;
      return 4792; /* *aarch64_movv4x4sf */

    case E_V4x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V4x2DFmode)
          || !general_operand (operands[1], E_V4x2DFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2DFmode)
       || register_operand (operands[1], V4x2DFmode))))
        return -1;
      return 4793; /* *aarch64_movv4x2df */

    case E_V4x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8BFmode)
          || !general_operand (operands[1], E_V4x8BFmode)
          || !
#line 7987 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8BFmode)
       || register_operand (operands[1], V4x8BFmode))))
        return -1;
      return 4794; /* *aarch64_movv4x8bf */

    case E_XImode:
      if (!nonimmediate_operand (operands[0], E_XImode)
          || !general_operand (operands[1], E_XImode)
          || !
#line 7999 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))))
        return -1;
      return 4795; /* *aarch64_movxi */

    default:
      return -1;
    }
}

 int
recog_489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern893 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1776; /* xorv8qi3_vec_concatz_be */

        case E_V8HImode:
          if (pattern893 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1780; /* xorv4hi3_vec_concatz_be */

        case E_V4SImode:
          if (pattern893 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1784; /* xorv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case AND:
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != XOR)
        return -1;
      x5 = XEXP (x2, 0);
      operands[4] = x5;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      x10 = XEXP (x4, 1);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern1004 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return 2877; /* aarch64_simd_bslv8qi_internal_vec_concatz_be */
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2890; /* *aarch64_simd_bslv8qi_alt_vec_concatz_be */

        case E_V8HImode:
          if (pattern1004 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return 2881; /* aarch64_simd_bslv4hi_internal_vec_concatz_be */
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2894; /* *aarch64_simd_bslv4hi_alt_vec_concatz_be */

        case E_V4SImode:
          if (pattern1004 (x2, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return 2885; /* aarch64_simd_bslv2si_internal_vec_concatz_be */
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2898; /* *aarch64_simd_bslv2si_alt_vec_concatz_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SMAX)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          operands[4] = x7;
          operands[1] = x6;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1074 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5267 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3381; /* *aarch64_sqmovunv8hi_insn_vec_concatz_le */

            case E_V8HImode:
              if (pattern1074 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5267 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3384; /* *aarch64_sqmovunv4si_insn_vec_concatz_le */

            case E_V4SImode:
              if (pattern1074 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5267 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3387; /* *aarch64_sqmovunv2di_insn_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x7;
          operands[2] = x6;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 1);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1075 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0
                  || !
#line 5313 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3392; /* aarch64_sqxtun2v8hi_be */

            case E_V8HImode:
              if (pattern1075 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0
                  || !
#line 5313 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3393; /* aarch64_sqxtun2v4si_be */

            case E_V4SImode:
              if (pattern1075 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0
                  || !
#line 5313 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3394; /* aarch64_sqxtun2v2di_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x10 = XEXP (x6, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              operands[5] = x7;
              operands[1] = x10;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              x8 = XEXP (x5, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1163 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V8HImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V8HImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V8QImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3980; /* *aarch64_sqshrun_nv8hi_insn_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1163 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V4SImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V4SImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3983; /* *aarch64_sqshrun_nv4si_insn_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1163 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V2DImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V2DImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3986; /* *aarch64_sqshrun_nv2di_insn_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              operands[2] = x10;
              x11 = XEXP (x6, 1);
              operands[3] = x11;
              x8 = XEXP (x5, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1164 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V8HImode)
                      || !aarch64_simd_umax_half_mode (operands[5], E_V8HImode)
                      || !register_operand (operands[1], E_V8QImode)
                      || !
#line 6886 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 4060; /* aarch64_sqshrun2_nv8hi_insn_be */

                case E_V8HImode:
                  if (pattern1164 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V4SImode)
                      || !aarch64_simd_umax_half_mode (operands[5], E_V4SImode)
                      || !register_operand (operands[1], E_V4HImode)
                      || !
#line 6886 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 4061; /* aarch64_sqshrun2_nv4si_insn_be */

                case E_V4SImode:
                  if (pattern1164 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V2DImode)
                      || !aarch64_simd_umax_half_mode (operands[5], E_V2DImode)
                      || !register_operand (operands[1], E_V2SImode)
                      || !
#line 6886 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 4062; /* aarch64_sqshrun2_nv2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x12 = XEXP (x10, 0);
          if (GET_CODE (x12) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              operands[6] = x7;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x14 = XEXP (x10, 1);
              operands[3] = x14;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              x8 = XEXP (x5, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1226 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V8SImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V8SImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[6], E_V8QImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3992; /* *aarch64_sqrshrun_nv8hi_insn_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1226 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V4DImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V4DImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[6], E_V4HImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3995; /* *aarch64_sqrshrun_nv4si_insn_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1226 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V2TImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V2TImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[6], E_V2SImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3998; /* *aarch64_sqrshrun_nv2di_insn_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              x13 = XEXP (x12, 0);
              operands[2] = x13;
              x14 = XEXP (x10, 1);
              operands[4] = x14;
              x11 = XEXP (x6, 1);
              operands[3] = x11;
              x8 = XEXP (x5, 1);
              operands[5] = x8;
              x9 = XEXP (x4, 1);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1227 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[5], E_V8SImode)
                      || !aarch64_simd_umax_quarter_mode (operands[6], E_V8SImode)
                      || !register_operand (operands[1], E_V8QImode)
                      || !
#line 6952 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                    return -1;
                  return 4066; /* aarch64_sqrshrun2_nv8hi_insn_be */

                case E_V8HImode:
                  if (pattern1227 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[5], E_V4DImode)
                      || !aarch64_simd_umax_quarter_mode (operands[6], E_V4DImode)
                      || !register_operand (operands[1], E_V4HImode)
                      || !
#line 6952 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                    return -1;
                  return 4067; /* aarch64_sqrshrun2_nv4si_insn_be */

                case E_V4SImode:
                  if (pattern1227 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_V2TImode)
                      || !aarch64_simd_umax_quarter_mode (operands[6], E_V2TImode)
                      || !register_operand (operands[1], E_V2SImode)
                      || !
#line 6952 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                    return -1;
                  return 4068; /* aarch64_sqrshrun2_nv2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_490 (x1, insn, pnum_clobbers);

    case 1:
      switch (XINT (x3, 1))
        {
        case 186:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern535 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1611; /* aarch64_absv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern535 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1615; /* aarch64_absv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern535 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1619; /* aarch64_absv2si_vec_concatz_le */

            case E_V2DImode:
              if (pattern535 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1624; /* aarch64_absdi_vec_concatz_le */

            default:
              return -1;
            }

        case 36:
          switch (pattern536 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2473; /* btruncv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2501; /* btruncv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 34:
          switch (pattern536 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2476; /* ceilv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2504; /* ceilv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 32:
          switch (pattern536 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2479; /* floorv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2507; /* floorv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 33:
          switch (pattern536 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2482; /* roundevenv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2510; /* roundevenv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 31:
          switch (pattern536 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2485; /* nearbyintv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2513; /* nearbyintv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 35:
          switch (pattern536 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2488; /* rintv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2516; /* rintv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 30:
          switch (pattern536 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2491; /* roundv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2519; /* roundv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 587:
          if (GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2SFmode)
              || !
#line 3230 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
            return -1;
          return 2644; /* aarch64_float_trunc_rodd_hi_v4sf_be */

        case 253:
          switch (pattern537 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5016; /* aarch64_rev64v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5028; /* aarch64_rev64v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5040; /* aarch64_rev64v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5055; /* aarch64_rev64v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5067; /* aarch64_rev64v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5079; /* aarch64_rev64v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case 254:
          switch (pattern537 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5019; /* aarch64_rev32v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5031; /* aarch64_rev32v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5043; /* aarch64_rev32v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5058; /* aarch64_rev32v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5070; /* aarch64_rev32v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5082; /* aarch64_rev32v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case 255:
          switch (pattern537 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5022; /* aarch64_rev16v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5034; /* aarch64_rev16v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5046; /* aarch64_rev16v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5061; /* aarch64_rev16v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5073; /* aarch64_rev16v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8478 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5085; /* aarch64_rev16v2sf_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      switch (XINT (x3, 1))
        {
        case 274:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3510; /* aarch64_sqrdmlahv4hi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3518; /* aarch64_sqrdmlahv2si_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3530; /* aarch64_sqrdmlah_lanev4hi_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3550; /* aarch64_sqrdmlah_laneqv4hi_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3538; /* aarch64_sqrdmlah_lanev2si_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3558; /* aarch64_sqrdmlah_laneqv2si_vec_concatz_le */

            default:
              return -1;
            }

        case 275:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3513; /* aarch64_sqrdmlshv4hi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5444 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3521; /* aarch64_sqrdmlshv2si_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3533; /* aarch64_sqrdmlsh_lanev4hi_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3553; /* aarch64_sqrdmlsh_laneqv4hi_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5460 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3541; /* aarch64_sqrdmlsh_lanev2si_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5498 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3561; /* aarch64_sqrdmlsh_laneqv2si_vec_concatz_le */

            default:
              return -1;
            }

        case 187:
          if (GET_MODE (x3) != E_V8QImode)
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 84
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V8QImode)
              || !
#line 9932 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8 && BYTES_BIG_ENDIAN))
            return -1;
          return 5322; /* aarch64_fcvtnv4sf_high_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 6; /* jump */
            }
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x2))
            {
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
              res = recog_473 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
              res = recog_474 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x2;
          if (aarch64_movti_operand (operands[1], E_TImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (nonimmediate_operand (operands[0], E_TImode)
                  && 
#line 1709 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], TImode)
    || aarch64_reg_or_zero (operands[1], TImode))))
                return 75; /* *movti_aarch64 */
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (register_operand (operands[0], E_VNx16QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx16QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx16QImode)))))
            return 5535; /* *aarch64_sve_movvnx16qi_no_ldr_str */
          break;

        case E_VNx8QImode:
          if (register_operand (operands[0], E_VNx8QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8QImode)))))
            return 5536; /* *aarch64_sve_movvnx8qi_no_ldr_str */
          break;

        case E_VNx4QImode:
          if (register_operand (operands[0], E_VNx4QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4QImode)))))
            return 5537; /* *aarch64_sve_movvnx4qi_no_ldr_str */
          break;

        case E_VNx2QImode:
          if (register_operand (operands[0], E_VNx2QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2QImode)))))
            return 5538; /* *aarch64_sve_movvnx2qi_no_ldr_str */
          break;

        case E_VNx8HImode:
          if (register_operand (operands[0], E_VNx8HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HImode)))))
            return 5539; /* *aarch64_sve_movvnx8hi_no_ldr_str */
          break;

        case E_VNx4HImode:
          if (register_operand (operands[0], E_VNx4HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HImode)))))
            return 5540; /* *aarch64_sve_movvnx4hi_no_ldr_str */
          break;

        case E_VNx2HImode:
          if (register_operand (operands[0], E_VNx2HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HImode)))))
            return 5541; /* *aarch64_sve_movvnx2hi_no_ldr_str */
          break;

        case E_VNx4SImode:
          if (register_operand (operands[0], E_VNx4SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SImode)))))
            return 5542; /* *aarch64_sve_movvnx4si_no_ldr_str */
          break;

        case E_VNx2SImode:
          if (register_operand (operands[0], E_VNx2SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SImode)))))
            return 5543; /* *aarch64_sve_movvnx2si_no_ldr_str */
          break;

        case E_VNx2DImode:
          if (register_operand (operands[0], E_VNx2DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DImode)))))
            return 5544; /* *aarch64_sve_movvnx2di_no_ldr_str */
          break;

        case E_VNx8HFmode:
          if (register_operand (operands[0], E_VNx8HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HFmode)))))
            return 5545; /* *aarch64_sve_movvnx8hf_no_ldr_str */
          break;

        case E_VNx4HFmode:
          if (register_operand (operands[0], E_VNx4HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HFmode)))))
            return 5546; /* *aarch64_sve_movvnx4hf_no_ldr_str */
          break;

        case E_VNx2HFmode:
          if (register_operand (operands[0], E_VNx2HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HFmode)))))
            return 5547; /* *aarch64_sve_movvnx2hf_no_ldr_str */
          break;

        case E_VNx8BFmode:
          if (register_operand (operands[0], E_VNx8BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8BFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8BFmode)))))
            return 5548; /* *aarch64_sve_movvnx8bf_no_ldr_str */
          break;

        case E_VNx4BFmode:
          if (register_operand (operands[0], E_VNx4BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4BFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4BFmode)))))
            return 5549; /* *aarch64_sve_movvnx4bf_no_ldr_str */
          break;

        case E_VNx2BFmode:
          if (register_operand (operands[0], E_VNx2BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2BFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2BFmode)))))
            return 5550; /* *aarch64_sve_movvnx2bf_no_ldr_str */
          break;

        case E_VNx4SFmode:
          if (register_operand (operands[0], E_VNx4SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SFmode)))))
            return 5551; /* *aarch64_sve_movvnx4sf_no_ldr_str */
          break;

        case E_VNx2SFmode:
          if (register_operand (operands[0], E_VNx2SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SFmode)))))
            return 5552; /* *aarch64_sve_movvnx2sf_no_ldr_str */
          break;

        case E_VNx2DFmode:
          if (register_operand (operands[0], E_VNx2DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DFmode)))))
            return 5553; /* *aarch64_sve_movvnx2df_no_ldr_str */
          break;

        case E_VNx32QImode:
          if (register_operand (operands[0], E_VNx32QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32QImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5659; /* *aarch64_sve_movvnx32qi_be */
          break;

        case E_VNx16HImode:
          if (register_operand (operands[0], E_VNx16HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5660; /* *aarch64_sve_movvnx16hi_be */
          break;

        case E_VNx8SImode:
          if (register_operand (operands[0], E_VNx8SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5661; /* *aarch64_sve_movvnx8si_be */
          break;

        case E_VNx4DImode:
          if (register_operand (operands[0], E_VNx4DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5662; /* *aarch64_sve_movvnx4di_be */
          break;

        case E_VNx16BFmode:
          if (register_operand (operands[0], E_VNx16BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16BFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5663; /* *aarch64_sve_movvnx16bf_be */
          break;

        case E_VNx16HFmode:
          if (register_operand (operands[0], E_VNx16HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5664; /* *aarch64_sve_movvnx16hf_be */
          break;

        case E_VNx8SFmode:
          if (register_operand (operands[0], E_VNx8SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5665; /* *aarch64_sve_movvnx8sf_be */
          break;

        case E_VNx4DFmode:
          if (register_operand (operands[0], E_VNx4DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5666; /* *aarch64_sve_movvnx4df_be */
          break;

        case E_VNx48QImode:
          if (register_operand (operands[0], E_VNx48QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx48QImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5667; /* *aarch64_sve_movvnx48qi_be */
          break;

        case E_VNx24HImode:
          if (register_operand (operands[0], E_VNx24HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5668; /* *aarch64_sve_movvnx24hi_be */
          break;

        case E_VNx12SImode:
          if (register_operand (operands[0], E_VNx12SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5669; /* *aarch64_sve_movvnx12si_be */
          break;

        case E_VNx6DImode:
          if (register_operand (operands[0], E_VNx6DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5670; /* *aarch64_sve_movvnx6di_be */
          break;

        case E_VNx24BFmode:
          if (register_operand (operands[0], E_VNx24BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24BFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5671; /* *aarch64_sve_movvnx24bf_be */
          break;

        case E_VNx24HFmode:
          if (register_operand (operands[0], E_VNx24HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5672; /* *aarch64_sve_movvnx24hf_be */
          break;

        case E_VNx12SFmode:
          if (register_operand (operands[0], E_VNx12SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5673; /* *aarch64_sve_movvnx12sf_be */
          break;

        case E_VNx6DFmode:
          if (register_operand (operands[0], E_VNx6DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5674; /* *aarch64_sve_movvnx6df_be */
          break;

        case E_VNx64QImode:
          if (register_operand (operands[0], E_VNx64QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx64QImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5675; /* *aarch64_sve_movvnx64qi_be */
          break;

        case E_VNx32HImode:
          if (register_operand (operands[0], E_VNx32HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5676; /* *aarch64_sve_movvnx32hi_be */
          break;

        case E_VNx16SImode:
          if (register_operand (operands[0], E_VNx16SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5677; /* *aarch64_sve_movvnx16si_be */
          break;

        case E_VNx8DImode:
          if (register_operand (operands[0], E_VNx8DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5678; /* *aarch64_sve_movvnx8di_be */
          break;

        case E_VNx32BFmode:
          if (register_operand (operands[0], E_VNx32BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32BFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5679; /* *aarch64_sve_movvnx32bf_be */
          break;

        case E_VNx32HFmode:
          if (register_operand (operands[0], E_VNx32HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5680; /* *aarch64_sve_movvnx32hf_be */
          break;

        case E_VNx16SFmode:
          if (register_operand (operands[0], E_VNx16SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5681; /* *aarch64_sve_movvnx16sf_be */
          break;

        case E_VNx8DFmode:
          if (register_operand (operands[0], E_VNx8DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5682; /* *aarch64_sve_movvnx8df_be */
          break;

        case E_VNx16BImode:
          if (nonimmediate_operand (operands[0], E_VNx16BImode)
              && aarch64_mov_operand (operands[1], E_VNx16BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BImode)
       || register_operand (operands[1], VNx16BImode))))
            return 5707; /* *aarch64_sve_movvnx16bi */
          break;

        case E_VNx8BImode:
          if (nonimmediate_operand (operands[0], E_VNx8BImode)
              && aarch64_mov_operand (operands[1], E_VNx8BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BImode)
       || register_operand (operands[1], VNx8BImode))))
            return 5708; /* *aarch64_sve_movvnx8bi */
          break;

        case E_VNx4BImode:
          if (nonimmediate_operand (operands[0], E_VNx4BImode)
              && aarch64_mov_operand (operands[1], E_VNx4BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BImode)
       || register_operand (operands[1], VNx4BImode))))
            return 5709; /* *aarch64_sve_movvnx4bi */
          break;

        case E_VNx2BImode:
          if (nonimmediate_operand (operands[0], E_VNx2BImode)
              && aarch64_mov_operand (operands[1], E_VNx2BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BImode)
       || register_operand (operands[1], VNx2BImode))))
            return 5710; /* *aarch64_sve_movvnx2bi */
          break;

        case E_VNx32BImode:
          if (nonimmediate_operand (operands[0], E_VNx32BImode)
              && aarch64_mov_operand (operands[1], E_VNx32BImode)
              && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5719; /* movvnx32bi */
          break;

        case E_VNx64BImode:
          if (nonimmediate_operand (operands[0], E_VNx64BImode)
              && aarch64_mov_operand (operands[1], E_VNx64BImode)
              && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5720; /* movvnx64bi */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == REG
          && GET_MODE (x2) == E_VNx16BImode)
        {
          switch (REGNO (x2))
            {
            case 85:
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 86
                  && GET_MODE (x3) == E_VNx16BImode
                  && 
#line 1141 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 5723; /* aarch64_copy_ffr_to_ffrt */
              break;

            case 86:
              operands[0] = x3;
              if (register_operand (operands[0], E_VNx16BImode)
                  && 
#line 1152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 5724; /* aarch64_rdffr */
              break;

            default:
              break;
            }
        }
      operands[1] = x2;
      operands[0] = x3;
      res = recog_475 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && GET_CODE (x3) == REG
          && REGNO (x3) == 90
          && GET_MODE (x3) == E_DImode)
        return 12912; /* aarch64_clear_tpidr2 */
      break;

    case TRUNCATE:
      res = recog_477 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!subreg_lowpart_operator (x2, E_DImode))
    return -1;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 829; /* *aarch64_bfidiqi_subreg_8 */

    case 1:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 830; /* *aarch64_bfidihi_subreg_8 */

    case 2:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 832; /* *aarch64_bfidisi_subreg_8 */

    case 3:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 831; /* *aarch64_bfidihi_subreg_16 */

    case 4:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 833; /* *aarch64_bfidisi_subreg_16 */

    case 5:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64))
        return -1;
      return 834; /* *aarch64_bfidisi_subreg_32 */

    default:
      return -1;
    }
}

 int
recog_513 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_480 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (register_operand (operands[0], E_V8QImode)
                      && GET_MODE (x3) == E_V8QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1230; /* aarch64_simd_dupv8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[0], E_V16QImode)
                      && GET_MODE (x3) == E_V16QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1231; /* aarch64_simd_dupv16qi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[0], E_V4HImode)
                      && GET_MODE (x3) == E_V4HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1232; /* aarch64_simd_dupv4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[0], E_V8HImode)
                      && GET_MODE (x3) == E_V8HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1233; /* aarch64_simd_dupv8hi */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1234; /* aarch64_simd_dupv2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[0], E_V4SImode)
                      && GET_MODE (x3) == E_V4SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1235; /* aarch64_simd_dupv4si */
                  break;

                case E_V2DImode:
                  if (register_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1236; /* aarch64_simd_dupv2di */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[0], E_V4HFmode)
                      && GET_MODE (x3) == E_V4HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1237; /* aarch64_simd_dupv4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[0], E_V8HFmode)
                      && GET_MODE (x3) == E_V8HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1238; /* aarch64_simd_dupv8hf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1239; /* aarch64_simd_dupv2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[0], E_V4SFmode)
                      && GET_MODE (x3) == E_V4SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1240; /* aarch64_simd_dupv4sf */
                  break;

                case E_V2DFmode:
                  if (register_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1241; /* aarch64_simd_dupv2df */
                  break;

                case E_V4BFmode:
                  if (register_operand (operands[0], E_V4BFmode)
                      && GET_MODE (x3) == E_V4BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1242; /* aarch64_simd_dupv4bf */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[0], E_V8BFmode)
                      && GET_MODE (x3) == E_V8BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1243; /* aarch64_simd_dupv8bf */
                  break;

                default:
                  break;
                }
              break;

            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1296; /* aarch64_simd_stpv2si */
                  break;

                case E_V2SFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1297; /* aarch64_simd_stpv2sf */
                  break;

                case E_V2DImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1298; /* aarch64_simd_stpv2di */
                  break;

                case E_V2DFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1299; /* aarch64_simd_stpv2df */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (register_operand (operands[0], E_V8QImode)
                  && GET_MODE (x3) == E_V8QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5117; /* *aarch64_simd_ld1rv8qi */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5118; /* *aarch64_simd_ld1rv16qi */
              break;

            case E_V4HImode:
              if (register_operand (operands[0], E_V4HImode)
                  && GET_MODE (x3) == E_V4HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5119; /* *aarch64_simd_ld1rv4hi */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5120; /* *aarch64_simd_ld1rv8hi */
              break;

            case E_V2SImode:
              if (register_operand (operands[0], E_V2SImode)
                  && GET_MODE (x3) == E_V2SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5121; /* *aarch64_simd_ld1rv2si */
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x3) == E_V4SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5122; /* *aarch64_simd_ld1rv4si */
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x3) == E_V2DImode
                  && aarch64_simd_struct_operand (operands[1], E_DImode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5123; /* *aarch64_simd_ld1rv2di */
              break;

            case E_V4HFmode:
              if (register_operand (operands[0], E_V4HFmode)
                  && GET_MODE (x3) == E_V4HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5124; /* *aarch64_simd_ld1rv4hf */
              break;

            case E_V8HFmode:
              if (register_operand (operands[0], E_V8HFmode)
                  && GET_MODE (x3) == E_V8HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5125; /* *aarch64_simd_ld1rv8hf */
              break;

            case E_V4BFmode:
              if (register_operand (operands[0], E_V4BFmode)
                  && GET_MODE (x3) == E_V4BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5126; /* *aarch64_simd_ld1rv4bf */
              break;

            case E_V8BFmode:
              if (register_operand (operands[0], E_V8BFmode)
                  && GET_MODE (x3) == E_V8BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5127; /* *aarch64_simd_ld1rv8bf */
              break;

            case E_V2SFmode:
              if (register_operand (operands[0], E_V2SFmode)
                  && GET_MODE (x3) == E_V2SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5128; /* *aarch64_simd_ld1rv2sf */
              break;

            case E_V4SFmode:
              if (register_operand (operands[0], E_V4SFmode)
                  && GET_MODE (x3) == E_V4SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5129; /* *aarch64_simd_ld1rv4sf */
              break;

            case E_V2DFmode:
              if (register_operand (operands[0], E_V2DFmode)
                  && GET_MODE (x3) == E_V2DFmode
                  && aarch64_simd_struct_operand (operands[1], E_DFmode)
                  && 
#line 8618 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5130; /* *aarch64_simd_ld1rv2df */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      return recog_479 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern12 (x1))
    {
    case 0:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 902; /* lbtrunchfsi2 */

    case 1:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 922; /* lbtruncsfsi2 */

    case 2:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 942; /* lbtruncdfsi2 */

    case 3:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 912; /* lbtrunchfdi2 */

    case 4:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 932; /* lbtruncsfdi2 */

    case 5:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 952; /* lbtruncdfdi2 */

    case 6:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2535; /* lbtruncv4hfv4hi2 */

    case 7:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2545; /* lbtruncv8hfv8hi2 */

    case 8:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2555; /* lbtruncv2sfv2si2 */

    case 9:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2565; /* lbtruncv4sfv4si2 */

    case 10:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2575; /* lbtruncv2dfv2di2 */

    case 11:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2585; /* lbtrunchfhi2 */

    case 12:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2SFmode)))))
        return -1;
      return 2599; /* *aarch64_fcvtv2sfv2si2_mult */

    case 13:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V4SFmode)))))
        return -1;
      return 2601; /* *aarch64_fcvtv4sfv4si2_mult */

    case 14:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2DFmode)))))
        return -1;
      return 2603; /* *aarch64_fcvtv2dfv2di2_mult */

    case 15:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 903; /* lceilhfsi2 */

    case 16:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 923; /* lceilsfsi2 */

    case 17:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 943; /* lceildfsi2 */

    case 18:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 913; /* lceilhfdi2 */

    case 19:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 933; /* lceilsfdi2 */

    case 20:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 953; /* lceildfdi2 */

    case 21:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2536; /* lceilv4hfv4hi2 */

    case 22:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2546; /* lceilv8hfv8hi2 */

    case 23:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2556; /* lceilv2sfv2si2 */

    case 24:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2566; /* lceilv4sfv4si2 */

    case 25:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2576; /* lceilv2dfv2di2 */

    case 26:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2586; /* lceilhfhi2 */

    case 27:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 904; /* lfloorhfsi2 */

    case 28:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 924; /* lfloorsfsi2 */

    case 29:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 944; /* lfloordfsi2 */

    case 30:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 914; /* lfloorhfdi2 */

    case 31:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 934; /* lfloorsfdi2 */

    case 32:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 954; /* lfloordfdi2 */

    case 33:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2537; /* lfloorv4hfv4hi2 */

    case 34:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2547; /* lfloorv8hfv8hi2 */

    case 35:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2557; /* lfloorv2sfv2si2 */

    case 36:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2567; /* lfloorv4sfv4si2 */

    case 37:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2577; /* lfloorv2dfv2di2 */

    case 38:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2587; /* lfloorhfhi2 */

    case 39:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 905; /* lroundhfsi2 */

    case 40:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 925; /* lroundsfsi2 */

    case 41:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 945; /* lrounddfsi2 */

    case 42:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 915; /* lroundhfdi2 */

    case 43:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 935; /* lroundsfdi2 */

    case 44:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 955; /* lrounddfdi2 */

    case 45:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2538; /* lroundv4hfv4hi2 */

    case 46:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2548; /* lroundv8hfv8hi2 */

    case 47:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2558; /* lroundv2sfv2si2 */

    case 48:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2568; /* lroundv4sfv4si2 */

    case 49:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2578; /* lroundv2dfv2di2 */

    case 50:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2588; /* lroundhfhi2 */

    case 51:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 906; /* lfrintnhfsi2 */

    case 52:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 926; /* lfrintnsfsi2 */

    case 53:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 946; /* lfrintndfsi2 */

    case 54:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 916; /* lfrintnhfdi2 */

    case 55:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 936; /* lfrintnsfdi2 */

    case 56:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 956; /* lfrintndfdi2 */

    case 57:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2539; /* lfrintnv4hfv4hi2 */

    case 58:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2549; /* lfrintnv8hfv8hi2 */

    case 59:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2559; /* lfrintnv2sfv2si2 */

    case 60:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2569; /* lfrintnv4sfv4si2 */

    case 61:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2579; /* lfrintnv2dfv2di2 */

    case 62:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2589; /* lfrintnhfhi2 */

    case 63:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 962; /* *aarch64_fcvtsfsi2_mult */

    case 64:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 966; /* *aarch64_fcvtdfsi2_mult */

    case 65:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 964; /* *aarch64_fcvtsfdi2_mult */

    case 66:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 968; /* *aarch64_fcvtdfdi2_mult */

    case 67:
      if (!
#line 6983 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 988; /* fix_truncsfsi2 */

    case 68:
      if (!
#line 6995 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 992; /* fix_trunchfsi2 */

    case 69:
      if (!
#line 7006 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 996; /* fix_truncdfsi2 */

    case 70:
      if (!
#line 6983 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 990; /* fix_truncdfdi2 */

    case 71:
      if (!
#line 6995 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 994; /* fix_trunchfdi2 */

    case 72:
      if (!
#line 7006 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 998; /* fix_truncsfdi2 */

    case 73:
      if (!
#line 3035 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2595; /* fix_trunchfhi2 */

    case 74:
      if (!
#line 3439 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12590; /* fixvnx8sfvnx8si2 */

    case 75:
      if (!
#line 3439 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12592; /* fixvnx16sfvnx16si2 */

    default:
      return -1;
    }
}

 int
recog_533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern36 (x3))
    {
    case 0:
      if (!
#line 7339 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
        return -1;
      return 1069; /* *aarch64_umaxsi3_cssc */

    case 1:
      if (!
#line 7339 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
        return -1;
      return 1073; /* *aarch64_umaxdi3_cssc */

    case 2:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2063; /* umaxv8qi3 */

    case 3:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2071; /* umaxv16qi3 */

    case 4:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2079; /* umaxv4hi3 */

    case 5:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2087; /* umaxv8hi3 */

    case 6:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2095; /* umaxv2si3 */

    case 7:
      if (!
#line 1754 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2103; /* umaxv4si3 */

    case 8:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11385; /* *umaxvnx32qi3 */

    case 9:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11389; /* *umaxvnx16hi3 */

    case 10:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11393; /* *umaxvnx8si3 */

    case 11:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11397; /* *umaxvnx4di3 */

    case 12:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11401; /* *umaxvnx64qi3 */

    case 13:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11405; /* *umaxvnx32hi3 */

    case 14:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11409; /* *umaxvnx16si3 */

    case 15:
      if (!
#line 734 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11413; /* *umaxvnx8di3 */

    case 16:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7393; /* *post_ra_umaxvnx16qi3 */

    case 17:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7398; /* *post_ra_umaxvnx8qi3 */

    case 18:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7403; /* *post_ra_umaxvnx4qi3 */

    case 19:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7408; /* *post_ra_umaxvnx2qi3 */

    case 20:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7413; /* *post_ra_umaxvnx8hi3 */

    case 21:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7418; /* *post_ra_umaxvnx4hi3 */

    case 22:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7423; /* *post_ra_umaxvnx2hi3 */

    case 23:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7428; /* *post_ra_umaxvnx4si3 */

    case 24:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7433; /* *post_ra_umaxvnx2si3 */

    case 25:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7438; /* *post_ra_umaxvnx2di3 */

    case 26:
      if (!
#line 3975 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7443; /* *post_ra_umaxv2di3 */

    case 27:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11418; /* aarch64_sve_single_umaxvnx32qi */

    case 28:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11423; /* aarch64_sve_single_umaxvnx16hi */

    case 29:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11428; /* aarch64_sve_single_umaxvnx8si */

    case 30:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11433; /* aarch64_sve_single_umaxvnx4di */

    case 31:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11438; /* aarch64_sve_single_umaxvnx64qi */

    case 32:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11443; /* aarch64_sve_single_umaxvnx32hi */

    case 33:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11448; /* aarch64_sve_single_umaxvnx16si */

    case 34:
      if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11453; /* aarch64_sve_single_umaxvnx8di */

    default:
      return -1;
    }
}

 int
recog_538 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      switch (pattern434 (x3))
        {
        case 0:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3236; /* aarch64_uqsubv8qi */

        case 1:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3242; /* aarch64_uqsubv16qi */

        case 2:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3252; /* aarch64_uqsubv4hi */

        case 3:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3258; /* aarch64_uqsubv8hi */

        case 4:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3268; /* aarch64_uqsubv2si */

        case 5:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3274; /* aarch64_uqsubv4si */

        case 6:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3278; /* aarch64_uqsubv2di */

        case 7:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3282; /* aarch64_uqsubqi */

        case 8:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3286; /* aarch64_uqsubhi */

        case 9:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3290; /* aarch64_uqsubsi */

        case 10:
          if (!
#line 5169 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3300; /* aarch64_uqsubdi */

        case 11:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8078; /* aarch64_sve_ussubvnx16qi */

        case 12:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8080; /* aarch64_sve_ussubvnx8hi */

        case 13:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8082; /* aarch64_sve_ussubvnx4si */

        case 14:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8084; /* aarch64_sve_ussubvnx2di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern436 (x3))
        {
        case 0:
          if (!
#line 10531 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10974; /* aarch64_sve_uqdecdi_pat */

        case 1:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11026; /* *aarch64_sve_uqdecdivnx16bi_cntp */

        case 2:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11029; /* *aarch64_sve_uqdecdivnx8bi_cntp */

        case 3:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11032; /* *aarch64_sve_uqdecdivnx4bi_cntp */

        case 4:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11035; /* *aarch64_sve_uqdecdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern437 (x3))
        {
        case 0:
          if (!
#line 10596 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10980; /* aarch64_sve_uqdecvnx2di_pat */

        case 1:
          if (!
#line 11056 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11050; /* *aarch64_sve_uqdecvnx2di_cntp */

        case 2:
          if (!
#line 10617 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10983; /* aarch64_sve_uqdecvnx4si_pat */

        case 3:
          if (!
#line 11095 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11053; /* *aarch64_sve_uqdecvnx4si_cntp */

        case 4:
          if (!
#line 10652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10986; /* *aarch64_sve_uqdecvnx8hi_pat */

        case 5:
          if (!
#line 11136 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11056; /* *aarch64_sve_uqdecvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_557 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10090; /* *while_rwsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10100; /* *while_rwdivnx2bi_cc */
}

 int
recog_565 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10089; /* *while_ugesivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10099; /* *while_ugedivnx2bi_cc */
}

 int
recog_573 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10088; /* *while_ugtsivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10098; /* *while_ugtdivnx2bi_cc */
}

 int
recog_583 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10047; /* *while_gtsivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10057; /* *while_gtdivnx8bi_cc */
}

 int
recog_593 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1082 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10022; /* *while_lesivnx16bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10032; /* *while_ledivnx16bi_cc */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10042; /* *while_lesivnx8bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10052; /* *while_ledivnx8bi_cc */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10062; /* *while_lesivnx4bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10072; /* *while_ledivnx4bi_cc */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10082; /* *while_lesivnx2bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10092; /* *while_ledivnx2bi_cc */

    case 4:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10102; /* while_lesivnx16bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10112; /* while_ledivnx16bi_ptest */

    case 5:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10122; /* while_lesivnx8bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10132; /* while_ledivnx8bi_ptest */

    case 6:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10142; /* while_lesivnx4bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10152; /* while_ledivnx4bi_ptest */

    case 7:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10162; /* while_lesivnx2bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10172; /* while_ledivnx2bi_ptest */

    case 8:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10023; /* *while_ultsivnx16bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10033; /* *while_ultdivnx16bi_cc */

    case 9:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10043; /* *while_ultsivnx8bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10053; /* *while_ultdivnx8bi_cc */

    case 10:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10063; /* *while_ultsivnx4bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10073; /* *while_ultdivnx4bi_cc */

    case 11:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10083; /* *while_ultsivnx2bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10093; /* *while_ultdivnx2bi_cc */

    case 12:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10103; /* while_ultsivnx16bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10113; /* while_ultdivnx16bi_ptest */

    case 13:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10123; /* while_ultsivnx8bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10133; /* while_ultdivnx8bi_ptest */

    case 14:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10143; /* while_ultsivnx4bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10153; /* while_ultdivnx4bi_ptest */

    case 15:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10163; /* while_ultsivnx2bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10173; /* while_ultdivnx2bi_ptest */

    case 16:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10024; /* *while_ulesivnx16bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10034; /* *while_uledivnx16bi_cc */

    case 17:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10044; /* *while_ulesivnx8bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10054; /* *while_uledivnx8bi_cc */

    case 18:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10064; /* *while_ulesivnx4bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10074; /* *while_uledivnx4bi_cc */

    case 19:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10084; /* *while_ulesivnx2bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10094; /* *while_uledivnx2bi_cc */

    case 20:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10104; /* while_ulesivnx16bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10114; /* while_uledivnx16bi_ptest */

    case 21:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10124; /* while_ulesivnx8bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10134; /* while_uledivnx8bi_ptest */

    case 22:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10144; /* while_ulesivnx4bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10154; /* while_uledivnx4bi_ptest */

    case 23:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10164; /* while_ulesivnx2bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10174; /* while_uledivnx2bi_ptest */

    case 24:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10025; /* *while_ltsivnx16bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10035; /* *while_ltdivnx16bi_cc */

    case 25:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10045; /* *while_ltsivnx8bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10055; /* *while_ltdivnx8bi_cc */

    case 26:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10065; /* *while_ltsivnx4bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10075; /* *while_ltdivnx4bi_cc */

    case 27:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10085; /* *while_ltsivnx2bi_cc */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10095; /* *while_ltdivnx2bi_cc */

    case 28:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10105; /* while_ltsivnx16bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10115; /* while_ltdivnx16bi_ptest */

    case 29:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10125; /* while_ltsivnx8bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10135; /* while_ltdivnx8bi_ptest */

    case 30:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10145; /* while_ltsivnx4bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10155; /* while_ltdivnx4bi_ptest */

    case 31:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 10165; /* while_ltsivnx2bi_ptest */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10175; /* while_ltdivnx2bi_ptest */

    case 32:
      return recog_592 (x1, insn, pnum_clobbers);

    case 33:
      return recog_591 (x1, insn, pnum_clobbers);

    case 34:
      return recog_590 (x1, insn, pnum_clobbers);

    case 35:
      return recog_589 (x1, insn, pnum_clobbers);

    case 36:
      return recog_588 (x1, insn, pnum_clobbers);

    case 37:
      return recog_587 (x1, insn, pnum_clobbers);

    case 38:
      return recog_586 (x1, insn, pnum_clobbers);

    case 39:
      return recog_585 (x1, insn, pnum_clobbers);

    case 40:
      return recog_584 (x1, insn, pnum_clobbers);

    case 41:
      return recog_583 (x1, insn, pnum_clobbers);

    case 42:
      return recog_582 (x1, insn, pnum_clobbers);

    case 43:
      return recog_581 (x1, insn, pnum_clobbers);

    case 44:
      return recog_580 (x1, insn, pnum_clobbers);

    case 45:
      return recog_579 (x1, insn, pnum_clobbers);

    case 46:
      return recog_578 (x1, insn, pnum_clobbers);

    case 47:
      return recog_577 (x1, insn, pnum_clobbers);

    case 48:
      return recog_576 (x1, insn, pnum_clobbers);

    case 49:
      return recog_575 (x1, insn, pnum_clobbers);

    case 50:
      return recog_574 (x1, insn, pnum_clobbers);

    case 51:
      return recog_573 (x1, insn, pnum_clobbers);

    case 52:
      return recog_572 (x1, insn, pnum_clobbers);

    case 53:
      return recog_571 (x1, insn, pnum_clobbers);

    case 54:
      return recog_570 (x1, insn, pnum_clobbers);

    case 55:
      return recog_569 (x1, insn, pnum_clobbers);

    case 56:
      return recog_568 (x1, insn, pnum_clobbers);

    case 57:
      return recog_567 (x1, insn, pnum_clobbers);

    case 58:
      return recog_566 (x1, insn, pnum_clobbers);

    case 59:
      return recog_565 (x1, insn, pnum_clobbers);

    case 60:
      return recog_564 (x1, insn, pnum_clobbers);

    case 61:
      return recog_563 (x1, insn, pnum_clobbers);

    case 62:
      return recog_562 (x1, insn, pnum_clobbers);

    case 63:
      return recog_561 (x1, insn, pnum_clobbers);

    case 64:
      return recog_560 (x1, insn, pnum_clobbers);

    case 65:
      return recog_559 (x1, insn, pnum_clobbers);

    case 66:
      return recog_558 (x1, insn, pnum_clobbers);

    case 67:
      return recog_557 (x1, insn, pnum_clobbers);

    case 68:
      return recog_556 (x1, insn, pnum_clobbers);

    case 69:
      return recog_555 (x1, insn, pnum_clobbers);

    case 70:
      return recog_554 (x1, insn, pnum_clobbers);

    case 71:
      return recog_553 (x1, insn, pnum_clobbers);

    case 72:
      return recog_552 (x1, insn, pnum_clobbers);

    case 73:
      return recog_551 (x1, insn, pnum_clobbers);

    case 74:
      return recog_550 (x1, insn, pnum_clobbers);

    case 75:
      return recog_549 (x1, insn, pnum_clobbers);

    case 76:
      return recog_548 (x1, insn, pnum_clobbers);

    case 77:
      return recog_547 (x1, insn, pnum_clobbers);

    case 78:
      return recog_546 (x1, insn, pnum_clobbers);

    case 79:
      return recog_545 (x1, insn, pnum_clobbers);

    case 80:
      if (!
#line 10172 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10926; /* *aarch64_brkn_cc */

    case 81:
      if (!
#line 10196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10927; /* *aarch64_brkn_ptest */

    default:
      return -1;
    }
}

 int
recog_616 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (!memory_operand (x3, E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 0);
  if (!pmode_plus_operator (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x5, 1);
  x10 = XEXP (x9, 0);
  switch (GET_CODE (x10))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x1, 0, 0);
      x13 = XEXP (x12, 1);
      operands[7] = x13;
      operands[5] = x9;
      operands[6] = x3;
      operands[8] = x4;
      switch (XWINT (x11, 0))
        {
        case 4L:
          if (!aarch64_ldp_reg_operand (operands[2], E_SImode)
              || !aarch64_ldp_reg_operand (operands[3], E_SImode)
              || !
#line 2099 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)))
            return -1;
          return 93; /* *loadwb_post_pair_4 */

        case 8L:
          if (!aarch64_ldp_reg_operand (operands[2], E_DImode)
              || !aarch64_ldp_reg_operand (operands[3], E_DImode)
              || !
#line 2099 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)))
            return -1;
          return 94; /* *loadwb_post_pair_8 */

        case 16L:
          if (!aarch64_ldp_reg_operand (operands[2], E_TImode)
              || !aarch64_ldp_reg_operand (operands[3], E_TImode)
              || !
#line 2119 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && aarch64_mem_pair_offset (operands[4], TImode)))
            return -1;
          return 95; /* *loadwb_post_pair_16 */

        default:
          return -1;
        }

    case PLUS:
      operands[9] = x10;
      if (!pmode_plus_operator (operands[9], E_VOIDmode))
        return -1;
      x12 = XVECEXP (x1, 0, 0);
      x13 = XEXP (x12, 1);
      operands[8] = x13;
      operands[6] = x9;
      operands[7] = x3;
      operands[10] = x4;
      x11 = XEXP (x4, 1);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x14 = XEXP (x10, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      x15 = XEXP (x10, 1);
      if (!rtx_equal_p (x15, operands[4]))
        return -1;
      if (aarch64_ldp_reg_operand (operands[2], E_SImode)
          && aarch64_ldp_reg_operand (operands[3], E_SImode)
          && 
#line 2143 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (SImode))))
        return 96; /* *loadwb_pre_pair_4 */
      if (aarch64_ldp_reg_operand (operands[2], E_DImode)
          && aarch64_ldp_reg_operand (operands[3], E_DImode)
          && 
#line 2143 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (DImode))))
        return 97; /* *loadwb_pre_pair_8 */
      if (!aarch64_ldp_reg_operand (operands[2], E_TImode)
          || !aarch64_ldp_reg_operand (operands[3], E_TImode)
          || !
#line 2170 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && aarch64_mem_pair_offset (operands[4], TImode)
   && known_eq (INTVAL (operands[5]), INTVAL (operands[4]) + 16)))
        return -1;
      return 98; /* *loadwb_pre_pair_16 */

    default:
      return -1;
    }
}

 int
recog_619 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (pattern441 (x5, 
66, 
CLOBBER, 
E_CCmode) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 81
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x2, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x11 = XVECEXP (x7, 0, 0);
      operands[1] = x11;
      if (!aarch64_reg_or_zero (operands[1], E_QImode))
        return -1;
      x12 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      x13 = XEXP (x8, 0);
      if (!rtx_equal_p (x13, operands[0])
          || !
#line 1998 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
        return -1;
      return 86; /* *aarch64_setmemdi */

    case CALL:
      x14 = XEXP (x3, 0);
      if (GET_CODE (x14) != MEM
          || GET_MODE (x14) != E_DImode)
        return -1;
      x15 = XEXP (x3, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern348 (x4) != 0
          || pattern969 (x1) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      if (pattern1209 (x6, 
30) != 0)
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      switch (pattern1256 (x1))
        {
        case 0:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
            return -1;
          return 1119; /* *tlsgd_small_si */

        case 1:
          if (!
#line 164 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
            return -1;
          return 1120; /* *tlsgd_small_di */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x6 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x8 = XEXP (x6, 0);
      if (!scratch_operand (x8, E_SImode))
        return -1;
      switch (pattern561 (x1))
        {
        case 0:
          return 5358; /* aarch64_compare_and_swapqi */

        case 1:
          return 5359; /* aarch64_compare_and_swaphi */

        case 2:
          return 5360; /* aarch64_compare_and_swapsi */

        case 3:
          return 5361; /* aarch64_compare_and_swapdi */

        case 4:
          return 5362; /* aarch64_compare_and_swapti */

        case 5:
          return 5376; /* aarch64_atomic_addqi */

        case 6:
          return 5381; /* aarch64_atomic_addhi */

        case 7:
          return 5386; /* aarch64_atomic_addsi */

        case 8:
          return 5391; /* aarch64_atomic_adddi */

        case 9:
          return 5377; /* aarch64_atomic_subqi */

        case 10:
          return 5382; /* aarch64_atomic_subhi */

        case 11:
          return 5387; /* aarch64_atomic_subsi */

        case 12:
          return 5392; /* aarch64_atomic_subdi */

        case 13:
          return 5378; /* aarch64_atomic_orqi */

        case 14:
          return 5383; /* aarch64_atomic_orhi */

        case 15:
          return 5388; /* aarch64_atomic_orsi */

        case 16:
          return 5393; /* aarch64_atomic_ordi */

        case 17:
          return 5379; /* aarch64_atomic_xorqi */

        case 18:
          return 5384; /* aarch64_atomic_xorhi */

        case 19:
          return 5389; /* aarch64_atomic_xorsi */

        case 20:
          return 5394; /* aarch64_atomic_xordi */

        case 21:
          return 5380; /* aarch64_atomic_andqi */

        case 22:
          return 5385; /* aarch64_atomic_andhi */

        case 23:
          return 5390; /* aarch64_atomic_andsi */

        case 24:
          return 5395; /* aarch64_atomic_anddi */

        case 25:
          return 5412; /* atomic_nandqi */

        case 26:
          return 5413; /* atomic_nandhi */

        case 27:
          return 5414; /* atomic_nandsi */

        case 28:
          return 5415; /* atomic_nanddi */

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x3;
      if (pattern40 (x1, 
28, 
2) != 0)
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      x4 = XVECEXP (x1, 0, 1);
      x16 = XEXP (x4, 1);
      x17 = XVECEXP (x16, 0, 0);
      operands[2] = x17;
      x18 = XVECEXP (x16, 0, 1);
      operands[3] = x18;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x8 = XEXP (x6, 0);
      operands[4] = x8;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      switch (pattern1287 (x4))
        {
        case 0:
          if (!
#line 227 "../../gcc/config/aarch64/atomics.md"
(!TARGET_LSE))
            return -1;
          return 5368; /* aarch64_atomic_exchangeqi */

        case 1:
          if (!
#line 227 "../../gcc/config/aarch64/atomics.md"
(!TARGET_LSE))
            return -1;
          return 5369; /* aarch64_atomic_exchangehi */

        case 2:
          if (!
#line 227 "../../gcc/config/aarch64/atomics.md"
(!TARGET_LSE))
            return -1;
          return 5370; /* aarch64_atomic_exchangesi */

        case 3:
          if (!
#line 227 "../../gcc/config/aarch64/atomics.md"
(!TARGET_LSE))
            return -1;
          return 5371; /* aarch64_atomic_exchangedi */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern352 (x1))
        {
        case 0:
          return 5456; /* aarch64_atomic_add_fetchqi */

        case 1:
          return 5461; /* aarch64_atomic_add_fetchhi */

        case 2:
          return 5466; /* aarch64_atomic_add_fetchsi */

        case 3:
          return 5471; /* aarch64_atomic_add_fetchdi */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern352 (x1))
        {
        case 0:
          return 5457; /* aarch64_atomic_sub_fetchqi */

        case 1:
          return 5462; /* aarch64_atomic_sub_fetchhi */

        case 2:
          return 5467; /* aarch64_atomic_sub_fetchsi */

        case 3:
          return 5472; /* aarch64_atomic_sub_fetchdi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern353 (x1))
        {
        case 0:
          return 5458; /* aarch64_atomic_or_fetchqi */

        case 1:
          return 5463; /* aarch64_atomic_or_fetchhi */

        case 2:
          return 5468; /* aarch64_atomic_or_fetchsi */

        case 3:
          return 5473; /* aarch64_atomic_or_fetchdi */

        default:
          return -1;
        }

    case XOR:
      switch (pattern353 (x1))
        {
        case 0:
          return 5459; /* aarch64_atomic_xor_fetchqi */

        case 1:
          return 5464; /* aarch64_atomic_xor_fetchhi */

        case 2:
          return 5469; /* aarch64_atomic_xor_fetchsi */

        case 3:
          return 5474; /* aarch64_atomic_xor_fetchdi */

        default:
          return -1;
        }

    case AND:
      switch (pattern353 (x1))
        {
        case 0:
          return 5460; /* aarch64_atomic_and_fetchqi */

        case 1:
          return 5465; /* aarch64_atomic_and_fetchhi */

        case 2:
          return 5470; /* aarch64_atomic_and_fetchsi */

        case 3:
          return 5475; /* aarch64_atomic_and_fetchdi */

        default:
          return -1;
        }

    case NOT:
      x14 = XEXP (x3, 0);
      if (GET_CODE (x14) != AND
          || pattern40 (x1, 
31, 
3) != 0)
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      x19 = XEXP (x14, 0);
      operands[1] = x19;
      x20 = XEXP (x14, 1);
      operands[2] = x20;
      x4 = XVECEXP (x1, 0, 1);
      x16 = XEXP (x4, 1);
      x21 = XVECEXP (x16, 0, 2);
      operands[3] = x21;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x8 = XEXP (x6, 0);
      operands[4] = x8;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      switch (pattern1182 (x1))
        {
        case 0:
          return 5476; /* atomic_nand_fetchqi */

        case 1:
          return 5477; /* atomic_nand_fetchhi */

        case 2:
          return 5478; /* atomic_nand_fetchsi */

        case 3:
          return 5479; /* atomic_nand_fetchdi */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3)
        return -1;
      x22 = XVECEXP (x3, 0, 2);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x16 = XEXP (x4, 1);
      if (GET_CODE (x16) != UNSPEC
          || XVECLEN (x16, 0) != 3)
        return -1;
      x21 = XVECEXP (x16, 0, 2);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != SET)
        return -1;
      x23 = XEXP (x5, 1);
      if (GET_CODE (x23) != UNSPEC
          || XVECLEN (x23, 0) != 3)
        return -1;
      x24 = XVECEXP (x23, 0, 2);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 3)
        return -1;
      x25 = XVECEXP (x7, 0, 2);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      x26 = XVECEXP (x3, 0, 0);
      operands[5] = x26;
      if (!register_operand (operands[5], E_VNx16BImode))
        return -1;
      x27 = XVECEXP (x3, 0, 1);
      operands[4] = x27;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x28 = XEXP (x5, 0);
      operands[2] = x28;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x17 = XVECEXP (x16, 0, 0);
      if (!rtx_equal_p (x17, operands[5]))
        return -1;
      x18 = XVECEXP (x16, 0, 1);
      if (!rtx_equal_p (x18, operands[4]))
        return -1;
      x29 = XVECEXP (x23, 0, 0);
      if (!rtx_equal_p (x29, operands[5]))
        return -1;
      x30 = XVECEXP (x23, 0, 1);
      if (!rtx_equal_p (x30, operands[4]))
        return -1;
      x11 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x11, operands[5]))
        return -1;
      x12 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x12, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 470:
          switch (pattern1354 (x1, 
470))
            {
            case 0:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11165; /* aarch64_ld1vnx64qi_strided4 */

            case 1:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11167; /* aarch64_ld1vnx32hi_strided4 */

            case 2:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11169; /* aarch64_ld1vnx16si_strided4 */

            case 3:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11171; /* aarch64_ld1vnx8di_strided4 */

            case 4:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11173; /* aarch64_ld1vnx32bf_strided4 */

            case 5:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11175; /* aarch64_ld1vnx32hf_strided4 */

            case 6:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11177; /* aarch64_ld1vnx16sf_strided4 */

            case 7:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11179; /* aarch64_ld1vnx8df_strided4 */

            default:
              return -1;
            }

        case 471:
          switch (pattern1354 (x1, 
471))
            {
            case 0:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11166; /* aarch64_ldnt1vnx64qi_strided4 */

            case 1:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11168; /* aarch64_ldnt1vnx32hi_strided4 */

            case 2:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11170; /* aarch64_ldnt1vnx16si_strided4 */

            case 3:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11172; /* aarch64_ldnt1vnx8di_strided4 */

            case 4:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11174; /* aarch64_ldnt1vnx32bf_strided4 */

            case 5:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11176; /* aarch64_ldnt1vnx32hf_strided4 */

            case 6:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11178; /* aarch64_ldnt1vnx16sf_strided4 */

            case 7:
              if (!
#line 323 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 4, 4)))
                return -1;
              return 11180; /* aarch64_ldnt1vnx8df_strided4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern585 (x2))
    {
    case 0:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_535 (insn, operands);

    case 1:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_537 (insn, operands);

    case 2:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_539 (insn, operands);

    case 3:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_541 (insn, operands);

    case 4:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_543 (insn, operands);

    case 5:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_545 (insn, operands);

    case 6:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_547 (insn, operands);

    case 7:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_549 (insn, operands);

    case 8:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_551 (insn, operands);

    case 9:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_553 (insn, operands);

    case 10:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_555 (insn, operands);

    case 11:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_557 (insn, operands);

    case 12:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_559 (insn, operands);

    case 13:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_561 (insn, operands);

    case 14:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_563 (insn, operands);

    case 15:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_565 (insn, operands);

    case 16:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_567 (insn, operands);

    case 17:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_569 (insn, operands);

    case 18:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_571 (insn, operands);

    case 19:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_573 (insn, operands);

    case 20:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_575 (insn, operands);

    case 21:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_577 (insn, operands);

    case 22:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_579 (insn, operands);

    case 23:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_581 (insn, operands);

    case 24:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_583 (insn, operands);

    case 25:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_585 (insn, operands);

    case 26:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_587 (insn, operands);

    case 27:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_589 (insn, operands);

    case 28:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_591 (insn, operands);

    case 29:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_593 (insn, operands);

    case 30:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_595 (insn, operands);

    case 31:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_597 (insn, operands);

    case 32:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_599 (insn, operands);

    case 33:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_601 (insn, operands);

    case 34:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_603 (insn, operands);

    case 35:
      if (!(
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 1353 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_605 (insn, operands);

    case 36:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_679 (insn, operands);

    case 37:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_683 (insn, operands);

    case 38:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_687 (insn, operands);

    case 39:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_691 (insn, operands);

    case 40:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_695 (insn, operands);

    case 41:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_699 (insn, operands);

    case 42:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_703 (insn, operands);

    case 43:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_707 (insn, operands);

    case 44:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_711 (insn, operands);

    case 45:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_715 (insn, operands);

    case 46:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_719 (insn, operands);

    case 47:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_723 (insn, operands);

    case 48:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_727 (insn, operands);

    case 49:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_731 (insn, operands);

    case 50:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_735 (insn, operands);

    case 51:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_739 (insn, operands);

    case 52:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_743 (insn, operands);

    case 53:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_747 (insn, operands);

    case 54:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_751 (insn, operands);

    case 55:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_755 (insn, operands);

    case 56:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_759 (insn, operands);

    case 57:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_763 (insn, operands);

    case 58:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_767 (insn, operands);

    case 59:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_771 (insn, operands);

    case 60:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_775 (insn, operands);

    case 61:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_779 (insn, operands);

    case 62:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_783 (insn, operands);

    case 63:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_787 (insn, operands);

    case 64:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_791 (insn, operands);

    case 65:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_795 (insn, operands);

    case 66:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_799 (insn, operands);

    case 67:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_803 (insn, operands);

    case 68:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_807 (insn, operands);

    case 69:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_811 (insn, operands);

    case 70:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_815 (insn, operands);

    case 71:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_819 (insn, operands);

    case 72:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_680 (insn, operands);

    case 73:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_684 (insn, operands);

    case 74:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_688 (insn, operands);

    case 75:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_692 (insn, operands);

    case 76:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_696 (insn, operands);

    case 77:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_700 (insn, operands);

    case 78:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_704 (insn, operands);

    case 79:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_708 (insn, operands);

    case 80:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_712 (insn, operands);

    case 81:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_716 (insn, operands);

    case 82:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_720 (insn, operands);

    case 83:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_724 (insn, operands);

    case 84:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_728 (insn, operands);

    case 85:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_732 (insn, operands);

    case 86:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_736 (insn, operands);

    case 87:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_740 (insn, operands);

    case 88:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_744 (insn, operands);

    case 89:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_748 (insn, operands);

    case 90:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_752 (insn, operands);

    case 91:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_756 (insn, operands);

    case 92:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_760 (insn, operands);

    case 93:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_764 (insn, operands);

    case 94:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_768 (insn, operands);

    case 95:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_772 (insn, operands);

    case 96:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_776 (insn, operands);

    case 97:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_780 (insn, operands);

    case 98:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_784 (insn, operands);

    case 99:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_788 (insn, operands);

    case 100:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_792 (insn, operands);

    case 101:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_796 (insn, operands);

    case 102:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_800 (insn, operands);

    case 103:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_804 (insn, operands);

    case 104:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_808 (insn, operands);

    case 105:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_812 (insn, operands);

    case 106:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_816 (insn, operands);

    case 107:
      if (!(
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1439 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_820 (insn, operands);

    case 108:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_607 (insn, operands);

    case 109:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_609 (insn, operands);

    case 110:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_611 (insn, operands);

    case 111:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_613 (insn, operands);

    case 112:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_615 (insn, operands);

    case 113:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_617 (insn, operands);

    case 114:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_619 (insn, operands);

    case 115:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_621 (insn, operands);

    case 116:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_623 (insn, operands);

    case 117:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_625 (insn, operands);

    case 118:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_627 (insn, operands);

    case 119:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_629 (insn, operands);

    case 120:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_631 (insn, operands);

    case 121:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_633 (insn, operands);

    case 122:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_635 (insn, operands);

    case 123:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_637 (insn, operands);

    case 124:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_639 (insn, operands);

    case 125:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_641 (insn, operands);

    case 126:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_643 (insn, operands);

    case 127:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_645 (insn, operands);

    case 128:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_647 (insn, operands);

    case 129:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_649 (insn, operands);

    case 130:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_651 (insn, operands);

    case 131:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_653 (insn, operands);

    case 132:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_655 (insn, operands);

    case 133:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_657 (insn, operands);

    case 134:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_659 (insn, operands);

    case 135:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_661 (insn, operands);

    case 136:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_663 (insn, operands);

    case 137:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_665 (insn, operands);

    case 138:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_667 (insn, operands);

    case 139:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_669 (insn, operands);

    case 140:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_671 (insn, operands);

    case 141:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_673 (insn, operands);

    case 142:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_675 (insn, operands);

    case 143:
      if (!(
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 1373 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_677 (insn, operands);

    case 144:
      if (!(
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0) && 
#line 1680 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_847 (insn, operands);

    case 145:
      if (!(
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0) && 
#line 1680 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_851 (insn, operands);

    case 146:
      if (!(
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0) && 
#line 1680 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_849 (insn, operands);

    case 147:
      if (!(
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0) && 
#line 1680 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_853 (insn, operands);

    case 148:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_855 (insn, operands);

    case 149:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_861 (insn, operands);

    case 150:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_867 (insn, operands);

    case 151:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_857 (insn, operands);

    case 152:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_863 (insn, operands);

    case 153:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_869 (insn, operands);

    case 154:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_859 (insn, operands);

    case 155:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_865 (insn, operands);

    case 156:
      if (!(
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1716 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_871 (insn, operands);

    case 157:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_873 (insn, operands);

    case 158:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_885 (insn, operands);

    case 159:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_897 (insn, operands);

    case 160:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_877 (insn, operands);

    case 161:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_889 (insn, operands);

    case 162:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_901 (insn, operands);

    case 163:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_881 (insn, operands);

    case 164:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_893 (insn, operands);

    case 165:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_905 (insn, operands);

    case 166:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_909 (insn, operands);

    case 167:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_915 (insn, operands);

    case 168:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_921 (insn, operands);

    case 169:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_911 (insn, operands);

    case 170:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_917 (insn, operands);

    case 171:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_923 (insn, operands);

    case 172:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_913 (insn, operands);

    case 173:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_919 (insn, operands);

    case 174:
      if (!(
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1789 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_925 (insn, operands);

    case 175:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_875 (insn, operands);

    case 176:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_887 (insn, operands);

    case 177:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_899 (insn, operands);

    case 178:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_879 (insn, operands);

    case 179:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_891 (insn, operands);

    case 180:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_903 (insn, operands);

    case 181:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_883 (insn, operands);

    case 182:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_895 (insn, operands);

    case 183:
      if (!(
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1751 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_907 (insn, operands);

    case 184:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_927 (insn, operands);

    case 185:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_933 (insn, operands);

    case 186:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_939 (insn, operands);

    case 187:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_929 (insn, operands);

    case 188:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_935 (insn, operands);

    case 189:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_941 (insn, operands);

    case 190:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_931 (insn, operands);

    case 191:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_937 (insn, operands);

    case 192:
      if (!(
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 1824 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_943 (insn, operands);

    case 193:
      if (!(
#line 1976 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1991 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_947 (insn, operands);

    case 194:
      if (!(
#line 1976 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1991 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_949 (insn, operands);

    case 195:
      if (!(
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2025 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_951 (insn, operands);

    case 196:
      if (!(
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2025 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_953 (insn, operands);

    case 197:
      if (!(
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2025 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return NULL;
      return gen_split_955 (insn, operands);

    case 198:
      if (!(
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2059 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_957 (insn, operands);

    case 199:
      if (!(
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2059 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_959 (insn, operands);

    case 200:
      if (!(
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2059 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[6]) || !CONSTANT_P (operands[7])))))
        return NULL;
      return gen_split_961 (insn, operands);

    case 201:
      if (!(
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2091 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_963 (insn, operands);

    case 202:
      if (!(
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2091 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_965 (insn, operands);

    case 203:
      if (!(
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2091 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[7]))))
        return NULL;
      return gen_split_967 (insn, operands);

    case 204:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2738 (insn, operands);

    case 205:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2740 (insn, operands);

    case 206:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2742 (insn, operands);

    case 207:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2744 (insn, operands);

    case 208:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2746 (insn, operands);

    case 209:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2748 (insn, operands);

    case 210:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2750 (insn, operands);

    case 211:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2752 (insn, operands);

    case 212:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2754 (insn, operands);

    case 213:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2756 (insn, operands);

    case 214:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2758 (insn, operands);

    case 215:
      if (!(
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0) && 
#line 406 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return NULL;
      return gen_split_2760 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 272:
      switch (pattern366 (x3))
        {
        case 0:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 1:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_209 (insn, operands);

        case 2:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 3:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_211 (insn, operands);

        case 4:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_212 (insn, operands);

        case 5:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_213 (insn, operands);

        case 6:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 7:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_215 (insn, operands);

        case 8:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 9:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_217 (insn, operands);

        case 10:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_218 (insn, operands);

        case 11:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_219 (insn, operands);

        case 12:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_220 (insn, operands);

        case 13:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_221 (insn, operands);

        case 14:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 15:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_223 (insn, operands);

        case 16:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_224 (insn, operands);

        case 17:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_225 (insn, operands);

        case 18:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_226 (insn, operands);

        case 19:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 20:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_228 (insn, operands);

        case 21:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_229 (insn, operands);

        case 22:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_230 (insn, operands);

        case 23:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 24:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_232 (insn, operands);

        case 25:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_233 (insn, operands);

        case 26:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_234 (insn, operands);

        case 27:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 28:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_236 (insn, operands);

        case 29:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_237 (insn, operands);

        case 30:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_238 (insn, operands);

        case 31:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_239 (insn, operands);

        case 32:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_240 (insn, operands);

        case 33:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_241 (insn, operands);

        case 34:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_242 (insn, operands);

        case 35:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_243 (insn, operands);

        case 36:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_244 (insn, operands);

        case 37:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_245 (insn, operands);

        case 38:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_246 (insn, operands);

        case 39:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_247 (insn, operands);

        case 40:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_248 (insn, operands);

        case 41:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_249 (insn, operands);

        case 42:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_250 (insn, operands);

        case 43:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_251 (insn, operands);

        case 44:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_252 (insn, operands);

        case 45:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_253 (insn, operands);

        case 46:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_254 (insn, operands);

        case 47:
          if (!(
#line 7729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7731 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_255 (insn, operands);

        default:
          return NULL;
        }

    case 245:
      if (GET_MODE (x3) != E_V2x16QImode
          || !register_operand (operands[0], E_V2x16QImode))
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode))
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V16QImode)
          || !(
#line 8416 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 8418 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
        return NULL;
      return gen_split_308 (insn, operands);

    case 125:
      return split_5 (x1, insn);

    case 152:
      switch (pattern367 (x3))
        {
        case 0:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_415 (insn, operands);

        case 1:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_416 (insn, operands);

        case 2:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_417 (insn, operands);

        case 3:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_418 (insn, operands);

        case 4:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_419 (insn, operands);

        case 5:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_420 (insn, operands);

        case 6:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_421 (insn, operands);

        case 7:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_422 (insn, operands);

        case 8:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_423 (insn, operands);

        case 9:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_424 (insn, operands);

        case 10:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_425 (insn, operands);

        case 11:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_426 (insn, operands);

        case 12:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_427 (insn, operands);

        case 13:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_428 (insn, operands);

        case 14:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_429 (insn, operands);

        case 15:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_430 (insn, operands);

        case 16:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_431 (insn, operands);

        case 17:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_432 (insn, operands);

        case 18:
          if (!(
#line 776 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN) && 
#line 778 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_433 (insn, operands);

        default:
          return NULL;
        }

    case 297:
      if (GET_MODE (x3) != E_VNx2DImode)
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x5) != UNSPEC
          || pattern592 (x5) != 0
          || !register_operand (operands[0], E_VNx2DImode))
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx2DImode))
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_VNx2DImode)
          || !(
#line 4148 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4150 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
        return NULL;
      return gen_split_1382 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      switch (pattern48 (x3))
        {
        case 0:
          return gen_split_23 (insn, operands);

        case 1:
          return gen_split_24 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          switch (pattern443 (x3))
            {
            case 0:
              if (!
#line 5125 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_39 (insn, operands);

            case 1:
              if (!
#line 5125 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_43 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern444 (x3))
            {
            case 0:
              if (!
#line 5147 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (IOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (!
#line 5147 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (IOR != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_51 (insn, operands);

            case 2:
              if (!
#line 5176 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (IOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_55 (insn, operands);

            case 3:
              if (!
#line 5176 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (IOR != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_59 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != UNSPEC
              || pattern571 (x6) != 0)
            return NULL;
          switch (pattern1025 (x3))
            {
            case 0:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx16QImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2962 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2963 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx16QImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2970 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2971 (insn, operands);

            case 1:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx8HImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2964 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2965 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx8HImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2972 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2973 (insn, operands);

            case 2:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx4SImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2966 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2967 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx4SImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2974 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2975 (insn, operands);

            case 3:
              x7 = XVECEXP (x6, 0, 1);
              x8 = XEXP (x7, 0);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (register_operand (operands[3], E_VNx2DImode))
                {
                  x10 = XEXP (x7, 1);
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2968 (insn, operands);
                  if (rtx_equal_p (x11, operands[2])
                      && (
#line 1850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1855 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return gen_split_2969 (insn, operands);
                }
              x10 = XEXP (x7, 1);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!register_operand (operands[3], E_VNx2DImode))
                return NULL;
              if (rtx_equal_p (x9, operands[1])
                  && (
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return gen_split_2976 (insn, operands);
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 1877 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1882 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                return NULL;
              return gen_split_2977 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern358 (x3))
        {
        case 0:
          if (!
#line 5199 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_63 (insn, operands);

        case 1:
          if (!
#line 5199 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_66 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_129 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2419 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2429 (insn, operands);
}

 rtx_insn *
split_137 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern341 (x1))
        {
        case 0:
          if (!(
#line 4423 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4427 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 1:
          if (!(
#line 4423 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4427 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern341 (x1))
        {
        case 0:
          if (!(
#line 4423 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4427 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_20 (insn, operands);

        case 1:
          if (!(
#line 4423 "../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4427 "../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_22 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern362 (x1, 
E_CCmode, 
66, 
CLOBBER) != 0)
        return NULL;
      x4 = XEXP (x3, 1);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SMAX:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_28 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_32 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_29 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_33 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_30 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_34 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_31 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 4966 "../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CC_NZVmode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern701 (x1, 
CLOBBER, 
E_CC_NZVmode) != 0)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (!register_operand (x7, E_SImode))
        return NULL;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          operands[1] = x9;
          operands[2] = x7;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !aarch64_mov_imm_operand (operands[1], E_SImode))
                return NULL;
              return gen_split_72 (insn, operands);

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !aarch64_mov_imm_operand (operands[1], E_DImode))
                return NULL;
              return gen_split_73 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_74 (insn, operands);

            case 1:
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_75 (insn, operands);

            case 1:
              return gen_split_80 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_76 (insn, operands);

            case 1:
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        case ROTATERT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_77 (insn, operands);

            case 1:
              return gen_split_82 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_78 (insn, operands);

            case 1:
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NEG:
      switch (pattern342 (x1))
        {
        case 0:
          if (!(
#line 7012 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 1:
          if (!(
#line 7012 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 2:
          if (!(
#line 7012 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 3:
          if (!(
#line 7012 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 4:
          if (!(
#line 7012 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 5:
          if (!(
#line 7075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 6:
          if (!(
#line 7075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 7075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 8:
          if (!(
#line 7075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 7163 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7165 "../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 127
          || pattern547 (x2) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 2);
      if (XWINT (x10, 0) == 1L)
        {
          x11 = XVECEXP (x3, 0, 3);
          switch (GET_CODE (x11))
            {
            case CONST:
              switch (pattern1077 (x1))
                {
                case 0:
                  if ((
#line 983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 987 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_525 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1035 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_529 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case SUBREG:
              switch (pattern1079 (x1))
                {
                case 0:
                  if ((
#line 1009 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_526 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1009 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_527 (insn, operands);
                  break;

                case 2:
                  if ((
#line 1009 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_528 (insn, operands);
                  break;

                case 3:
                  if ((
#line 1061 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_530 (insn, operands);
                  break;

                case 4:
                  if ((
#line 1061 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_531 (insn, operands);
                  break;

                case 5:
                  if ((
#line 1061 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_532 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case UNSPEC:
              res = split_132 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
        }
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 3)
        return NULL;
      x12 = XVECEXP (x3, 0, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !aarch64_sve_ptrue_flag (x10, E_SImode))
        return NULL;
      x13 = XVECEXP (x11, 0, 1);
      if (!aarch64_sve_ptrue_flag (x13, E_SImode))
        return NULL;
      return split_135 (x1, insn);

    case VEC_DUPLICATE:
      switch (pattern347 (x1))
        {
        case 0:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1000 (insn, operands);

        case 1:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1019 (insn, operands);

        case 2:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1001 (insn, operands);

        case 3:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1002 (insn, operands);

        case 4:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1003 (insn, operands);

        case 5:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1004 (insn, operands);

        case 6:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1020 (insn, operands);

        case 7:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1005 (insn, operands);

        case 8:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1006 (insn, operands);

        case 9:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1007 (insn, operands);

        case 10:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1021 (insn, operands);

        case 11:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1008 (insn, operands);

        case 12:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1009 (insn, operands);

        case 13:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1022 (insn, operands);

        case 14:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1010 (insn, operands);

        case 15:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1024 (insn, operands);

        case 16:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1011 (insn, operands);

        case 17:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1012 (insn, operands);

        case 18:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1013 (insn, operands);

        case 19:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1023 (insn, operands);

        case 20:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1014 (insn, operands);

        case 21:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1015 (insn, operands);

        case 22:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1016 (insn, operands);

        case 23:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1025 (insn, operands);

        case 24:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1017 (insn, operands);

        case 25:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1018 (insn, operands);

        case 26:
          if (!(
#line 2732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1026 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      return split_136 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V16QImode))
    {
      switch (pattern921 (
E_V16QImode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_92 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_93 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_94 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_95 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_96 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_97 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_98 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_99 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode))
    return NULL;
  switch (pattern975 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_156 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_157 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_158 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_159 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_160 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_161 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_162 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_163 (insn, operands);

    default:
      return NULL;
    }
}
