/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_rshift_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !aarch64_fp_pow2 (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !aarch64_fp_pow2 (operands[2], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  if (!subreg_lowpart_operator (operands[4], E_VOIDmode))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NEG)
    return -1;
  return pattern16 (x1); /* [-1, 1] */
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      return pattern23 (x3); /* [-1, 3] */

    case VEC_DUPLICATE:
      res = pattern24 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[3] = x8;
  switch (XWINT (x5, 0))
    {
    case 8L:
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!register_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case 16L:
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case 32L:
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!aarch64_sync_memory_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!aarch64_sync_memory_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!aarch64_sync_memory_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!aarch64_sync_memory_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 15
      || pattern63 (x1, 
E_DImode, 
15) != 0)
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern55 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern55 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern55 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern55 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern55 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern55 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern55 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_QImode:
      if (pattern55 (x3, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_HImode:
      if (pattern55 (x3, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern55 (x3, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_DImode:
      if (pattern55 (x3, 
E_DImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern55 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern55 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern55 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern55 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern55 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern55 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern55 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_V4HFmode:
      if (pattern55 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 7;

    case E_V8HFmode:
      if (pattern55 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 8;

    case E_V4BFmode:
      if (pattern55 (x3, 
E_V4BFmode) != 0)
        return -1;
      return 9;

    case E_V8BFmode:
      if (pattern55 (x3, 
E_V8BFmode) != 0)
        return -1;
      return 10;

    case E_V2SFmode:
      if (pattern55 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 11;

    case E_V4SFmode:
      if (pattern55 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 12;

    case E_V2DFmode:
      if (pattern55 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 13;

    case E_VNx16QImode:
      if (pattern55 (x3, 
E_VNx16QImode) != 0)
        return -1;
      return 14;

    case E_VNx8QImode:
      if (pattern55 (x3, 
E_VNx8QImode) != 0)
        return -1;
      return 15;

    case E_VNx4QImode:
      if (pattern55 (x3, 
E_VNx4QImode) != 0)
        return -1;
      return 16;

    case E_VNx2QImode:
      if (pattern55 (x3, 
E_VNx2QImode) != 0)
        return -1;
      return 17;

    case E_VNx8HImode:
      if (pattern55 (x3, 
E_VNx8HImode) != 0)
        return -1;
      return 18;

    case E_VNx4HImode:
      if (pattern55 (x3, 
E_VNx4HImode) != 0)
        return -1;
      return 19;

    case E_VNx2HImode:
      if (pattern55 (x3, 
E_VNx2HImode) != 0)
        return -1;
      return 20;

    case E_VNx4SImode:
      if (pattern55 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 21;

    case E_VNx2SImode:
      if (pattern55 (x3, 
E_VNx2SImode) != 0)
        return -1;
      return 22;

    case E_VNx2DImode:
      if (pattern55 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 23;

    case E_VNx8HFmode:
      if (pattern55 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 24;

    case E_VNx4HFmode:
      if (pattern55 (x3, 
E_VNx4HFmode) != 0)
        return -1;
      return 25;

    case E_VNx2HFmode:
      if (pattern55 (x3, 
E_VNx2HFmode) != 0)
        return -1;
      return 26;

    case E_VNx8BFmode:
      if (pattern55 (x3, 
E_VNx8BFmode) != 0)
        return -1;
      return 27;

    case E_VNx4BFmode:
      if (pattern55 (x3, 
E_VNx4BFmode) != 0)
        return -1;
      return 28;

    case E_VNx2BFmode:
      if (pattern55 (x3, 
E_VNx2BFmode) != 0)
        return -1;
      return 29;

    case E_VNx4SFmode:
      if (pattern55 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 30;

    case E_VNx2SFmode:
      if (pattern55 (x3, 
E_VNx2SFmode) != 0)
        return -1;
      return 31;

    case E_VNx2DFmode:
      if (pattern55 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 32;

    case E_VNx16BImode:
      if (pattern55 (x3, 
E_VNx16BImode) != 0)
        return -1;
      return 33;

    case E_VNx8BImode:
      if (pattern55 (x3, 
E_VNx8BImode) != 0)
        return -1;
      return 34;

    case E_VNx4BImode:
      if (pattern55 (x3, 
E_VNx4BImode) != 0)
        return -1;
      return 35;

    case E_VNx2BImode:
      if (pattern55 (x3, 
E_VNx2BImode) != 0)
        return -1;
      return 36;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern104 (x3); /* [-1, 2] */
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !aligned_register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8SImode:
          if (!aligned_register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 1;

        case E_VNx8DImode:
          if (!aligned_register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern147 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_qi (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern153 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_hi (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 86
      || GET_MODE (x3) != E_VNx16BImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return 0;

    case E_VNx8HImode:
      return 1;

    case E_VNx4SImode:
      return 2;

    case E_VNx2DImode:
      return 3;

    case E_VNx8BFmode:
      return 4;

    case E_VNx8HFmode:
      return 5;

    case E_VNx4SFmode:
      return 6;

    case E_VNx2DFmode:
      return 7;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16BImode))
    return -1;
  return 0;
}

int
pattern182 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx8HFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (!register_operand (x5, E_VNx4SFmode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      operands[3] = x5;
      return 0;

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 167
          || GET_MODE (x6) != E_VNx8HFmode)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      operands[4] = x5;
      return 1;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_V16QImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 0);
  operands[4] = x6;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || pattern205 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_register (operands[2], i1)
      || !aarch64_simd_register (operands[3], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_VNx16QImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 93
      || GET_MODE (x2) != E_VNx16QImode)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[1], E_VNx8SFmode))
            return -1;
          return 0;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[1], E_VNx16SFmode))
            return -1;
          return 1;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[1], E_VNx4DFmode))
            return -1;
          return 2;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[1], E_VNx8DFmode))
            return -1;
          return 3;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[1], E_VNx16HFmode))
            return -1;
          return 4;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[1], E_VNx32HFmode))
            return -1;
          return 5;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[1], E_VNx16BFmode))
            return -1;
          return 6;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[1], E_VNx32BFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[2], E_VNx8SFmode))
            return -1;
          return 8;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[2], E_VNx16SFmode))
            return -1;
          return 9;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[2], E_VNx4DFmode))
            return -1;
          return 10;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[2], E_VNx8DFmode))
            return -1;
          return 11;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[2], E_VNx16HFmode))
            return -1;
          return 12;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[2], E_VNx32HFmode))
            return -1;
          return 13;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[2], E_VNx16BFmode))
            return -1;
          return 14;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[2], E_VNx32BFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern256 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93
      || GET_MODE (x3) != E_VNx4SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93
      || GET_MODE (x5) != E_VNx4SImode)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  if (!register_operand (operands[1], E_VNx4BImode))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  if (!register_operand (operands[2], E_VNx4BImode))
    return -1;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  if (!register_operand (operands[3], E_VNx4SImode))
    return -1;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  if (!register_operand (operands[4], E_VNx4SImode))
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern268 (x2, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern268 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern268 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern268 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx1TImode:
          if (pattern268 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern269 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 5;

        case E_VNx8HImode:
          if (pattern269 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern269 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2DImode:
          if (pattern269 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx1TImode:
          if (pattern269 (x2, 
E_VNx1TImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern287 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern287 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern287 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1
      || !register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern300 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              return pattern301 (x1, 
E_SImode); /* [-1, 2] */

            case E_DImode:
              res = pattern301 (x1, 
E_DImode);
              if (res >= 0)
                return res + 3; /* [3, 5] */
              return -1;

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern302 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
                return -1;
              return 6;

            case E_V4SImode:
              if (pattern302 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
                return -1;
              return 7;

            case E_V2DImode:
              if (pattern302 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern303 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V4SImode:
          if (pattern303 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (pattern303 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern318 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern318 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern318 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern318 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern346 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return pattern345 (x1); /* [-1, 3] */
}

int
pattern355 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_hi_half (operands[2], i1))
    return -1;
  return 0;
}

int
pattern358 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  return pattern357 (x1); /* [-1, 1] */
}

int
pattern361 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern373 (x1, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern373 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern373 (x1, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern378 (x1); /* [-1, 1] */
}

int
pattern381 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern386 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern390 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern392 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x3, 0, 0);
  operands[4] = x5;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x1, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern390 (x1, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern390 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern390 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern390 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case XOR:
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern391 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern391 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern391 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 6;

        case E_VNx2DImode:
          if (pattern391 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern405 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern409 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern409 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern409 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !aarch64_simd_reg_or_zero (operands[2], E_V8QImode)
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HImode))
            return -1;
          return 1;

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DFmode)
          || !aarch64_simd_reg_or_zero (operands[2], E_DFmode)
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern442 (rtx x1, unsigned int i1, rtx_code i2, unsigned int i3, machine_mode i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i5
      || GET_MODE (x3) != i4)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern441 (x6, 
i1, 
i2, 
E_DImode); /* [-1, 0] */
}

int
pattern447 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern453 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern456 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern462 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XVECEXP (x1, 0, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern458 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8QImode:
          if (pattern458 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4QImode:
          if (pattern458 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2QImode:
          if (pattern458 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern458 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern458 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2HImode:
          if (pattern458 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern458 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2SImode:
          if (pattern458 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx2DImode:
          if (pattern458 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        case E_V2DImode:
          if (pattern458 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case UNSPEC:
      res = pattern461 (x1, 
SMAX);
      if (res >= 0)
        return res + 11; /* [11, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern477 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern482 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern487 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          return pattern485 (x1, 
E_V2SImode, 
E_V8QImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern485 (x1, 
E_V4SImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (!register_operand (operands[0], E_VNx4SImode)
              || GET_MODE (x1) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode
              || !register_operand (operands[3], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[1], E_VNx16QImode)
                  || !register_operand (operands[2], E_VNx16QImode))
                return -1;
              return 2;

            case E_VNx8HImode:
              if (!register_operand (operands[1], E_VNx8HImode)
                  || !register_operand (operands[2], E_VNx8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_VNx2DImode:
          if (pattern485 (x1, 
E_VNx2DImode, 
E_VNx8HImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 167)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x1, 1);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          res = pattern486 (x1, 
E_VNx4SImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        case E_VNx2DImode:
          res = pattern486 (x1, 
E_VNx2DImode);
          if (res >= 0)
            return res + 7; /* [7, 8] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern405 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern405 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern405 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern405 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern405 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern523 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern529 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern535 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern541 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern540 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern540 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern540 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern548 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_VNx32BImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_NZCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_VNx32BImode))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[1] = x9;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x10 = XVECEXP (x3, 0, 2);
  operands[2] = x10;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern564 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!register_operand (operands[1], E_VNx4HImode))
        return -1;
      return 1;

    case E_VNx2HImode:
      if (!register_operand (operands[1], E_VNx2HImode))
        return -1;
      return 2;

    case E_VNx4SImode:
      if (!register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 3;

    case E_VNx2SImode:
      if (!register_operand (operands[1], E_VNx2SImode))
        return -1;
      return 4;

    case E_VNx2DImode:
      if (!register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern576 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !aarch64_sve_ldff1_operand (operands[1], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_rshift_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern594 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ZERO_EXTEND)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  x10 = XEXP (x6, 1);
  operands[3] = x10;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4SImode:
          return pattern593 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern593 (x3, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2DImode:
          if (pattern593 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V4DImode:
          if (pattern593 (x3, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern612 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_hi_half (operands[4], i3))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern621 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern626 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern624 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern624 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V8HImode:
      if (pattern625 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern625 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern625 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern633 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern641 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i4))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern649 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern658 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern655 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern655 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern655 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern655 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern665 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      return pattern664 (x1); /* [-1, 2] */

    case PLUS:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x5, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x1) != E_V16QImode
              || !register_operand (operands[1], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x5) != E_V8SImode
              || GET_MODE (x6) != E_V8SImode
              || !register_operand (operands[2], E_V8HImode)
              || !aarch64_int_rnd_operand (operands[4], E_V8SImode)
              || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode))
            return -1;
          return 3;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || GET_MODE (x3) != E_V4DImode
              || GET_MODE (x5) != E_V4DImode
              || GET_MODE (x6) != E_V4DImode
              || !register_operand (operands[2], E_V4SImode)
              || !aarch64_int_rnd_operand (operands[4], E_V4DImode)
              || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || GET_MODE (x3) != E_V2TImode
              || GET_MODE (x5) != E_V2TImode
              || GET_MODE (x6) != E_V2TImode
              || !register_operand (operands[2], E_V2DImode)
              || !aarch64_int_rnd_operand (operands[4], E_V2TImode)
              || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern682 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || pattern681 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern688 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_imm24 (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_imm24 (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 2;

        case E_DImode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern696 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern696 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8QImode:
          if (pattern696 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4QImode:
          if (pattern696 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2QImode:
          if (pattern696 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern696 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern696 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2HImode:
          if (pattern696 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern696 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2SImode:
          if (pattern696 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx2DImode:
          if (pattern696 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern698 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern698 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern698 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern698 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern698 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern698 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern698 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern698 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern698 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern698 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern732 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern741 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          return 0;

        case E_V16QImode:
          return 1;

        case E_V4HImode:
          return 2;

        case E_V8HImode:
          return 3;

        case E_V2SImode:
          return 4;

        case E_V4SImode:
          return 5;

        case E_V2DImode:
          return 6;

        default:
          return -1;
        }

    case CONST_INT:
      if (!aarch64_simd_shift_imm_offset_di (operands[2], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_TImode
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_MODE (x6) != E_TImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_int_rnd_operand (operands[3], E_TImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern756 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern762 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern761 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern761 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern761 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern771 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern774 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern773 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern773 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern773 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern773 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern788 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode)
          || !register_operand (operands[1], i1))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern802 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern813 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern812 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern812 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern821 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern828 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_imm_zero (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern834 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern833 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern833 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern833 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern844 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x2, operands[2]))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern842 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern842 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern842 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern842 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern843 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern843 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern843 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DImode:
          if (pattern843 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern868 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern874 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x5 = XEXP (x2, 1);
  return pattern871 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern879 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern878 (x4); /* [-1, 1] */
}

int
pattern884 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern890 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_orr_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern895 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_V2SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2SFmode)
    return -1;
  return 0;
}

int
pattern901 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern906 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x3, 1);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  return pattern905 (x1); /* [-1, 1] */
}

int
pattern913 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  return pattern600 (x4); /* [-1, 3] */
}

int
pattern917 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_general_reg (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!aarch64_plus_immediate (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern921 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode)
          || !memory_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode)
          || !memory_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode)
          || !memory_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode)
          || !memory_operand (operands[3], E_V2DImode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[2], E_V8HFmode)
          || !memory_operand (operands[3], E_V8HFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[2], E_V4SFmode)
          || !memory_operand (operands[3], E_V4SFmode))
        return -1;
      return 5;

    case E_V2DFmode:
      if (!register_operand (operands[2], E_V2DFmode)
          || !memory_operand (operands[3], E_V2DFmode))
        return -1;
      return 6;

    case E_V8BFmode:
      if (!register_operand (operands[2], E_V8BFmode)
          || !memory_operand (operands[3], E_V8BFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern938 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern945 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern983 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern990 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern999 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern337 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1007 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1015 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1023 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern1036 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1046 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1054 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1062 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (pattern811 (x2, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1081 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != UNSPEC
          || XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != i1
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx16BImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      if (!rtx_equal_p (x6, operands[3]))
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1091 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1026 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1026 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1026 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1026 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1090 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1090 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1090 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern833 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern833 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern833 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode
      || !register_operand (operands[5], E_VNx2BImode))
    return -1;
  return 0;
}

int
pattern1121 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1129 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1136 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i5
      || !register_operand (operands[1], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1150 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_fp_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_fp_zero (operands[3], i1))
    return -1;
  operands[5] = x1;
  if (!aarch64_reg_or_fp_zero (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!memory_operand (operands[6], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[7] = x4;
  if (!aarch64_reg_or_fp_zero (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1160 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_int_rnd_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1171 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  x10 = XEXP (x8, 1);
  operands[3] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  return pattern1170 (x1); /* [-1, 1] */
}

int
pattern1176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1181 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1181 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1181 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1181 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1194 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !vect_par_cnst_even_or_odd_half (operands[4], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  return pattern1138 (x8, 
i1); /* [-1, 0] */
}

int
pattern1211 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1218 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1225 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_int_rnd_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1233 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case SET:
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 3
          || XINT (x7, 1) != i1)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[4]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[5]))
        return -1;
      x11 = XVECEXP (x7, 0, 2);
      if (!rtx_equal_p (x11, operands[6]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x7) != E_VNx8BImode)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x7) != E_VNx4BImode)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x7) != E_VNx2BImode)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1276 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1286 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XVECEXP (x2, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern1288 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern1288 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern1288 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1303 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_VNx2HImode:
      if (!register_operand (operands[4], E_VNx2HImode))
        return -1;
      return 0;

    case E_VNx2HFmode:
      if (!register_operand (operands[4], E_VNx2HFmode))
        return -1;
      return 1;

    case E_VNx2BFmode:
      if (!register_operand (operands[4], E_VNx2BFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1306 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1315 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2HImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2SImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
        return -1;
      return 2;

    case E_VNx2DImode:
      if (!register_operand (operands[2], E_VNx2DImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1324 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_carry_operation (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !aarch64_carry_operation (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1333 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1344 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 126)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x6, operands[6]))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x7, operands[7]))
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          return pattern1343 (x1, 
E_VNx16BImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1343 (x1, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (pattern1343 (x1, 
E_VNx4BImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 3;

        case E_VNx8BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx8BImode
              || !register_operand (operands[2], E_VNx8HImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 4;

        case E_VNx4BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx4BImode
              || !register_operand (operands[2], E_VNx4SImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  switch (XINT (x3, 1))
    {
    case 320:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8085; /* aarch64_pred_smulhvnx16qi */

        case E_VNx8QImode:
          if (pattern857 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8087; /* aarch64_pred_smulhvnx8qi */

        case E_VNx4QImode:
          if (pattern857 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8089; /* aarch64_pred_smulhvnx4qi */

        case E_VNx2QImode:
          if (pattern857 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8091; /* aarch64_pred_smulhvnx2qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8093; /* aarch64_pred_smulhvnx8hi */

        case E_VNx4HImode:
          if (pattern857 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8095; /* aarch64_pred_smulhvnx4hi */

        case E_VNx2HImode:
          if (pattern857 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8097; /* aarch64_pred_smulhvnx2hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8099; /* aarch64_pred_smulhvnx4si */

        case E_VNx2SImode:
          if (pattern857 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8101; /* aarch64_pred_smulhvnx2si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8103; /* aarch64_pred_smulhvnx2di */

        default:
          return -1;
        }

    case 321:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8086; /* aarch64_pred_umulhvnx16qi */

        case E_VNx8QImode:
          if (pattern857 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8088; /* aarch64_pred_umulhvnx8qi */

        case E_VNx4QImode:
          if (pattern857 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8090; /* aarch64_pred_umulhvnx4qi */

        case E_VNx2QImode:
          if (pattern857 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8092; /* aarch64_pred_umulhvnx2qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8094; /* aarch64_pred_umulhvnx8hi */

        case E_VNx4HImode:
          if (pattern857 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8096; /* aarch64_pred_umulhvnx4hi */

        case E_VNx2HImode:
          if (pattern857 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8098; /* aarch64_pred_umulhvnx2hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8100; /* aarch64_pred_umulhvnx4si */

        case E_VNx2SImode:
          if (pattern857 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8102; /* aarch64_pred_umulhvnx2si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8104; /* aarch64_pred_umulhvnx2di */

        default:
          return -1;
        }

    case 414:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern979 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8348; /* *sdiv_pow2vnx16qi3 */

        case E_VNx8QImode:
          if (pattern979 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8349; /* *sdiv_pow2vnx8qi3 */

        case E_VNx4QImode:
          if (pattern979 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8350; /* *sdiv_pow2vnx4qi3 */

        case E_VNx2QImode:
          if (pattern979 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8351; /* *sdiv_pow2vnx2qi3 */

        case E_VNx8HImode:
          if (pattern979 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8352; /* *sdiv_pow2vnx8hi3 */

        case E_VNx4HImode:
          if (pattern979 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8353; /* *sdiv_pow2vnx4hi3 */

        case E_VNx2HImode:
          if (pattern979 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8354; /* *sdiv_pow2vnx2hi3 */

        case E_VNx4SImode:
          if (pattern979 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8355; /* *sdiv_pow2vnx4si3 */

        case E_VNx2SImode:
          if (pattern979 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8356; /* *sdiv_pow2vnx2si3 */

        case E_VNx2DImode:
          if (pattern979 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8357; /* *sdiv_pow2vnx2di3 */

        case E_V8QImode:
          if (pattern979 (x2, 
E_V8QImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8358; /* *sdiv_pow2v8qi3 */

        case E_V16QImode:
          if (pattern979 (x2, 
E_V16QImode, 
E_VNx16BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8359; /* *sdiv_pow2v16qi3 */

        case E_V4HImode:
          if (pattern979 (x2, 
E_V4HImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8360; /* *sdiv_pow2v4hi3 */

        case E_V8HImode:
          if (pattern979 (x2, 
E_V8HImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8361; /* *sdiv_pow2v8hi3 */

        case E_V2SImode:
          if (pattern979 (x2, 
E_V2SImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8362; /* *sdiv_pow2v2si3 */

        case E_V4SImode:
          if (pattern979 (x2, 
E_V4SImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8363; /* *sdiv_pow2v4si3 */

        case E_V2DImode:
          if (pattern979 (x2, 
E_V2DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8364; /* *sdiv_pow2v2di3 */

        case E_V1DImode:
          if (pattern979 (x2, 
E_V1DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8365; /* *sdiv_pow2v1di3 */

        default:
          return -1;
        }

    case 209:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11554; /* aarch64_pred_shaddvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11564; /* aarch64_pred_shaddvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11574; /* aarch64_pred_shaddvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11584; /* aarch64_pred_shaddvnx2di */

        default:
          return -1;
        }

    case 213:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11555; /* aarch64_pred_shsubvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11565; /* aarch64_pred_shsubvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11575; /* aarch64_pred_shsubvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11585; /* aarch64_pred_shsubvnx2di */

        default:
          return -1;
        }

    case 232:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11556; /* aarch64_pred_sqrshlvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11566; /* aarch64_pred_sqrshlvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11576; /* aarch64_pred_sqrshlvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11586; /* aarch64_pred_sqrshlvnx2di */

        default:
          return -1;
        }

    case 211:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11557; /* aarch64_pred_srhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11567; /* aarch64_pred_srhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11577; /* aarch64_pred_srhaddvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11587; /* aarch64_pred_srhaddvnx2di */

        default:
          return -1;
        }

    case 230:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11558; /* aarch64_pred_srshlvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11568; /* aarch64_pred_srshlvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11578; /* aarch64_pred_srshlvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11588; /* aarch64_pred_srshlvnx2di */

        default:
          return -1;
        }

    case 210:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11559; /* aarch64_pred_uhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11569; /* aarch64_pred_uhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11579; /* aarch64_pred_uhaddvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11589; /* aarch64_pred_uhaddvnx2di */

        default:
          return -1;
        }

    case 214:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11560; /* aarch64_pred_uhsubvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11570; /* aarch64_pred_uhsubvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11580; /* aarch64_pred_uhsubvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11590; /* aarch64_pred_uhsubvnx2di */

        default:
          return -1;
        }

    case 233:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11561; /* aarch64_pred_uqrshlvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11571; /* aarch64_pred_uqrshlvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11581; /* aarch64_pred_uqrshlvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11591; /* aarch64_pred_uqrshlvnx2di */

        default:
          return -1;
        }

    case 212:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11562; /* aarch64_pred_urhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11572; /* aarch64_pred_urhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11582; /* aarch64_pred_urhaddvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11592; /* aarch64_pred_urhaddvnx2di */

        default:
          return -1;
        }

    case 231:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern857 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11563; /* aarch64_pred_urshlvnx16qi */

        case E_VNx8HImode:
          if (pattern857 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11573; /* aarch64_pred_urshlvnx8hi */

        case E_VNx4SImode:
          if (pattern857 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11583; /* aarch64_pred_urshlvnx4si */

        case E_VNx2DImode:
          if (pattern857 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11593; /* aarch64_pred_urshlvnx2di */

        default:
          return -1;
        }

    case 226:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern980 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11744; /* aarch64_pred_sqshlvnx16qi */

        case E_VNx8HImode:
          if (pattern980 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11746; /* aarch64_pred_sqshlvnx8hi */

        case E_VNx4SImode:
          if (pattern980 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11748; /* aarch64_pred_sqshlvnx4si */

        case E_VNx2DImode:
          if (pattern980 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11750; /* aarch64_pred_sqshlvnx2di */

        default:
          return -1;
        }

    case 227:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern980 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11745; /* aarch64_pred_uqshlvnx16qi */

        case E_VNx8HImode:
          if (pattern980 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11747; /* aarch64_pred_uqshlvnx8hi */

        case E_VNx4SImode:
          if (pattern980 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11749; /* aarch64_pred_uqshlvnx4si */

        case E_VNx2DImode:
          if (pattern980 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 1197 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11751; /* aarch64_pred_uqshlvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern75 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V4HImode) != 0
              || !
#line 5356 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3436; /* aarch64_sqrdmulhv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V8HImode) != 0
              || !
#line 5356 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3440; /* aarch64_sqrdmulhv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V2SImode) != 0
              || !
#line 5356 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3444; /* aarch64_sqrdmulhv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V4SImode) != 0
              || !
#line 5356 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3448; /* aarch64_sqrdmulhv4si */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_HImode) != 0
              || !
#line 5356 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3450; /* aarch64_sqrdmulhhi */

        case E_SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_SImode) != 0
              || !
#line 5356 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3452; /* aarch64_sqrdmulhsi */

        case E_VNx16QImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx16QImode) != 0
              || !
#line 1160 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11731; /* aarch64_sve_sqrdmulhvnx16qi */

        case E_VNx8HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx8HImode) != 0
              || !
#line 1160 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11733; /* aarch64_sve_sqrdmulhvnx8hi */

        case E_VNx4SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx4SImode) != 0
              || !
#line 1160 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11735; /* aarch64_sve_sqrdmulhvnx4si */

        case E_VNx2DImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx2DImode) != 0
              || !
#line 1160 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11737; /* aarch64_sve_sqrdmulhvnx2di */

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern780 (x2, 
E_HImode, 
E_V4HImode) != 0
              || !
#line 5368 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3456; /* aarch64_sqrdmulh_nv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern780 (x2, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 5368 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3460; /* aarch64_sqrdmulh_nv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern780 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 5368 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3464; /* aarch64_sqrdmulh_nv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern780 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 5368 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3468; /* aarch64_sqrdmulh_nv4si */

        default:
          return -1;
        }

    case 2:
      if (!
#line 5383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3472; /* aarch64_sqrdmulh_lanev4hi */

    case 3:
      if (!
#line 5398 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3488; /* aarch64_sqrdmulh_laneqv4hi */

    case 4:
      if (!
#line 5383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3476; /* aarch64_sqrdmulh_lanev8hi */

    case 5:
      if (!
#line 5398 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3492; /* aarch64_sqrdmulh_laneqv8hi */

    case 6:
      if (!
#line 5383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3480; /* aarch64_sqrdmulh_lanev2si */

    case 7:
      if (!
#line 5398 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3496; /* aarch64_sqrdmulh_laneqv2si */

    case 8:
      if (!
#line 5383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3484; /* aarch64_sqrdmulh_lanev4si */

    case 9:
      if (!
#line 5398 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3500; /* aarch64_sqrdmulh_laneqv4si */

    case 10:
      if (!
#line 5413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3502; /* aarch64_sqrdmulh_lanehi */

    case 11:
      if (!
#line 5428 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3506; /* aarch64_sqrdmulh_laneqhi */

    case 12:
      if (!
#line 5413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3504; /* aarch64_sqrdmulh_lanesi */

    case 13:
      if (!
#line 5428 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3508; /* aarch64_sqrdmulh_laneqsi */

    case 14:
      if (!
#line 1173 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11739; /* aarch64_sve_sqrdmulh_lane_vnx8hi */

    case 15:
      if (!
#line 1173 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11741; /* aarch64_sve_sqrdmulh_lane_vnx4si */

    case 16:
      if (!
#line 1173 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11743; /* aarch64_sve_sqrdmulh_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[1], E_V4x8QImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4562; /* aarch64_vec_store_lanesv4x8qi_lanev8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[1], E_V4x4HImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4563; /* aarch64_vec_store_lanesv4x4hi_lanev4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[1], E_V4x2SImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4564; /* aarch64_vec_store_lanesv4x2si_lanev2si */

    case E_V4x1DImode:
      if (!register_operand (operands[1], E_V4x1DImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4565; /* aarch64_vec_store_lanesv4x1di_lanedi */

    case E_V4x4HFmode:
      if (!register_operand (operands[1], E_V4x4HFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4566; /* aarch64_vec_store_lanesv4x4hf_lanev4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[1], E_V4x2SFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4567; /* aarch64_vec_store_lanesv4x2sf_lanev2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[1], E_V4x1DFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4568; /* aarch64_vec_store_lanesv4x1df_lanedf */

    case E_V4x4BFmode:
      if (!register_operand (operands[1], E_V4x4BFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4569; /* aarch64_vec_store_lanesv4x4bf_lanev4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[1], E_V4x16QImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4570; /* aarch64_vec_store_lanesv4x16qi_lanev16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[1], E_V4x8HImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4571; /* aarch64_vec_store_lanesv4x8hi_lanev8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[1], E_V4x4SImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4572; /* aarch64_vec_store_lanesv4x4si_lanev4si */

    case E_V4x2DImode:
      if (!register_operand (operands[1], E_V4x2DImode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4573; /* aarch64_vec_store_lanesv4x2di_lanev2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[1], E_V4x8HFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4574; /* aarch64_vec_store_lanesv4x8hf_lanev8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[1], E_V4x4SFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4575; /* aarch64_vec_store_lanesv4x4sf_lanev4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[1], E_V4x2DFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4576; /* aarch64_vec_store_lanesv4x2df_lanev2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[1], E_V4x8BFmode)
          || !
#line 7630 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4577; /* aarch64_vec_store_lanesv4x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3644; /* aarch64_urshlv8qi */

    case 1:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3650; /* aarch64_urshlv16qi */

    case 2:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3660; /* aarch64_urshlv4hi */

    case 3:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3666; /* aarch64_urshlv8hi */

    case 4:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3676; /* aarch64_urshlv2si */

    case 5:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3682; /* aarch64_urshlv4si */

    case 6:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3686; /* aarch64_urshlv2di */

    case 7:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3696; /* aarch64_urshldi */

    case 8:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11457; /* aarch64_sve_urshlvnx32qi */

    case 9:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11460; /* aarch64_sve_urshlvnx16hi */

    case 10:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11463; /* aarch64_sve_urshlvnx8si */

    case 11:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11466; /* aarch64_sve_urshlvnx4di */

    case 12:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11469; /* aarch64_sve_urshlvnx64qi */

    case 13:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11472; /* aarch64_sve_urshlvnx32hi */

    case 14:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11475; /* aarch64_sve_urshlvnx16si */

    case 15:
      if (!
#line 754 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11478; /* aarch64_sve_urshlvnx8di */

    case 16:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11481; /* aarch64_sve_single_urshlvnx32qi */

    case 17:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11484; /* aarch64_sve_single_urshlvnx16hi */

    case 18:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11487; /* aarch64_sve_single_urshlvnx8si */

    case 19:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11490; /* aarch64_sve_single_urshlvnx4di */

    case 20:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11493; /* aarch64_sve_single_urshlvnx64qi */

    case 21:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11496; /* aarch64_sve_single_urshlvnx32hi */

    case 22:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11499; /* aarch64_sve_single_urshlvnx16si */

    case 23:
      if (!
#line 765 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11502; /* aarch64_sve_single_urshlvnx8di */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern82 (x1))
    {
    case 0:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3699; /* aarch64_sqshlv8qi */

    case 1:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3711; /* aarch64_sqshlv16qi */

    case 2:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3715; /* aarch64_sqshlv4hi */

    case 3:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3727; /* aarch64_sqshlv8hi */

    case 4:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3731; /* aarch64_sqshlv2si */

    case 5:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3743; /* aarch64_sqshlv4si */

    case 6:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3747; /* aarch64_sqshlv2di */

    case 7:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3751; /* aarch64_sqshlqi */

    case 8:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3755; /* aarch64_sqshlhi */

    case 9:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3759; /* aarch64_sqshlsi */

    case 10:
      if (!
#line 6322 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3763; /* aarch64_sqshldi */

    case 11:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3854; /* aarch64_sqshl_nv8qi */

    case 12:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3857; /* aarch64_sqshl_nv16qi */

    case 13:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3860; /* aarch64_sqshl_nv4hi */

    case 14:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3863; /* aarch64_sqshl_nv8hi */

    case 15:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3866; /* aarch64_sqshl_nv2si */

    case 16:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3869; /* aarch64_sqshl_nv4si */

    case 17:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3872; /* aarch64_sqshl_nv2di */

    case 18:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3875; /* aarch64_sqshl_nqi */

    case 19:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3878; /* aarch64_sqshl_nhi */

    case 20:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3881; /* aarch64_sqshl_nsi */

    case 21:
      if (!
#line 6469 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3884; /* aarch64_sqshl_ndi */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern55 (x3, 
E_VNx4SImode) != 0
              || !
#line 4132 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7975; /* aarch64_adrvnx4si */

        case E_VNx2DImode:
          if (pattern55 (x3, 
E_VNx2DImode) != 0
              || !
#line 4132 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7976; /* aarch64_adrvnx2di */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern592 (x5) != 0
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_VNx2DImode)
          || !
#line 4148 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 7977; /* *aarch64_adr_sxtw */

    case AND:
      if (GET_MODE (x5) != E_VNx2DImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x10 = XEXP (x5, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[3] = x11;
      if (!aarch64_sve_uxtw_immediate (operands[3], E_VNx2DImode)
          || !
#line 4165 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 7978; /* *aarch64_adr_uxtw_unspec */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern55 (x3, 
E_VNx16QImode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10385; /* aarch64_sve_tblqvnx16qi */

    case E_VNx8HImode:
      if (pattern55 (x3, 
E_VNx8HImode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10387; /* aarch64_sve_tblqvnx8hi */

    case E_VNx4SImode:
      if (pattern55 (x3, 
E_VNx4SImode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10389; /* aarch64_sve_tblqvnx4si */

    case E_VNx2DImode:
      if (pattern55 (x3, 
E_VNx2DImode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10391; /* aarch64_sve_tblqvnx2di */

    case E_VNx8BFmode:
      if (pattern91 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10393; /* aarch64_sve_tblqvnx8bf */

    case E_VNx8HFmode:
      if (pattern91 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10395; /* aarch64_sve_tblqvnx8hf */

    case E_VNx4SFmode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10397; /* aarch64_sve_tblqvnx4sf */

    case E_VNx2DFmode:
      if (pattern91 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !(
#line 9093 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3171 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10399; /* aarch64_sve_tblqvnx2df */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern69 (x1))
    {
    case 0:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2111; /* aarch64_smaxpv8qi */

    case 1:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2119; /* aarch64_smaxpv16qi */

    case 2:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2127; /* aarch64_smaxpv4hi */

    case 3:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2135; /* aarch64_smaxpv8hi */

    case 4:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2143; /* aarch64_smaxpv2si */

    case 5:
      if (!
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2151; /* aarch64_smaxpv4si */

    case 6:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10340; /* aarch64_pred_reduc_smax_vnx16qi */

    case 7:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10347; /* aarch64_pred_reduc_smax_vnx8hi */

    case 8:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10354; /* aarch64_pred_reduc_smax_vnx4si */

    case 9:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10361; /* aarch64_pred_reduc_smax_vnx2di */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern97 (x1))
    {
    case 0:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10652; /* aarch64_sve_uzp1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10658; /* aarch64_sve_uzp1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10664; /* aarch64_sve_uzp1qvnx4si */

    case 3:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10670; /* aarch64_sve_uzp1qvnx2di */

    case 4:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10676; /* aarch64_sve_uzp1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10682; /* aarch64_sve_uzp1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10688; /* aarch64_sve_uzp1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10694; /* aarch64_sve_uzp1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3635; /* aarch64_sshlv8qi */

    case 1:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3647; /* aarch64_sshlv16qi */

    case 2:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3651; /* aarch64_sshlv4hi */

    case 3:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3663; /* aarch64_sshlv8hi */

    case 4:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3667; /* aarch64_sshlv2si */

    case 5:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3679; /* aarch64_sshlv4si */

    case 6:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3683; /* aarch64_sshlv2di */

    case 7:
      if (!
#line 6308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3687; /* aarch64_sshldi */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern53 (x1))
    {
    case 0:
      return 1022; /* fcvtzssf3 */

    case 1:
      if (!
#line 7171 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1030; /* fcvtzshfsi3 */

    case 2:
      return 1024; /* fcvtzsdf3 */

    case 3:
      if (!
#line 7171 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1032; /* fcvtzshfdi3 */

    case 4:
      if (!
#line 7191 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1038; /* fcvtzshf3 */

    case 5:
      if (!(
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2617; /* fcvtzsv4hf3 */

    case 6:
      if (!(
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2619; /* fcvtzsv8hf3 */

    case 7:
      if (!
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2621; /* fcvtzsv2sf3 */

    case 8:
      if (!
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2623; /* fcvtzsv4sf3 */

    case 9:
      if (!
#line 3125 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2625; /* fcvtzsv2df3 */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12060; /* aarch64_sve_sqdmullbvnx8hi */

    case 1:
      if (!
#line 2269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12081; /* aarch64_sve_sqdmullbvnx4si */

    case 2:
      if (!
#line 2269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12102; /* aarch64_sve_sqdmullbvnx2di */

    case 3:
      if (!
#line 2282 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12118; /* aarch64_sve_sqdmullb_lane_vnx4si */

    case 4:
      if (!
#line 2282 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12124; /* aarch64_sve_sqdmullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern117 (x1))
    {
    case 0:
      if (!
#line 3722 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12705; /* aarch64_pred_reduc_uminqv_vnx16qi */

    case 1:
      if (!
#line 3722 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12713; /* aarch64_pred_reduc_uminqv_vnx8hi */

    case 2:
      if (!
#line 3722 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12721; /* aarch64_pred_reduc_uminqv_vnx4si */

    case 3:
      if (!
#line 3722 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12729; /* aarch64_pred_reduc_uminqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (!
#line 2983 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12478; /* aarch64_sve_sqcadd90vnx16qi */

    case 1:
      if (!
#line 2983 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12482; /* aarch64_sve_sqcadd90vnx8hi */

    case 2:
      if (!
#line 2983 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12486; /* aarch64_sve_sqcadd90vnx4si */

    case 3:
      if (!
#line 2983 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12490; /* aarch64_sve_sqcadd90vnx2di */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8QImode
          || !register_operand (operands[1], E_V2x8QImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4666; /* aarch64_st1_x2_v8qi */

    case E_V2x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HImode
          || !register_operand (operands[1], E_V2x4HImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4667; /* aarch64_st1_x2_v4hi */

    case E_V2x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SImode
          || !register_operand (operands[1], E_V2x2SImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4668; /* aarch64_st1_x2_v2si */

    case E_V2x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DImode
          || !register_operand (operands[1], E_V2x1DImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4669; /* aarch64_st1_x2_di */

    case E_V2x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HFmode
          || !register_operand (operands[1], E_V2x4HFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4670; /* aarch64_st1_x2_v4hf */

    case E_V2x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SFmode
          || !register_operand (operands[1], E_V2x2SFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4671; /* aarch64_st1_x2_v2sf */

    case E_V2x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DFmode
          || !register_operand (operands[1], E_V2x1DFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4672; /* aarch64_st1_x2_df */

    case E_V2x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4BFmode
          || !register_operand (operands[1], E_V2x4BFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4673; /* aarch64_st1_x2_v4bf */

    case E_V2x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x16QImode
          || !register_operand (operands[1], E_V2x16QImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4674; /* aarch64_st1_x2_v16qi */

    case E_V2x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HImode
          || !register_operand (operands[1], E_V2x8HImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4675; /* aarch64_st1_x2_v8hi */

    case E_V2x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SImode
          || !register_operand (operands[1], E_V2x4SImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4676; /* aarch64_st1_x2_v4si */

    case E_V2x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DImode
          || !register_operand (operands[1], E_V2x2DImode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4677; /* aarch64_st1_x2_v2di */

    case E_V2x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HFmode
          || !register_operand (operands[1], E_V2x8HFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4678; /* aarch64_st1_x2_v8hf */

    case E_V2x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SFmode
          || !register_operand (operands[1], E_V2x4SFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4679; /* aarch64_st1_x2_v4sf */

    case E_V2x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DFmode
          || !register_operand (operands[1], E_V2x2DFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4680; /* aarch64_st1_x2_v2df */

    case E_V2x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8BFmode
          || !register_operand (operands[1], E_V2x8BFmode)
          || !
#line 7847 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4681; /* aarch64_st1_x2_v8bf */

    case E_V3x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8QImode
          || !register_operand (operands[1], E_V3x8QImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4682; /* aarch64_st1_x3_v8qi */

    case E_V3x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HImode
          || !register_operand (operands[1], E_V3x4HImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4683; /* aarch64_st1_x3_v4hi */

    case E_V3x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SImode
          || !register_operand (operands[1], E_V3x2SImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4684; /* aarch64_st1_x3_v2si */

    case E_V3x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DImode
          || !register_operand (operands[1], E_V3x1DImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4685; /* aarch64_st1_x3_di */

    case E_V3x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HFmode
          || !register_operand (operands[1], E_V3x4HFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4686; /* aarch64_st1_x3_v4hf */

    case E_V3x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SFmode
          || !register_operand (operands[1], E_V3x2SFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4687; /* aarch64_st1_x3_v2sf */

    case E_V3x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DFmode
          || !register_operand (operands[1], E_V3x1DFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4688; /* aarch64_st1_x3_df */

    case E_V3x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4BFmode
          || !register_operand (operands[1], E_V3x4BFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4689; /* aarch64_st1_x3_v4bf */

    case E_V3x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x16QImode
          || !register_operand (operands[1], E_V3x16QImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4690; /* aarch64_st1_x3_v16qi */

    case E_V3x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HImode
          || !register_operand (operands[1], E_V3x8HImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4691; /* aarch64_st1_x3_v8hi */

    case E_V3x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SImode
          || !register_operand (operands[1], E_V3x4SImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4692; /* aarch64_st1_x3_v4si */

    case E_V3x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DImode
          || !register_operand (operands[1], E_V3x2DImode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4693; /* aarch64_st1_x3_v2di */

    case E_V3x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HFmode
          || !register_operand (operands[1], E_V3x8HFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4694; /* aarch64_st1_x3_v8hf */

    case E_V3x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SFmode
          || !register_operand (operands[1], E_V3x4SFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4695; /* aarch64_st1_x3_v4sf */

    case E_V3x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DFmode
          || !register_operand (operands[1], E_V3x2DFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4696; /* aarch64_st1_x3_v2df */

    case E_V3x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8BFmode
          || !register_operand (operands[1], E_V3x8BFmode)
          || !
#line 7867 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4697; /* aarch64_st1_x3_v8bf */

    case E_V4x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8QImode
          || !register_operand (operands[1], E_V4x8QImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4698; /* aarch64_st1_x4_v8qi */

    case E_V4x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HImode
          || !register_operand (operands[1], E_V4x4HImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4699; /* aarch64_st1_x4_v4hi */

    case E_V4x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SImode
          || !register_operand (operands[1], E_V4x2SImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4700; /* aarch64_st1_x4_v2si */

    case E_V4x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DImode
          || !register_operand (operands[1], E_V4x1DImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4701; /* aarch64_st1_x4_di */

    case E_V4x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HFmode
          || !register_operand (operands[1], E_V4x4HFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4702; /* aarch64_st1_x4_v4hf */

    case E_V4x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SFmode
          || !register_operand (operands[1], E_V4x2SFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4703; /* aarch64_st1_x4_v2sf */

    case E_V4x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DFmode
          || !register_operand (operands[1], E_V4x1DFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4704; /* aarch64_st1_x4_df */

    case E_V4x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4BFmode
          || !register_operand (operands[1], E_V4x4BFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4705; /* aarch64_st1_x4_v4bf */

    case E_V4x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x16QImode
          || !register_operand (operands[1], E_V4x16QImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4706; /* aarch64_st1_x4_v16qi */

    case E_V4x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HImode
          || !register_operand (operands[1], E_V4x8HImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4707; /* aarch64_st1_x4_v8hi */

    case E_V4x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SImode
          || !register_operand (operands[1], E_V4x4SImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4708; /* aarch64_st1_x4_v4si */

    case E_V4x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DImode
          || !register_operand (operands[1], E_V4x2DImode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4709; /* aarch64_st1_x4_v2di */

    case E_V4x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HFmode
          || !register_operand (operands[1], E_V4x8HFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4710; /* aarch64_st1_x4_v8hf */

    case E_V4x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SFmode
          || !register_operand (operands[1], E_V4x4SFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4711; /* aarch64_st1_x4_v4sf */

    case E_V4x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DFmode
          || !register_operand (operands[1], E_V4x2DFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4712; /* aarch64_st1_x4_v2df */

    case E_V4x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8BFmode
          || !register_operand (operands[1], E_V4x8BFmode)
          || !
#line 7887 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4713; /* aarch64_st1_x4_v8bf */

    case E_V8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4730; /* aarch64_be_st1v8qi */

    case E_V16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4731; /* aarch64_be_st1v16qi */

    case E_V4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4732; /* aarch64_be_st1v4hi */

    case E_V8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4733; /* aarch64_be_st1v8hi */

    case E_V2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4734; /* aarch64_be_st1v2si */

    case E_V4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4735; /* aarch64_be_st1v4si */

    case E_V2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4736; /* aarch64_be_st1v2di */

    case E_V4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4737; /* aarch64_be_st1v4hf */

    case E_V8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4738; /* aarch64_be_st1v8hf */

    case E_V4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BFmode
          || !register_operand (operands[1], E_V4BFmode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4739; /* aarch64_be_st1v4bf */

    case E_V8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BFmode
          || !register_operand (operands[1], E_V8BFmode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4740; /* aarch64_be_st1v8bf */

    case E_V2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4741; /* aarch64_be_st1v2sf */

    case E_V4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4742; /* aarch64_be_st1v4sf */

    case E_V2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4743; /* aarch64_be_st1v2df */

    case E_DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 7916 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4744; /* aarch64_be_st1di */

    default:
      return -1;
    }
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1241 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11758; /* *cond_sqshlvnx2di_2 */
    }
  if (register_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1268 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11766; /* *cond_sqshlvnx2di_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11774; /* *cond_sqshlvnx2di_any */
}

 int
recog_218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11604; /* *cond_urshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11651; /* *cond_urshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11691; /* *cond_urshlvnx16qi_any */
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11625; /* *cond_uhsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11668; /* *cond_uhsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11708; /* *cond_uhsubvnx4si_any */
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11598; /* *cond_srshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11646; /* *cond_srshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11686; /* *cond_srshlvnx16qi_any */
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11619; /* *cond_shsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11663; /* *cond_shsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11703; /* *cond_shsubvnx4si_any */
}

 int
recog_258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1043 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8507; /* *cond_fminvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8653; /* *cond_fminvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8757; /* *cond_fminvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8520; /* *cond_fminvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8666; /* *cond_fminvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8770; /* *cond_fminvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8533; /* *cond_fminvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8679; /* *cond_fminvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8783; /* *cond_fminvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8546; /* *cond_fminvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8692; /* *cond_fminvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8796; /* *cond_fminvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8607; /* *cond_fminvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8857; /* *cond_fminvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8614; /* *cond_fminvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8864; /* *cond_fminvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8621; /* *cond_fminvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8871; /* *cond_fminvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8559; /* *cond_fminvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8705; /* *cond_fminvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8809; /* *cond_fminvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8572; /* *cond_fminvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8718; /* *cond_fminvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8822; /* *cond_fminvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8585; /* *cond_fminvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8731; /* *cond_fminvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8835; /* *cond_fminvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8598; /* *cond_fminvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8744; /* *cond_fminvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8848; /* *cond_fminvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8628; /* *cond_fminvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8878; /* *cond_fminvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8635; /* *cond_fminvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8885; /* *cond_fminvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8642; /* *cond_fminvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8892; /* *cond_fminvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1109 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9237; /* *cond_fmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9265; /* *cond_fmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9297; /* *cond_fmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9241; /* *cond_fmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9269; /* *cond_fmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9301; /* *cond_fmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9245; /* *cond_fmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9273; /* *cond_fmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9305; /* *cond_fmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9261; /* *cond_fmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9293; /* *cond_fmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9249; /* *cond_fmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9281; /* *cond_fmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9313; /* *cond_fmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9253; /* *cond_fmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9285; /* *cond_fmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9317; /* *cond_fmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9257; /* *cond_fmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9289; /* *cond_fmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9321; /* *cond_fmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9277; /* *cond_fmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9309; /* *cond_fmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      switch (GET_CODE (operands[3]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1045 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7071; /* *cond_uxtvnx16qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7081; /* *cond_uxtvnx16qi_any */

            case E_VNx8QImode:
              if (pattern1045 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7072; /* *cond_uxtvnx8qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7082; /* *cond_uxtvnx8qi_any */

            case E_VNx4QImode:
              if (pattern1045 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7073; /* *cond_uxtvnx4qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7083; /* *cond_uxtvnx4qi_any */

            case E_VNx2QImode:
              if (pattern1045 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7074; /* *cond_uxtvnx2qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7084; /* *cond_uxtvnx2qi_any */

            case E_VNx8HImode:
              if (pattern1045 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7075; /* *cond_uxtvnx8hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7085; /* *cond_uxtvnx8hi_any */

            case E_VNx4HImode:
              if (pattern1045 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7076; /* *cond_uxtvnx4hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7086; /* *cond_uxtvnx4hi_any */

            case E_VNx2HImode:
              if (pattern1045 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7077; /* *cond_uxtvnx2hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7087; /* *cond_uxtvnx2hi_any */

            case E_VNx4SImode:
              if (pattern1045 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7078; /* *cond_uxtvnx4si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7088; /* *cond_uxtvnx4si_any */

            case E_VNx2SImode:
              if (pattern1045 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7079; /* *cond_uxtvnx2si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7089; /* *cond_uxtvnx2si_any */

            case E_VNx2DImode:
              if (pattern1045 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7080; /* *cond_uxtvnx2di_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7090; /* *cond_uxtvnx2di_any */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern466 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7455; /* *cond_andvnx16qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7625; /* *cond_andvnx16qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7795; /* *cond_andvnx16qi_any */

            case E_VNx8QImode:
              if (pattern466 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7472; /* *cond_andvnx8qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7642; /* *cond_andvnx8qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7812; /* *cond_andvnx8qi_any */

            case E_VNx4QImode:
              if (pattern466 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7489; /* *cond_andvnx4qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7659; /* *cond_andvnx4qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7829; /* *cond_andvnx4qi_any */

            case E_VNx2QImode:
              if (pattern466 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7506; /* *cond_andvnx2qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7676; /* *cond_andvnx2qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7846; /* *cond_andvnx2qi_any */

            case E_VNx8HImode:
              if (pattern466 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7523; /* *cond_andvnx8hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7693; /* *cond_andvnx8hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7863; /* *cond_andvnx8hi_any */

            case E_VNx4HImode:
              if (pattern466 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7540; /* *cond_andvnx4hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7710; /* *cond_andvnx4hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7880; /* *cond_andvnx4hi_any */

            case E_VNx2HImode:
              if (pattern466 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7557; /* *cond_andvnx2hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7727; /* *cond_andvnx2hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7897; /* *cond_andvnx2hi_any */

            case E_VNx4SImode:
              if (pattern466 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7574; /* *cond_andvnx4si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7744; /* *cond_andvnx4si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7914; /* *cond_andvnx4si_any */

            case E_VNx2SImode:
              if (pattern466 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7591; /* *cond_andvnx2si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7761; /* *cond_andvnx2si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7931; /* *cond_andvnx2si_any */

            case E_VNx2DImode:
              if (pattern466 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7608; /* *cond_andvnx2di_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7778; /* *cond_andvnx2di_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7948; /* *cond_andvnx2di_any */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern983 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8181; /* *cond_bicvnx16qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8191; /* *cond_bicvnx16qi_any */

        case E_VNx8QImode:
          if (pattern983 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8182; /* *cond_bicvnx8qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8192; /* *cond_bicvnx8qi_any */

        case E_VNx4QImode:
          if (pattern983 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8183; /* *cond_bicvnx4qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8193; /* *cond_bicvnx4qi_any */

        case E_VNx2QImode:
          if (pattern983 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8184; /* *cond_bicvnx2qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8194; /* *cond_bicvnx2qi_any */

        case E_VNx8HImode:
          if (pattern983 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8185; /* *cond_bicvnx8hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8195; /* *cond_bicvnx8hi_any */

        case E_VNx4HImode:
          if (pattern983 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8186; /* *cond_bicvnx4hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8196; /* *cond_bicvnx4hi_any */

        case E_VNx2HImode:
          if (pattern983 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8187; /* *cond_bicvnx2hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8197; /* *cond_bicvnx2hi_any */

        case E_VNx4SImode:
          if (pattern983 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8188; /* *cond_bicvnx4si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8198; /* *cond_bicvnx4si_any */

        case E_VNx2SImode:
          if (pattern983 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8189; /* *cond_bicvnx2si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8199; /* *cond_bicvnx2si_any */

        case E_VNx2DImode:
          if (pattern983 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8190; /* *cond_bicvnx2di_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8200; /* *cond_bicvnx2di_any */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern720 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7456; /* *cond_iorvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7626; /* *cond_iorvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7796; /* *cond_iorvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7473; /* *cond_iorvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7643; /* *cond_iorvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7813; /* *cond_iorvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7490; /* *cond_iorvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7660; /* *cond_iorvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7830; /* *cond_iorvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7507; /* *cond_iorvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7677; /* *cond_iorvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7847; /* *cond_iorvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7524; /* *cond_iorvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7694; /* *cond_iorvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7864; /* *cond_iorvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7541; /* *cond_iorvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7711; /* *cond_iorvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7881; /* *cond_iorvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7558; /* *cond_iorvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7728; /* *cond_iorvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7898; /* *cond_iorvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7575; /* *cond_iorvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7745; /* *cond_iorvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7915; /* *cond_iorvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7592; /* *cond_iorvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7762; /* *cond_iorvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7932; /* *cond_iorvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7609; /* *cond_iorvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7779; /* *cond_iorvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7949; /* *cond_iorvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern595 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6707; /* *cond_popcountvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6797; /* *cond_popcountvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6716; /* *cond_popcountvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6806; /* *cond_popcountvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6725; /* *cond_popcountvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6815; /* *cond_popcountvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6734; /* *cond_popcountvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6824; /* *cond_popcountvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6743; /* *cond_popcountvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6833; /* *cond_popcountvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6752; /* *cond_popcountvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6842; /* *cond_popcountvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6761; /* *cond_popcountvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6851; /* *cond_popcountvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6770; /* *cond_popcountvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6860; /* *cond_popcountvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6779; /* *cond_popcountvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6869; /* *cond_popcountvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6788; /* *cond_popcountvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6878; /* *cond_popcountvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !register_operand (operands[2], E_V3x8QImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4474; /* aarch64_vec_load_lanesv3x8qi_lanev8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !register_operand (operands[2], E_V3x4HImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4475; /* aarch64_vec_load_lanesv3x4hi_lanev4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !register_operand (operands[2], E_V3x2SImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4476; /* aarch64_vec_load_lanesv3x2si_lanev2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !register_operand (operands[2], E_V3x1DImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4477; /* aarch64_vec_load_lanesv3x1di_lanedi */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !register_operand (operands[2], E_V3x4HFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4478; /* aarch64_vec_load_lanesv3x4hf_lanev4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !register_operand (operands[2], E_V3x2SFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4479; /* aarch64_vec_load_lanesv3x2sf_lanev2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !register_operand (operands[2], E_V3x1DFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4480; /* aarch64_vec_load_lanesv3x1df_lanedf */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !register_operand (operands[2], E_V3x4BFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4481; /* aarch64_vec_load_lanesv3x4bf_lanev4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !register_operand (operands[2], E_V3x16QImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4482; /* aarch64_vec_load_lanesv3x16qi_lanev16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !register_operand (operands[2], E_V3x8HImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4483; /* aarch64_vec_load_lanesv3x8hi_lanev8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !register_operand (operands[2], E_V3x4SImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4484; /* aarch64_vec_load_lanesv3x4si_lanev4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !register_operand (operands[2], E_V3x2DImode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4485; /* aarch64_vec_load_lanesv3x2di_lanev2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !register_operand (operands[2], E_V3x8HFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4486; /* aarch64_vec_load_lanesv3x8hf_lanev8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !register_operand (operands[2], E_V3x4SFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4487; /* aarch64_vec_load_lanesv3x4sf_lanev4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !register_operand (operands[2], E_V3x2DFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4488; /* aarch64_vec_load_lanesv3x2df_lanev2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !register_operand (operands[2], E_V3x8BFmode)
          || !
#line 7485 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4489; /* aarch64_vec_load_lanesv3x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x3) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9790 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
            return -1;
          return 10889; /* aarch64_sve_fcvt_truncvnx4sfvnx8hf */

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9790 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10890; /* aarch64_sve_fcvt_truncvnx2dfvnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x3) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4SFmode:
              if (!register_operand (operands[2], E_VNx4SFmode)
                  || !
#line 9790 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                return -1;
              return 10891; /* aarch64_sve_fcvt_truncvnx4sfvnx4sf */

            case E_VNx8HFmode:
              if (!register_operand (operands[2], E_VNx8HFmode)
                  || !
#line 9947 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                return -1;
              return 10900; /* aarch64_sve_fcvt_nontruncvnx8hfvnx4sf */

            default:
              return -1;
            }

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9790 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10892; /* aarch64_sve_fcvt_truncvnx2dfvnx4sf */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (pattern865 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx8BFmode) != 0
          || !
#line 9847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
        return -1;
      return 10897; /* aarch64_sve_fcvt_truncvnx4sfvnx8bf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8HFmode:
          if (!register_operand (operands[2], E_VNx8HFmode)
              || !
#line 9947 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10901; /* aarch64_sve_fcvt_nontruncvnx8hfvnx2df */

        case E_VNx4SFmode:
          if (!register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9947 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10903; /* aarch64_sve_fcvt_nontruncvnx4sfvnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9949; /* while_ugesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9959; /* while_ugedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9969; /* while_ugesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9979; /* while_ugedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9989; /* while_ugesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9999; /* while_ugedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10009; /* while_ugesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10019; /* while_ugedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[2], E_V1DImode)
          || !
#line 7697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4582; /* aarch64_vec_ldap1_lanesv1di_lanesi */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[2], E_V1DFmode)
          || !
#line 7697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4583; /* aarch64_vec_ldap1_lanesv1df_lanedf */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[2], E_V2DImode)
          || !
#line 7697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4584; /* aarch64_vec_ldap1_lanesv2di_lanedi */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[2], E_V2DFmode)
          || !
#line 7697 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4585; /* aarch64_vec_ldap1_lanesv2df_lanedf */

    default:
      return -1;
    }
}

 int
recog_328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern180 (x1))
    {
    case 0:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11238; /* aarch64_st1vnx32qi */

    case 1:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11240; /* aarch64_st1vnx16hi */

    case 2:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11242; /* aarch64_st1vnx8si */

    case 3:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11244; /* aarch64_st1vnx4di */

    case 4:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11246; /* aarch64_st1vnx16bf */

    case 5:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11248; /* aarch64_st1vnx16hf */

    case 6:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11250; /* aarch64_st1vnx8sf */

    case 7:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11252; /* aarch64_st1vnx4df */

    case 8:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11254; /* aarch64_st1vnx64qi */

    case 9:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11256; /* aarch64_st1vnx32hi */

    case 10:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11258; /* aarch64_st1vnx16si */

    case 11:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11260; /* aarch64_st1vnx8di */

    case 12:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11262; /* aarch64_st1vnx32bf */

    case 13:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11264; /* aarch64_st1vnx32hf */

    case 14:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11266; /* aarch64_st1vnx16sf */

    case 15:
      if (!
#line 479 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11268; /* aarch64_st1vnx8df */

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5919; /* aarch64_ldnf1vnx16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5921; /* aarch64_ldnf1vnx8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5923; /* aarch64_ldnf1vnx4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5925; /* aarch64_ldnf1vnx2di */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5927; /* aarch64_ldnf1vnx8bf */

    case 5:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5929; /* aarch64_ldnf1vnx8hf */

    case 6:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5931; /* aarch64_ldnf1vnx4sf */

    case 7:
      x2 = XEXP (x1, 1);
      if (pattern928 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1401 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 5933; /* aarch64_ldnf1vnx2df */

    default:
      return -1;
    }
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern91 (x3, 
E_VNx16BImode, 
E_VNx16QImode) != 0
          || !
#line 164 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11077; /* aarch64_pmov_lane_to_vnx16qi */

    case E_VNx8HImode:
      if (pattern91 (x3, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 164 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11078; /* aarch64_pmov_lane_to_vnx8hi */

    case E_VNx4SImode:
      if (pattern91 (x3, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 164 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11079; /* aarch64_pmov_lane_to_vnx4si */

    case E_VNx2DImode:
      if (pattern91 (x3, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 164 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11080; /* aarch64_pmov_lane_to_vnx2di */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (pattern865 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 3529 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12598; /* aarch64_pred_flogbvnx8hf */

    case E_VNx4SImode:
      if (pattern865 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 3529 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12599; /* aarch64_pred_flogbvnx4sf */

    case E_VNx2DImode:
      if (pattern865 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 3529 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12600; /* aarch64_pred_flogbvnx2df */

    default:
      return -1;
    }
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern193 (x1))
    {
    case 0:
      if (!
#line 3015 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12496; /* aarch64_sve_sqrdcmlahvnx16qi */

    case 1:
      if (!
#line 3015 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12504; /* aarch64_sve_sqrdcmlahvnx8hi */

    case 2:
      if (!
#line 3015 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12512; /* aarch64_sve_sqrdcmlahvnx4si */

    case 3:
      if (!
#line 3015 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12520; /* aarch64_sve_sqrdcmlahvnx2di */

    case 4:
      if (!
#line 3032 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12528; /* aarch64_sqrdcmlah_lane_vnx8hi */

    case 5:
      if (!
#line 3032 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12536; /* aarch64_sqrdcmlah_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SFmode:
      if (pattern865 (x3, 
E_VNx8HFmode, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
          || !
#line 3146 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12556; /* aarch64_pred_fcvtltvnx4sf */

    case E_VNx2DFmode:
      if (pattern865 (x3, 
E_VNx4SFmode, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
          || !
#line 3146 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12557; /* aarch64_pred_fcvtltvnx2df */

    default:
      return -1;
    }
}

 int
recog_378 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern183 (x1))
    {
    case 0:
      if (!
#line 1450 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11806; /* aarch64_sve_sbclbvnx16qi */

    case 1:
      if (!
#line 1450 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11814; /* aarch64_sve_sbclbvnx8hi */

    case 2:
      if (!
#line 1450 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11822; /* aarch64_sve_sbclbvnx4si */

    case 3:
      if (!
#line 1450 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11830; /* aarch64_sve_sbclbvnx2di */

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern177 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 8))
        return -1;
      *pnum_clobbers = 1;
      return 10933; /* aarch64_sve_pnextvnx16bi */

    case 1:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      *pnum_clobbers = 1;
      return 10935; /* aarch64_sve_pnextvnx8bi */

    case 2:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      *pnum_clobbers = 1;
      return 10937; /* aarch64_sve_pnextvnx4bi */

    case 3:
      if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      *pnum_clobbers = 1;
      return 10939; /* aarch64_sve_pnextvnx2bi */

    default:
      return -1;
    }
}

 int
recog_394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (XWINT (x3, 0) != 1L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  x5 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x5))
    {
    case CONST:
      operands[1] = x5;
      if (!aarch64_sve_ptrue_svpattern_immediate (operands[1], E_VNx16BImode))
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 128
          || GET_MODE (x6) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[3] = x8;
      x9 = XVECEXP (x6, 0, 0);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x10 = XVECEXP (x6, 0, 1);
      operands[5] = x10;
      if (!aarch64_simd_imm_zero (operands[5], E_VNx16BImode)
          || !
#line 1035 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 5715; /* *aarch64_sve_ptruevnx16bi_ptest */

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x5), 0))
        return -1;
      x6 = XEXP (x5, 0);
      if (!aarch64_sve_ptrue_svpattern_immediate (x6, E_VNx16BImode))
        return -1;
      operands[1] = x6;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 2
          || XINT (x11, 1) != 128
          || GET_MODE (x11) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[2] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[3] = x8;
      x12 = XVECEXP (x11, 0, 0);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x13 = XVECEXP (x11, 0, 1);
      operands[5] = x13;
      switch (GET_MODE (x5))
        {
        case E_VNx8BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx8BImode)
              || !
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5716; /* *aarch64_sve_ptruevnx8bi_ptest */

        case E_VNx4BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx4BImode)
              || !
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5717; /* *aarch64_sve_ptruevnx4bi_ptest */

        case E_VNx2BImode:
          if (!aarch64_simd_imm_zero (operands[5], E_VNx2BImode)
              || !
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          *pnum_clobbers = 1;
          return 5718; /* *aarch64_sve_ptruevnx2bi_ptest */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x5) != 86
          || GET_MODE (x5) != E_VNx16BImode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      if (!rtx_equal_p (x8, operands[1])
          || !
#line 1200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      *pnum_clobbers = 1;
      return 5727; /* *aarch64_rdffr_ptest */

    case UNSPEC:
      return recog_393 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16QImode
      || pattern254 (x2, 
89, 
E_VNx16QImode, 
93) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_VNx16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 93
      || GET_MODE (x4) != E_VNx16QImode)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!pmode_register_operand (operands[1], E_VOIDmode)
          || !
#line 512 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME))
        return -1;
      return 12941; /* aarch64_sme_ldr0 */

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !aarch64_mov_operand (operands[3], E_SImode)
              || !(
#line 527 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 159 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
            return -1;
          return 12942; /* aarch64_sme_ldrnsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !aarch64_mov_operand (operands[3], E_DImode)
              || !(
#line 527 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME
   && aarch64_sme_ldr_vnum_offset_p (operands[1], operands[3])) && 
#line 160 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
            return -1;
          return 12943; /* aarch64_sme_ldrndi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[3] = x7;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      switch (XWINT (x3, 0))
        {
        case 8L:
          if (!
#line 643 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11363; /* aarch64_sve_psel8 */

        case 16L:
          if (!
#line 643 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11364; /* aarch64_sve_psel16 */

        case 32L:
          if (!
#line 643 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11365; /* aarch64_sve_psel32 */

        case 64L:
          if (!
#line 643 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11366; /* aarch64_sve_psel64 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (XWINT (x3, 0))
        {
        case 8L:
          if (!
#line 657 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 8))
            return -1;
          return 11367; /* *aarch64_sve_psel8_plus */

        case 16L:
          if (!
#line 657 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 16))
            return -1;
          return 11368; /* *aarch64_sve_psel16_plus */

        case 32L:
          if (!
#line 657 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 32))
            return -1;
          return 11369; /* *aarch64_sve_psel32_plus */

        case 64L:
          if (!
#line 657 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME
   && UINTVAL (operands[4]) < 128 / 64))
            return -1;
          return 11370; /* *aarch64_sve_psel64_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern214 (x1))
    {
    case 0:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11270; /* aarch64_st1vnx32qi_strided2 */

    case 1:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11272; /* aarch64_st1vnx16hi_strided2 */

    case 2:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11274; /* aarch64_st1vnx8si_strided2 */

    case 3:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11276; /* aarch64_st1vnx4di_strided2 */

    case 4:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11278; /* aarch64_st1vnx16bf_strided2 */

    case 5:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11280; /* aarch64_st1vnx16hf_strided2 */

    case 6:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11282; /* aarch64_st1vnx8sf_strided2 */

    case 7:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11284; /* aarch64_st1vnx4df_strided2 */

    case 8:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11286; /* aarch64_st1vnx64qi_strided2 */

    case 9:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11288; /* aarch64_st1vnx32hi_strided2 */

    case 10:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11290; /* aarch64_st1vnx16si_strided2 */

    case 11:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11292; /* aarch64_st1vnx8di_strided2 */

    case 12:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11294; /* aarch64_st1vnx32bf_strided2 */

    case 13:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11296; /* aarch64_st1vnx32hf_strided2 */

    case 14:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11298; /* aarch64_st1vnx16sf_strided2 */

    case 15:
      if (!
#line 492 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands + 2, 2, 8)))
        return -1;
      return 11300; /* aarch64_st1vnx8df_strided2 */

    default:
      return -1;
    }
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern933 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6071 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8941; /* aarch64_pred_subvnx8hf */

    case E_VNx4SFmode:
      if (pattern933 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6071 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8942; /* aarch64_pred_subvnx4sf */

    case E_VNx2DFmode:
      if (pattern933 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6071 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8943; /* aarch64_pred_subvnx2df */

    case E_VNx8BFmode:
      if (pattern200 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1346 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
        return -1;
      return 11783; /* aarch64_pred_subvnx8bf */

    default:
      return -1;
    }
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern246 (x1))
    {
    case 0:
      if (!
#line 1429 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13653; /* aarch64_sme_smlsvnx4sivnx16qi */

    case 1:
      if (!
#line 1429 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13657; /* aarch64_sme_smlsvnx4sivnx8hi */

    case 2:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13669; /* aarch64_sme_smlsvnx4sivnx32qi */

    case 3:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13673; /* aarch64_sme_smlsvnx4sivnx64qi */

    case 4:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13677; /* aarch64_sme_smlsvnx4sivnx16hi */

    case 5:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13681; /* aarch64_sme_smlsvnx4sivnx32hi */

    case 6:
      if (!
#line 1557 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13781; /* aarch64_sme_smlsvnx2divnx8hi */

    case 7:
      if (!
#line 1587 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13789; /* aarch64_sme_smlsvnx2divnx16hi */

    case 8:
      if (!
#line 1587 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13793; /* aarch64_sme_smlsvnx2divnx32hi */

    case 9:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13701; /* aarch64_sme_single_smlsvnx4sivnx32qi */

    case 10:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13705; /* aarch64_sme_single_smlsvnx4sivnx64qi */

    case 11:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13709; /* aarch64_sme_single_smlsvnx4sivnx16hi */

    case 12:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13713; /* aarch64_sme_single_smlsvnx4sivnx32hi */

    case 13:
      if (!
#line 1618 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13805; /* aarch64_sme_single_smlsvnx2divnx16hi */

    case 14:
      if (!
#line 1618 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13809; /* aarch64_sme_single_smlsvnx2divnx32hi */

    case 15:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13733; /* aarch64_sme_lane_smlsvnx4sivnx16qi */

    case 16:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13737; /* aarch64_sme_lane_smlsvnx4sivnx32qi */

    case 17:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13741; /* aarch64_sme_lane_smlsvnx4sivnx64qi */

    case 18:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13745; /* aarch64_sme_lane_smlsvnx4sivnx8hi */

    case 19:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13749; /* aarch64_sme_lane_smlsvnx4sivnx16hi */

    case 20:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13753; /* aarch64_sme_lane_smlsvnx4sivnx32hi */

    case 21:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13821; /* aarch64_sme_lane_smlsvnx2divnx8hi */

    case 22:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13825; /* aarch64_sme_lane_smlsvnx2divnx16hi */

    case 23:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13829; /* aarch64_sme_lane_smlsvnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1443 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13661; /* *aarch64_sme_smlsvnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1443 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13665; /* *aarch64_sme_smlsvnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1308 ())
            {
            case 0:
              if (
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13685; /* *aarch64_sme_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13689; /* *aarch64_sme_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1309 ())
        {
        case 0:
          if (!
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13693; /* *aarch64_sme_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13697; /* *aarch64_sme_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1571 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 13785; /* *aarch64_sme_smlsvnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1309 ())
        {
        case 0:
          if (!
#line 1601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13797; /* *aarch64_sme_smlsvnx2divnx16hi_plus */

        case 1:
          if (!
#line 1601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13801; /* *aarch64_sme_smlsvnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1310 (x3))
            {
            case 0:
              if (
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13717; /* *aarch64_sme_single_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13721; /* *aarch64_sme_single_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern245 (x3))
        {
        case 0:
          if (!
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13725; /* *aarch64_sme_single_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13729; /* *aarch64_sme_single_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1633 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13813; /* *aarch64_sme_single_smlsvnx2divnx16hi_plus */

    case 28:
      if (!
#line 1633 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13817; /* *aarch64_sme_single_smlsvnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13757; /* *aarch64_sme_lane_smlsvnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1348 (x3))
                {
                case 0:
                  if (
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13761; /* *aarch64_sme_lane_smlsvnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13765; /* *aarch64_sme_lane_smlsvnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 13769; /* *aarch64_sme_lane_smlsvnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1349 (x3))
        {
        case 0:
          if (!
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13773; /* *aarch64_sme_lane_smlsvnx4sivnx16hi */

        case 1:
          if (!
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13777; /* *aarch64_sme_lane_smlsvnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 13833; /* *aarch64_sme_lane_smlsvnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1349 (x3))
        {
        case 0:
          if (!
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13837; /* *aarch64_sme_lane_smlsvnx2divnx16hi */

        case 1:
          if (!
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13841; /* *aarch64_sme_lane_smlsvnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern229 (x1))
    {
    case 0:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13250; /* aarch64_sme_write_horvnx32qivnx32qi */

    case 1:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13252; /* aarch64_sme_write_horvnx16hivnx16hi */

    case 2:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13254; /* aarch64_sme_write_horvnx8sivnx8si */

    case 3:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13256; /* aarch64_sme_write_horvnx4divnx4di */

    case 4:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13258; /* aarch64_sme_write_horvnx16bfvnx16bf */

    case 5:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13260; /* aarch64_sme_write_horvnx16hfvnx16hf */

    case 6:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13262; /* aarch64_sme_write_horvnx8sfvnx8sf */

    case 7:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13264; /* aarch64_sme_write_horvnx4dfvnx4df */

    case 8:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13266; /* aarch64_sme_write_horvnx64qivnx64qi */

    case 9:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13268; /* aarch64_sme_write_horvnx32hivnx32hi */

    case 10:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13270; /* aarch64_sme_write_horvnx16sivnx16si */

    case 11:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13272; /* aarch64_sme_write_horvnx8divnx8di */

    case 12:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13274; /* aarch64_sme_write_horvnx32bfvnx32bf */

    case 13:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13276; /* aarch64_sme_write_horvnx32hfvnx32hf */

    case 14:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13278; /* aarch64_sme_write_horvnx16sfvnx16sf */

    case 15:
      if (!
#line 979 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13280; /* aarch64_sme_write_horvnx8dfvnx8df */

    case 16:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13282; /* *aarch64_sme_write_horvnx32qivnx32qi_plus */

    case 17:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13284; /* *aarch64_sme_write_horvnx16hivnx16hi_plus */

    case 18:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13286; /* *aarch64_sme_write_horvnx8sivnx8si_plus */

    case 19:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13288; /* *aarch64_sme_write_horvnx4divnx4di_plus */

    case 20:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13290; /* *aarch64_sme_write_horvnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13292; /* *aarch64_sme_write_horvnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13294; /* *aarch64_sme_write_horvnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13296; /* *aarch64_sme_write_horvnx4dfvnx4df_plus */

    case 24:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13298; /* *aarch64_sme_write_horvnx64qivnx64qi_plus */

    case 25:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13300; /* *aarch64_sme_write_horvnx32hivnx32hi_plus */

    case 26:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13302; /* *aarch64_sme_write_horvnx16sivnx16si_plus */

    case 27:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13304; /* *aarch64_sme_write_horvnx8divnx8di_plus */

    case 28:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13306; /* *aarch64_sme_write_horvnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13308; /* *aarch64_sme_write_horvnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13310; /* *aarch64_sme_write_horvnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 997 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13312; /* *aarch64_sme_write_horvnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 281:
      if (pattern196 (x1) != 0
          || !
#line 9007 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5201; /* aarch64_sm3tt1aqv4si */

    case 282:
      if (pattern196 (x1) != 0
          || !
#line 9007 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5202; /* aarch64_sm3tt1bqv4si */

    case 283:
      if (pattern196 (x1) != 0
          || !
#line 9007 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5203; /* aarch64_sm3tt2aqv4si */

    case 284:
      if (pattern196 (x1) != 0
          || !
#line 9007 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5204; /* aarch64_sm3tt2bqv4si */

    case 590:
      return recog_398 (x1, insn, pnum_clobbers);

    case 193:
      return recog_418 (x1, insn, pnum_clobbers);

    case 458:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 9982 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5340; /* aarch64_fmlalbv8hf */

        case 1:
          if (!
#line 2090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12001; /* aarch64_sve_add_fmlalbvnx8hf */

        case 2:
          if (!
#line 9997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5342; /* aarch64_fmlalb_lanev8hfv8qi */

        case 3:
          if (!
#line 9997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5344; /* aarch64_fmlalb_lanev8hfv16qi */

        default:
          return -1;
        }

    case 464:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 9982 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5341; /* aarch64_fmlaltv8hf */

        case 1:
          if (!
#line 2090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12002; /* aarch64_sve_add_fmlaltvnx8hf */

        case 2:
          if (!
#line 9997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5343; /* aarch64_fmlalt_lanev8hfv8qi */

        case 3:
          if (!
#line 9997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5345; /* aarch64_fmlalt_lanev8hfv16qi */

        default:
          return -1;
        }

    case 459:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10013 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5346; /* aarch64_fmlallbbv4sf */

        case 1:
          if (!
#line 2105 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12003; /* aarch64_sve_add_fmlallbbvnx4sf */

        case 2:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5350; /* aarch64_fmlallbb_lanev4sfv8qi */

        case 3:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5354; /* aarch64_fmlallbb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 460:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10013 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5347; /* aarch64_fmlallbtv4sf */

        case 1:
          if (!
#line 2105 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12004; /* aarch64_sve_add_fmlallbtvnx4sf */

        case 2:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5351; /* aarch64_fmlallbt_lanev4sfv8qi */

        case 3:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5355; /* aarch64_fmlallbt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 461:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10013 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5348; /* aarch64_fmlalltbv4sf */

        case 1:
          if (!
#line 2105 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12005; /* aarch64_sve_add_fmlalltbvnx4sf */

        case 2:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5352; /* aarch64_fmlalltb_lanev4sfv8qi */

        case 3:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5356; /* aarch64_fmlalltb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 462:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10013 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5349; /* aarch64_fmlallttv4sf */

        case 1:
          if (!
#line 2105 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 12006; /* aarch64_sve_add_fmlallttvnx4sf */

        case 2:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5353; /* aarch64_fmlalltt_lanev4sfv8qi */

        case 3:
          if (!
#line 10028 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5357; /* aarch64_fmlalltt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 127:
      return recog_396 (x1, insn, pnum_clobbers);

    case 390:
      return recog_411 (x1, insn, pnum_clobbers);

    case 352:
      switch (pattern201 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3373 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8488; /* aarch64_pred_famaxvnx8hf */

        case 1:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3373 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8492; /* aarch64_pred_famaxvnx4sf */

        case 2:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3373 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8496; /* aarch64_pred_famaxvnx2df */

        default:
          return -1;
        }

    case 353:
      switch (pattern201 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3374 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8489; /* aarch64_pred_faminvnx8hf */

        case 1:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3374 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8493; /* aarch64_pred_faminvnx4sf */

        case 2:
          if (!(
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3374 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8497; /* aarch64_pred_faminvnx2df */

        default:
          return -1;
        }

    case 370:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8490; /* aarch64_pred_divvnx8hf */

        case 1:
          if (!
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8494; /* aarch64_pred_divvnx4sf */

        case 2:
          if (!
#line 5437 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8498; /* aarch64_pred_divvnx2df */

        default:
          return -1;
        }

    case 378:
      return recog_422 (x1, insn, pnum_clobbers);

    case 351:
      return recog_420 (x1, insn, pnum_clobbers);

    case 354:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8911; /* aarch64_pred_cadd90vnx8hf */

        case 1:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8913; /* aarch64_pred_cadd90vnx4sf */

        case 2:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8915; /* aarch64_pred_cadd90vnx2df */

        default:
          return -1;
        }

    case 355:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8912; /* aarch64_pred_cadd270vnx8hf */

        case 1:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8914; /* aarch64_pred_cadd270vnx4sf */

        case 2:
          if (!
#line 5906 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8916; /* aarch64_pred_cadd270vnx2df */

        default:
          return -1;
        }

    case 392:
      return recog_421 (x1, insn, pnum_clobbers);

    case 377:
      return recog_419 (x1, insn, pnum_clobbers);

    case 371:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9014; /* aarch64_pred_fmax_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9020; /* aarch64_pred_fmax_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9026; /* aarch64_pred_fmax_nanvnx2df */

        case 3:
          if (!
#line 1346 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11777; /* aarch64_pred_fmax_nanvnx8bf */

        default:
          return -1;
        }

    case 372:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9015; /* aarch64_pred_fmaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9021; /* aarch64_pred_fmaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9027; /* aarch64_pred_fmaxvnx2df */

        case 3:
          if (!
#line 1346 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11778; /* aarch64_pred_fmaxvnx8bf */

        default:
          return -1;
        }

    case 373:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9016; /* aarch64_pred_fmin_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9022; /* aarch64_pred_fmin_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9028; /* aarch64_pred_fmin_nanvnx2df */

        case 3:
          if (!
#line 1346 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11779; /* aarch64_pred_fmin_nanvnx8bf */

        default:
          return -1;
        }

    case 374:
      return recog_410 (x1, insn, pnum_clobbers);

    case 394:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9018; /* aarch64_pred_smaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9024; /* aarch64_pred_smaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9030; /* aarch64_pred_smaxvnx2df */

        case 3:
          if (!
#line 1346 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11784; /* aarch64_pred_smaxvnx8bf */

        case 4:
          if (!
#line 2952 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12470; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2952 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12472; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2952 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12474; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 395:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9019; /* aarch64_pred_sminvnx8hf */

        case 1:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9025; /* aarch64_pred_sminvnx4sf */

        case 2:
          if (!
#line 6728 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9031; /* aarch64_pred_sminvnx2df */

        case 3:
          if (!
#line 1346 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11785; /* aarch64_pred_sminvnx8bf */

        case 4:
          if (!
#line 2952 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12471; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2952 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12473; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2952 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12475; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 578:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3266 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9407; /* aarch64_sve_bfdot_lanevnx4sf */

    case 579:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3267 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9408; /* aarch64_sve_bfmlalb_lanevnx4sf */

    case 580:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3268 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9409; /* aarch64_sve_bfmlalt_lanevnx4sf */

    case 581:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3269 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9410; /* aarch64_sve_bfmlslb_lanevnx4sf */

    case 582:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3270 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9411; /* aarch64_sve_bfmlslt_lanevnx4sf */

    case 356:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10182; /* aarch64_pred_fcmeqvnx8hf */

        case 1:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10188; /* aarch64_pred_fcmeqvnx4sf */

        case 2:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10194; /* aarch64_pred_fcmeqvnx2df */

        default:
          return -1;
        }

    case 357:
      return recog_416 (x1, insn, pnum_clobbers);

    case 358:
      return recog_415 (x1, insn, pnum_clobbers);

    case 363:
      return recog_414 (x1, insn, pnum_clobbers);

    case 364:
      return recog_413 (x1, insn, pnum_clobbers);

    case 365:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10187; /* aarch64_pred_fcmnevnx8hf */

        case 1:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10193; /* aarch64_pred_fcmnevnx4sf */

        case 2:
          if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10199; /* aarch64_pred_fcmnevnx2df */

        default:
          return -1;
        }

    case 366:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern935 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 8528 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10200; /* aarch64_pred_fcmuovnx8hf */

        case E_VNx4BImode:
          if (pattern935 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 8528 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10201; /* aarch64_pred_fcmuovnx4sf */

        case E_VNx2BImode:
          if (pattern935 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 8528 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10202; /* aarch64_pred_fcmuovnx2df */

        default:
          return -1;
        }

    case 438:
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern866 (x2, 
E_VNx4SFmode, 
E_VNx8BFmode, 
E_VNx4BImode) != 0
              || !
#line 9901 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
            return -1;
          return 10899; /* aarch64_sve_cvtntvnx8bf */

        case E_VNx8HFmode:
          if (pattern866 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
              || !
#line 3232 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12570; /* aarch64_sve_cvtntvnx8hf */

        case E_VNx4SFmode:
          if (pattern866 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
              || !
#line 3232 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12571; /* aarch64_sve_cvtntvnx4sf */

        default:
          return -1;
        }

    case 120:
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11181; /* aarch64_gather_ld1q */

    case 122:
      return recog_412 (x1, insn, pnum_clobbers);

    case 540:
      return recog_409 (x1, insn, pnum_clobbers);

    case 541:
      return recog_408 (x1, insn, pnum_clobbers);

    case 621:
      if (pattern215 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!aarch64_reg_or_zero (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 529 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11334; /* aarch64_scatter_st1q */

    case 124:
      return recog_401 (x1, insn, pnum_clobbers);

    case 480:
      return recog_404 (x1, insn, pnum_clobbers);

    case 442:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 84
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_VNx16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx16QImode))
        return -1;
      switch (pattern1050 (x2))
        {
        case 0:
          if (!
#line 2161 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx8HFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12013; /* aarch64_sve_dotvnx8hf */

        case 1:
          if (!
#line 2161 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx4SFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12014; /* aarch64_sve_dotvnx4sf */

        default:
          return -1;
        }

    case 440:
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VNx4SFmode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DFmode)
          || !
#line 3322 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12575; /* aarch64_sve2_cvtxntvnx2df */

    case 136:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12634; /* aarch64_sve_whilege_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12642; /* aarch64_sve_whilege_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12650; /* aarch64_sve_whilege_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12658; /* aarch64_sve_whilege_b64_x2 */

        default:
          return -1;
        }

    case 137:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12635; /* aarch64_sve_whilegt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12643; /* aarch64_sve_whilegt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12651; /* aarch64_sve_whilegt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12659; /* aarch64_sve_whilegt_b64_x2 */

        default:
          return -1;
        }

    case 138:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12636; /* aarch64_sve_whileugt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12644; /* aarch64_sve_whileugt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12652; /* aarch64_sve_whileugt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12660; /* aarch64_sve_whileugt_b64_x2 */

        default:
          return -1;
        }

    case 139:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12637; /* aarch64_sve_whileuge_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12645; /* aarch64_sve_whileuge_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12653; /* aarch64_sve_whileuge_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12661; /* aarch64_sve_whileuge_b64_x2 */

        default:
          return -1;
        }

    case 140:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12638; /* aarch64_sve_whilele_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12646; /* aarch64_sve_whilele_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12654; /* aarch64_sve_whilele_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12662; /* aarch64_sve_whilele_b64_x2 */

        default:
          return -1;
        }

    case 141:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12639; /* aarch64_sve_whileult_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12647; /* aarch64_sve_whileult_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12655; /* aarch64_sve_whileult_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12663; /* aarch64_sve_whileult_b64_x2 */

        default:
          return -1;
        }

    case 142:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12640; /* aarch64_sve_whileule_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12648; /* aarch64_sve_whileule_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12656; /* aarch64_sve_whileule_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12664; /* aarch64_sve_whileule_b64_x2 */

        default:
          return -1;
        }

    case 143:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12641; /* aarch64_sve_whilelt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12649; /* aarch64_sve_whilelt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12657; /* aarch64_sve_whilelt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12665; /* aarch64_sve_whilelt_b64_x2 */

        default:
          return -1;
        }

    case 693:
      return recog_417 (x1, insn, pnum_clobbers);

    case 697:
      return recog_403 (x1, insn, pnum_clobbers);

    case 699:
      return recog_402 (x1, insn, pnum_clobbers);

    case 648:
      return recog_400 (x1, insn, pnum_clobbers);

    case 649:
      return recog_399 (x1, insn, pnum_clobbers);

    case 677:
      return recog_405 (x1, insn, pnum_clobbers);

    case 701:
      return recog_397 (x1, insn, pnum_clobbers);

    case 631:
      return recog_424 (x1, insn, pnum_clobbers);

    case 661:
      return recog_423 (x1, insn, pnum_clobbers);

    case 637:
      return recog_407 (x1, insn, pnum_clobbers);

    case 644:
      return recog_406 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern606 (x2, 
E_SImode))
                {
                case 0:
                  return 215; /* *add_zero_extendqi_si */

                case 1:
                  return 219; /* *add_zero_extendhi_si */

                case 2:
                  return 223; /* *add_zero_extendsi_si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern606 (x2, 
E_DImode))
                {
                case 0:
                  return 217; /* *add_zero_extendqi_di */

                case 1:
                  return 221; /* *add_zero_extendhi_di */

                case 2:
                  return 225; /* *add_zero_extendsi_di */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern607 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3050; /* aarch64_uaddwv8qi */

            case E_V4SImode:
              if (pattern607 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3052; /* aarch64_uaddwv4hi */

            case E_V2DImode:
              if (pattern607 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3054; /* aarch64_uaddwv2si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern291 (x2))
            {
            case 0:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3021; /* aarch64_uaddlv8qi */

            case 1:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3025; /* aarch64_uaddlv4hi */

            case 2:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3029; /* aarch64_uaddlv2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SMAX:
          switch (pattern613 (x2, 
SMIN))
            {
            case 0:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1674; /* aarch64_sabalv8qi */

            case 1:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1676; /* aarch64_sabalv4hi */

            case 2:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1678; /* aarch64_sabalv2si */

            case 3:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1680; /* aarch64_sabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1682; /* aarch64_sabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1684; /* aarch64_sabal2v4si_insn */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern613 (x2, 
UMIN))
            {
            case 0:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1675; /* aarch64_uabalv8qi */

            case 1:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1677; /* aarch64_uabalv4hi */

            case 2:
              if (!
#line 964 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1679; /* aarch64_uabalv2si */

            case 3:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1681; /* aarch64_uabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1683; /* aarch64_uabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1685; /* aarch64_uabal2v4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern608 (x2))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2997; /* aarch64_uaddlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3009; /* aarch64_uaddlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3001; /* aarch64_uaddlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3013; /* aarch64_uaddlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3005; /* aarch64_uaddlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3017; /* aarch64_uaddlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern610 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3056; /* aarch64_uaddwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3062; /* aarch64_uaddw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3058; /* aarch64_uaddwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3064; /* aarch64_uaddw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3060; /* aarch64_uaddwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3066; /* aarch64_uaddw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern375 (x2, 
E_DImode) != 0)
        return -1;
      switch (pattern326 (x2))
        {
        case 0:
          if (!
#line 10381 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10957; /* aarch64_sve_incdi_pat */

        case 1:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10991; /* *aarch64_sve_incdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10994; /* *aarch64_sve_incdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10997; /* *aarch64_sve_incdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11000; /* *aarch64_sve_incdivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      switch (pattern396 (x3))
        {
        case 0:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8171; /* *bicvnx16qi3 */

        case 1:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8172; /* *bicvnx8qi3 */

        case 2:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8173; /* *bicvnx4qi3 */

        case 3:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8174; /* *bicvnx2qi3 */

        case 4:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8175; /* *bicvnx8hi3 */

        case 5:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8176; /* *bicvnx4hi3 */

        case 6:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8177; /* *bicvnx2hi3 */

        case 7:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8178; /* *bicvnx4si3 */

        case 8:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8179; /* *bicvnx2si3 */

        case 9:
          if (!
#line 4757 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8180; /* *bicvnx2di3 */

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL
          || XINT (x4, 1) != 126)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x8))
        {
        case LT:
          switch (pattern945 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9752; /* *cmpltvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9762; /* *cmpltvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9792; /* *cmpltvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9772; /* *cmpltvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9802; /* *cmpltvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9822; /* *cmpltvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9782; /* *cmpltvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9812; /* *cmpltvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9832; /* *cmpltvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9842; /* *cmpltvnx2di_and */

            default:
              return -1;
            }

        case LE:
          switch (pattern945 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9753; /* *cmplevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9763; /* *cmplevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9793; /* *cmplevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9773; /* *cmplevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9803; /* *cmplevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9823; /* *cmplevnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9783; /* *cmplevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9813; /* *cmplevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9833; /* *cmplevnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9843; /* *cmplevnx2di_and */

            default:
              return -1;
            }

        case EQ:
          switch (pattern945 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9754; /* *cmpeqvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9764; /* *cmpeqvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9794; /* *cmpeqvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9774; /* *cmpeqvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9804; /* *cmpeqvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9824; /* *cmpeqvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9784; /* *cmpeqvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9814; /* *cmpeqvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9834; /* *cmpeqvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9844; /* *cmpeqvnx2di_and */

            default:
              return -1;
            }

        case NE:
          switch (pattern945 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9755; /* *cmpnevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9765; /* *cmpnevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9795; /* *cmpnevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9775; /* *cmpnevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9805; /* *cmpnevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9825; /* *cmpnevnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9785; /* *cmpnevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9815; /* *cmpnevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9835; /* *cmpnevnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9845; /* *cmpnevnx2di_and */

            default:
              return -1;
            }

        case GE:
          switch (pattern945 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9756; /* *cmpgevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9766; /* *cmpgevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9796; /* *cmpgevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9776; /* *cmpgevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9806; /* *cmpgevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9826; /* *cmpgevnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9786; /* *cmpgevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9816; /* *cmpgevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9836; /* *cmpgevnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9846; /* *cmpgevnx2di_and */

            default:
              return -1;
            }

        case GT:
          switch (pattern945 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9757; /* *cmpgtvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9767; /* *cmpgtvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9797; /* *cmpgtvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9777; /* *cmpgtvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9807; /* *cmpgtvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9827; /* *cmpgtvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9787; /* *cmpgtvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9817; /* *cmpgtvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9837; /* *cmpgtvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9847; /* *cmpgtvnx2di_and */

            default:
              return -1;
            }

        case LTU:
          switch (pattern946 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9758; /* *cmplovnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9768; /* *cmplovnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9798; /* *cmplovnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9778; /* *cmplovnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9808; /* *cmplovnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9828; /* *cmplovnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9788; /* *cmplovnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9818; /* *cmplovnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9838; /* *cmplovnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9848; /* *cmplovnx2di_and */

            default:
              return -1;
            }

        case LEU:
          switch (pattern946 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9759; /* *cmplsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9769; /* *cmplsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9799; /* *cmplsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9779; /* *cmplsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9809; /* *cmplsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9829; /* *cmplsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9789; /* *cmplsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9819; /* *cmplsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9839; /* *cmplsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9849; /* *cmplsvnx2di_and */

            default:
              return -1;
            }

        case GEU:
          switch (pattern946 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9760; /* *cmphsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9770; /* *cmphsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9800; /* *cmphsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9780; /* *cmphsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9810; /* *cmphsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9830; /* *cmphsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9790; /* *cmphsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9820; /* *cmphsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9840; /* *cmphsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9850; /* *cmphsvnx2di_and */

            default:
              return -1;
            }

        case GTU:
          switch (pattern946 (x3))
            {
            case 0:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9761; /* *cmphivnx16qi_and */

            case 1:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9771; /* *cmphivnx8qi_and */

            case 2:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9801; /* *cmphivnx8hi_and */

            case 3:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9781; /* *cmphivnx4qi_and */

            case 4:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9811; /* *cmphivnx4hi_and */

            case 5:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9831; /* *cmphivnx4si_and */

            case 6:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9791; /* *cmphivnx2qi_and */

            case 7:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9821; /* *cmphivnx2hi_and */

            case 8:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9841; /* *cmphivnx2si_and */

            case 9:
              if (!
#line 8286 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9851; /* *cmphivnx2di_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      switch (pattern399 (x3))
        {
        case 0:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10203; /* *fcmeqvnx8hf_and_combine */

        case 1:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10209; /* *fcmeqvnx4sf_and_combine */

        case 2:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10215; /* *fcmeqvnx2df_and_combine */

        case 3:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10204; /* *fcmgevnx8hf_and_combine */

        case 4:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10210; /* *fcmgevnx4sf_and_combine */

        case 5:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10216; /* *fcmgevnx2df_and_combine */

        case 6:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10205; /* *fcmgtvnx8hf_and_combine */

        case 7:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10211; /* *fcmgtvnx4sf_and_combine */

        case 8:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10217; /* *fcmgtvnx2df_and_combine */

        case 9:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10206; /* *fcmlevnx8hf_and_combine */

        case 10:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10212; /* *fcmlevnx4sf_and_combine */

        case 11:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10218; /* *fcmlevnx2df_and_combine */

        case 12:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10207; /* *fcmltvnx8hf_and_combine */

        case 13:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10213; /* *fcmltvnx4sf_and_combine */

        case 14:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10219; /* *fcmltvnx2df_and_combine */

        case 15:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10208; /* *fcmnevnx8hf_and_combine */

        case 16:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10214; /* *fcmnevnx4sf_and_combine */

        case 17:
          if (!
#line 8550 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10220; /* *fcmnevnx2df_and_combine */

        case 18:
          if (!
#line 8573 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10221; /* *fcmuovnx8hf_and_combine */

        case 19:
          if (!
#line 8573 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10222; /* *fcmuovnx4sf_and_combine */

        case 20:
          if (!
#line 8573 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10223; /* *fcmuovnx2df_and_combine */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern517 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1586; /* negv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1590; /* negv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1594; /* negv2si2_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2682 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2383; /* negv4hf2_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2682 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2387; /* negv2sf2_vec_concatz_be */

        default:
          return -1;
        }

    case LT:
      switch (pattern520 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4071; /* aarch64_cmltv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4091; /* aarch64_cmltv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4236; /* aarch64_cmltv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4111; /* aarch64_cmltv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4256; /* aarch64_cmltv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4291; /* aarch64_cmltdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4306; /* aarch64_facltv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4322; /* aarch64_facltv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4350; /* aarch64_facltdf_vec_concatz_be */

        default:
          return -1;
        }

    case LE:
      switch (pattern520 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4074; /* aarch64_cmlev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4094; /* aarch64_cmlev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4239; /* aarch64_cmlev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4114; /* aarch64_cmlev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4259; /* aarch64_cmlev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4294; /* aarch64_cmledf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4309; /* aarch64_faclev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4325; /* aarch64_faclev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4353; /* aarch64_facledf_vec_concatz_be */

        default:
          return -1;
        }

    case EQ:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      switch (pattern518 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4077; /* aarch64_cmeqv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4097; /* aarch64_cmeqv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4242; /* aarch64_cmeqv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4117; /* aarch64_cmeqv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4262; /* aarch64_cmeqv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4297; /* aarch64_cmeqdf_vec_concatz_be */

        default:
          return -1;
        }

    case GE:
      switch (pattern520 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4080; /* aarch64_cmgev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4100; /* aarch64_cmgev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4245; /* aarch64_cmgev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4120; /* aarch64_cmgev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4265; /* aarch64_cmgev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4300; /* aarch64_cmgedf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4312; /* aarch64_facgev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4328; /* aarch64_facgev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4356; /* aarch64_facgedf_vec_concatz_be */

        default:
          return -1;
        }

    case GT:
      switch (pattern520 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4083; /* aarch64_cmgtv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4103; /* aarch64_cmgtv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4248; /* aarch64_cmgtv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 6997 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4123; /* aarch64_cmgtv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4268; /* aarch64_cmgtv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7214 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4303; /* aarch64_cmgtdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 181 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4315; /* aarch64_facgtv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4331; /* aarch64_facgtv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7235 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4359; /* aarch64_facgtdf_vec_concatz_be */

        default:
          return -1;
        }

    case LTU:
      switch (pattern522 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4146; /* aarch64_cmltuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4162; /* aarch64_cmltuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4178; /* aarch64_cmltuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case LEU:
      switch (pattern522 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4149; /* aarch64_cmleuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4165; /* aarch64_cmleuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4181; /* aarch64_cmleuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GEU:
      switch (pattern522 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4152; /* aarch64_cmgeuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4168; /* aarch64_cmgeuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4184; /* aarch64_cmgeuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GTU:
      switch (pattern522 (x2))
        {
        case 0:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4155; /* aarch64_cmgtuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4171; /* aarch64_cmgtuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7062 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4187; /* aarch64_cmgtuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case NE:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != AND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7200 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 4233; /* *aarch64_cmtstdi_vec_concatz_be */

    default:
      return -1;
    }
}

 int
recog_496 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern663 (x2))
            {
            case 0:
              if (!
#line 1829 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2189; /* aarch64_xtn2v8hi_insn_le */

            case 1:
              if (!
#line 1829 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2190; /* aarch64_xtn2v4si_insn_le */

            case 2:
              if (!
#line 1829 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 2191; /* aarch64_xtn2v2di_insn_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              x7 = XEXP (x6, 0);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  switch (pattern762 (x2))
                    {
                    case 0:
                      if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3175; /* aarch64_addhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3177; /* aarch64_addhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3179; /* aarch64_addhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern823 (x2))
                    {
                    case 0:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3181; /* aarch64_raddhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3183; /* aarch64_raddhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3185; /* aarch64_raddhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                case MINUS:
                  switch (pattern823 (x2))
                    {
                    case 0:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3182; /* aarch64_rsubhn2v8hi_insn_le */

                    case 1:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3184; /* aarch64_rsubhn2v4si_insn_le */

                    case 2:
                      if (!
#line 4927 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 3186; /* aarch64_rsubhn2v2di_insn_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern762 (x2))
                {
                case 0:
                  if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3176; /* aarch64_subhn2v8hi_insn_le */

                case 1:
                  if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3178; /* aarch64_subhn2v4si_insn_le */

                case 2:
                  if (!
#line 4911 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3180; /* aarch64_subhn2v2di_insn_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern666 (x2))
                {
                case 0:
                  if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4007; /* aarch64_sshrn2_nv8hi_insn_le */

                case 1:
                  if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4013; /* aarch64_sshrn2_nv4si_insn_le */

                case 2:
                  if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                    return -1;
                  return 4019; /* aarch64_sshrn2_nv2di_insn_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SMIN:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != SMAX)
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x8 = XEXP (x6, 1);
              operands[3] = x8;
              x9 = XEXP (x5, 1);
              operands[4] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1073 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !
#line 5298 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3389; /* aarch64_sqxtun2v8hi_le */

                case E_V8HImode:
                  if (pattern1073 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !
#line 5298 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3390; /* aarch64_sqxtun2v4si_le */

                case E_V4SImode:
                  if (pattern1073 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !
#line 5298 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                    return -1;
                  return 3391; /* aarch64_sqxtun2v2di_le */

                default:
                  return -1;
                }

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              operands[3] = x10;
              x11 = XEXP (x7, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  operands[2] = x11;
                  x8 = XEXP (x6, 1);
                  operands[4] = x8;
                  x9 = XEXP (x5, 1);
                  operands[5] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern1162 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V8HImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V8HImode)
                          || !
#line 6869 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4057; /* aarch64_sqshrun2_nv8hi_insn_le */

                    case E_V8HImode:
                      if (pattern1162 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V4SImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V4SImode)
                          || !
#line 6869 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4058; /* aarch64_sqshrun2_nv4si_insn_le */

                    case E_V4SImode:
                      if (pattern1162 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                          || !aarch64_simd_imm_zero (operands[4], E_V2DImode)
                          || !aarch64_simd_umax_half_mode (operands[5], E_V2DImode)
                          || !
#line 6869 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 4059; /* aarch64_sqshrun2_nv2di_insn_le */

                    default:
                      return -1;
                    }

                case PLUS:
                  x12 = XEXP (x11, 0);
                  if (GET_CODE (x12) != SIGN_EXTEND)
                    return -1;
                  x13 = XEXP (x12, 0);
                  operands[2] = x13;
                  x14 = XEXP (x11, 1);
                  operands[4] = x14;
                  x8 = XEXP (x6, 1);
                  operands[5] = x8;
                  x9 = XEXP (x5, 1);
                  operands[6] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern1225 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                          || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V8SImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V8SImode)
                          || !
#line 6931 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4063; /* aarch64_sqrshrun2_nv8hi_insn_le */

                    case E_V8HImode:
                      if (pattern1225 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                          || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V4DImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V4DImode)
                          || !
#line 6931 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4064; /* aarch64_sqrshrun2_nv4si_insn_le */

                    case E_V4SImode:
                      if (pattern1225 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                          || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                          || !aarch64_simd_imm_zero (operands[5], E_V2TImode)
                          || !aarch64_simd_umax_quarter_mode (operands[6], E_V2TImode)
                          || !
#line 6931 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4065; /* aarch64_sqrshrun2_nv2di_insn_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern665 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4008; /* aarch64_ushrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4014; /* aarch64_ushrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4020; /* aarch64_ushrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4041; /* aarch64_rshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4044; /* aarch64_rshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4047; /* aarch64_rshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 587
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V2SFmode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V2DFmode)
              || !
#line 3219 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2643; /* aarch64_float_trunc_rodd_hi_v4sf_le */

        case 3:
          if (XINT (x3, 1) != 187
              || GET_MODE (x3) != E_V8QImode)
            return -1;
          x16 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 84
              || GET_MODE (x16) != E_DImode
              || !register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_V8QImode))
            return -1;
          x15 = XVECEXP (x3, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x17 = XVECEXP (x3, 0, 1);
          operands[3] = x17;
          if (!register_operand (operands[3], E_V4SFmode)
              || !
#line 9919 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8 && !BYTES_BIG_ENDIAN))
            return -1;
          return 5321; /* aarch64_fcvtnv4sf_high_le */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern662 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 3264 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2651; /* aarch64_float_truncate_hi_v4sf_le */

        case E_V8HFmode:
          if (pattern662 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !
#line 3264 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
            return -1;
          return 2652; /* aarch64_float_truncate_hi_v8hf_le */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_491 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern763 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2975; /* *aarch64_combinezv8qi */

        case E_V8HImode:
          if (pattern763 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2976; /* *aarch64_combinezv4hi */

        case E_V8BFmode:
          if (pattern763 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2977; /* *aarch64_combinezv4bf */

        case E_V8HFmode:
          if (pattern763 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2978; /* *aarch64_combinezv4hf */

        case E_V4SImode:
          if (pattern763 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2979; /* *aarch64_combinezv2si */

        case E_V4SFmode:
          if (pattern763 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2980; /* *aarch64_combinezv2sf */

        case E_V2SImode:
          if (pattern763 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2981; /* *aarch64_combinezsi */

        case E_V2SFmode:
          if (pattern763 (x2, 
E_SFmode, 
E_V2SFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2982; /* *aarch64_combinezsf */

        case E_V2DImode:
          if (pattern763 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2983; /* *aarch64_combinezdi */

        case E_V2DFmode:
          if (pattern763 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4392 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT && !BYTES_BIG_ENDIAN))
            return -1;
          return 2984; /* *aarch64_combinezdf */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern663 (x2))
            {
            case 0:
              if (!
#line 5212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3365; /* aarch64_sqxtn2v8hi_le */

            case 1:
              if (!
#line 5212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3367; /* aarch64_sqxtn2v4si_le */

            case 2:
              if (!
#line 5212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3369; /* aarch64_sqxtn2v2di_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern665 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4003; /* aarch64_sqsshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4009; /* aarch64_sqsshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4015; /* aarch64_sqsshrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4039; /* aarch64_sqrshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4042; /* aarch64_sqrshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4045; /* aarch64_sqrshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern666 (x2))
            {
            case 0:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4004; /* aarch64_squshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4010; /* aarch64_squshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4016; /* aarch64_squshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern663 (x2))
            {
            case 0:
              if (!
#line 5212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3366; /* aarch64_uqxtn2v8hi_le */

            case 1:
              if (!
#line 5212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3368; /* aarch64_uqxtn2v4si_le */

            case 2:
              if (!
#line 5212 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return -1;
              return 3370; /* aarch64_uqxtn2v2di_le */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern666 (x2))
            {
            case 0:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4005; /* aarch64_uqsshrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4011; /* aarch64_uqsshrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4017; /* aarch64_uqsshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern665 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4006; /* aarch64_uqushrn2_nv8hi_insn_le */

            case 1:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4012; /* aarch64_uqushrn2_nv4si_insn_le */

            case 2:
              if (!
#line 6743 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (US_TRUNCATE, LSHIFTRT)))
                return -1;
              return 4018; /* aarch64_uqushrn2_nv2di_insn_le */

            case 3:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4040; /* aarch64_uqrshrn2_nv8hi_insn_le */

            case 4:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4043; /* aarch64_uqrshrn2_nv4si_insn_le */

            case 5:
              if (!
#line 6795 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4046; /* aarch64_uqrshrn2_nv2di_insn_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_469 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (!register_operand (x5, E_VNx16BImode))
        return -1;
      operands[1] = x5;
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 86
          && GET_MODE (x3) == E_VNx16BImode
          && 
#line 1162 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return 5725; /* aarch64_rdffr_z */
      operands[2] = x5;
      operands[1] = x3;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !
#line 6759 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9032; /* andvnx16bi3 */

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_CODE (operands[3]))
        {
        case REG:
        case SUBREG:
          switch (pattern49 (x2))
            {
            case 0:
              return 530; /* and_ashlsi3 */

            case 1:
              return 545; /* and_ashldi3 */

            default:
              return -1;
            }

        case CONST_INT:
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern925 (x2, 
E_SImode) != 0
                  || !
#line 6601 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (SImode, operands[3], operands[2])))
                return -1;
              return 864; /* *andim_ashiftsi_bfiz */

            case E_DImode:
              if (pattern925 (x2, 
E_DImode) != 0
                  || !
#line 6601 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (DImode, operands[3], operands[2])))
                return -1;
              return 865; /* *andim_ashiftdi_bfiz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern50 (x2))
        {
        case 0:
          return 533; /* and_ashrsi3 */

        case 1:
          return 548; /* and_ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[2] = x7;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern282 (x2))
        {
        case 0:
          return 536; /* and_lshrsi3 */

        case 1:
          return 551; /* and_lshrdi3 */

        default:
          break;
        }
      if (XWINT (x7, 0) != 56L)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 175
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[2] = x11;
      if (!aarch64_granule16_simm9 (operands[2], E_DImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode)
          || !
#line 8411 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1216; /* stg */

    case ROTATERT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern50 (x2))
        {
        case 0:
          return 539; /* and_rotrsi3 */

        case 1:
          return 554; /* and_rotrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern50 (x2))
        {
        case 0:
          return 542; /* and_rotlsi3 */

        case 1:
          return 557; /* and_rotldi3 */

        default:
          return -1;
        }

    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern707 (x2, 
E_SImode) != 0)
                return -1;
              return 588; /* andnsi3 */

            case E_DImode:
              if (pattern707 (x2, 
E_DImode) != 0)
                return -1;
              return 590; /* andndi3 */

            case E_V8QImode:
              if (pattern707 (x2, 
E_V8QImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1325; /* andnv8qi3 */

            case E_V16QImode:
              if (pattern707 (x2, 
E_V16QImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1328; /* andnv16qi3 */

            case E_V4HImode:
              if (pattern707 (x2, 
E_V4HImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1329; /* andnv4hi3 */

            case E_V8HImode:
              if (pattern707 (x2, 
E_V8HImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1332; /* andnv8hi3 */

            case E_V2SImode:
              if (pattern707 (x2, 
E_V2SImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1333; /* andnv2si3 */

            case E_V4SImode:
              if (pattern707 (x2, 
E_V4SImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1336; /* andnv4si3 */

            case E_V2DImode:
              if (pattern707 (x2, 
E_V2DImode) != 0
                  || !
#line 337 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1337; /* andnv2di3 */

            case E_VNx16BImode:
              if (pattern707 (x2, 
E_VNx16BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7331; /* *one_cmplvnx16bi3 */

            case E_VNx8BImode:
              if (pattern707 (x2, 
E_VNx8BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7332; /* *one_cmplvnx8bi3 */

            case E_VNx4BImode:
              if (pattern707 (x2, 
E_VNx4BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7333; /* *one_cmplvnx4bi3 */

            case E_VNx2BImode:
              if (pattern707 (x2, 
E_VNx2BImode) != 0
                  || !
#line 3864 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7334; /* *one_cmplvnx2bi3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern365 (x2))
            {
            case 0:
              return 602; /* and_one_cmpl_ashlsi3 */

            case 1:
              return 617; /* and_one_cmpl_ashldi3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern365 (x2))
            {
            case 0:
              return 605; /* and_one_cmpl_ashrsi3 */

            case 1:
              return 620; /* and_one_cmpl_ashrdi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern365 (x2))
            {
            case 0:
              return 608; /* and_one_cmpl_lshrsi3 */

            case 1:
              return 623; /* and_one_cmpl_lshrdi3 */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern365 (x2))
            {
            case 0:
              return 611; /* and_one_cmpl_rotrsi3 */

            case 1:
              return 626; /* and_one_cmpl_rotrdi3 */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern365 (x2))
            {
            case 0:
              return 614; /* and_one_cmpl_rotlsi3 */

            case 1:
              return 629; /* and_one_cmpl_rotldi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_470 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern299 (x2))
            {
            case 0:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9036; /* aarch64_pred_andvnx16bi_z */

            case 1:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9039; /* aarch64_pred_andvnx8bi_z */

            case 2:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9042; /* aarch64_pred_andvnx4bi_z */

            case 3:
              if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9045; /* aarch64_pred_andvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (pattern508 (x2))
                {
                case 0:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9072; /* aarch64_pred_bicvnx16bi_z */

                case 1:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9074; /* aarch64_pred_bicvnx8bi_z */

                case 2:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9076; /* aarch64_pred_bicvnx4bi_z */

                case 3:
                  if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9078; /* aarch64_pred_bicvnx2bi_z */

                case 4:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9096; /* aarch64_pred_norvnx16bi_z */

                case 5:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9098; /* aarch64_pred_norvnx8bi_z */

                case 6:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9100; /* aarch64_pred_norvnx4bi_z */

                case 7:
                  if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9102; /* aarch64_pred_norvnx2bi_z */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pnum_clobbers == NULL
                  || XVECLEN (x12, 0) != 4)
                return -1;
              x13 = XVECEXP (x12, 0, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x14 = XVECEXP (x12, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x12, 0, 2);
              operands[2] = x15;
              x16 = XVECEXP (x12, 0, 3);
              operands[3] = x16;
              x5 = XEXP (x2, 1);
              if (!rtx_equal_p (x5, operands[1]))
                return -1;
              switch (XINT (x12, 1))
                {
                case 356:
                  switch (pattern1125 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10224; /* *fcmeqvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10230; /* *fcmeqvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10236; /* *fcmeqvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10242; /* *fcmeqvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10248; /* *fcmeqvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10254; /* *fcmeqvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 357:
                  switch (pattern1125 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10225; /* *fcmgevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10231; /* *fcmgevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10237; /* *fcmgevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10243; /* *fcmgevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10249; /* *fcmgevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10255; /* *fcmgevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 358:
                  switch (pattern1125 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10226; /* *fcmgtvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10232; /* *fcmgtvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10238; /* *fcmgtvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10244; /* *fcmgtvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10250; /* *fcmgtvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10256; /* *fcmgtvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 363:
                  switch (pattern1125 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10227; /* *fcmlevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10233; /* *fcmlevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10239; /* *fcmlevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10245; /* *fcmlevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10251; /* *fcmlevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10257; /* *fcmlevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 364:
                  switch (pattern1125 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10228; /* *fcmltvnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10234; /* *fcmltvnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10240; /* *fcmltvnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10246; /* *fcmltvnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10252; /* *fcmltvnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10258; /* *fcmltvnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 365:
                  switch (pattern1125 (x2))
                    {
                    case 0:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10229; /* *fcmnevnx8hf_bic_combine */

                    case 1:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10235; /* *fcmnevnx4sf_bic_combine */

                    case 2:
                      if (!
#line 8602 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10241; /* *fcmnevnx2df_bic_combine */

                    case 3:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10247; /* *fcmnevnx8hf_nor_combine */

                    case 4:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10253; /* *fcmnevnx4sf_nor_combine */

                    case 5:
                      if (!
#line 8640 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                        return -1;
                      *pnum_clobbers = 1;
                      return 10259; /* *fcmnevnx2df_nor_combine */

                    default:
                      return -1;
                    }

                case 366:
                  x7 = XEXP (x3, 1);
                  switch (GET_CODE (x7))
                    {
                    case REG:
                    case SUBREG:
                      operands[4] = x7;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1218 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8678 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10260; /* *fcmuovnx8hf_bic_combine */

                        case E_VNx4BImode:
                          if (pattern1218 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8678 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10261; /* *fcmuovnx4sf_bic_combine */

                        case E_VNx2BImode:
                          if (pattern1218 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8678 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10262; /* *fcmuovnx2df_bic_combine */

                        default:
                          return -1;
                        }

                    case NOT:
                      x17 = XEXP (x7, 0);
                      operands[4] = x17;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx8BImode:
                          if (pattern1219 (x2, 
E_VNx8BImode, 
E_VNx8HFmode) != 0
                              || !
#line 8715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10263; /* *fcmuovnx8hf_nor_combine */

                        case E_VNx4BImode:
                          if (pattern1219 (x2, 
E_VNx4BImode, 
E_VNx4SFmode) != 0
                              || !
#line 8715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10264; /* *fcmuovnx4sf_nor_combine */

                        case E_VNx2BImode:
                          if (pattern1219 (x2, 
E_VNx2BImode, 
E_VNx2DFmode) != 0
                              || !
#line 8715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                            return -1;
                          *pnum_clobbers = 1;
                          return 10265; /* *fcmuovnx2df_nor_combine */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (pattern298 (x2, 
E_VNx16BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9037; /* aarch64_pred_iorvnx16bi_z */

            case E_VNx8BImode:
              if (pattern298 (x2, 
E_VNx8BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9040; /* aarch64_pred_iorvnx8bi_z */

            case E_VNx4BImode:
              if (pattern298 (x2, 
E_VNx4BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9043; /* aarch64_pred_iorvnx4bi_z */

            case E_VNx2BImode:
              if (pattern298 (x2, 
E_VNx2BImode) != 0
                  || !
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9046; /* aarch64_pred_iorvnx2bi_z */

            default:
              return -1;
            }

        case NOT:
          switch (pattern508 (x2))
            {
            case 0:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9073; /* aarch64_pred_ornvnx16bi_z */

            case 1:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9075; /* aarch64_pred_ornvnx8bi_z */

            case 2:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9077; /* aarch64_pred_ornvnx4bi_z */

            case 3:
              if (!
#line 6861 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9079; /* aarch64_pred_ornvnx2bi_z */

            case 4:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9097; /* aarch64_pred_nandvnx16bi_z */

            case 5:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9099; /* aarch64_pred_nandvnx8bi_z */

            case 6:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9101; /* aarch64_pred_nandvnx4bi_z */

            case 7:
              if (!
#line 6935 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9103; /* aarch64_pred_nandvnx2bi_z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern299 (x2))
        {
        case 0:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9038; /* aarch64_pred_xorvnx16bi_z */

        case 1:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9041; /* aarch64_pred_xorvnx8bi_z */

        case 2:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9044; /* aarch64_pred_xorvnx4bi_z */

        case 3:
          if (!
#line 6789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9047; /* aarch64_pred_xorvnx2bi_z */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_518 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern306 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern745 (x3, 
E_SImode) == 0
                  && 
#line 7339 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1068; /* *aarch64_sminsi3_cssc */
              break;

            case E_DImode:
              if (pattern745 (x3, 
E_DImode) == 0
                  && 
#line 7339 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
                return 1072; /* *aarch64_smindi3_cssc */
              break;

            case E_SFmode:
              if (pattern31 (x3, 
E_SFmode) == 0
                  && 
#line 7373 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1081; /* sminsf3 */
              break;

            case E_DFmode:
              if (pattern31 (x3, 
E_DFmode) == 0
                  && 
#line 7373 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 1082; /* smindf3 */
              break;

            case E_V8QImode:
              if (pattern31 (x3, 
E_V8QImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2060; /* sminv8qi3 */
              break;

            case E_V16QImode:
              if (pattern31 (x3, 
E_V16QImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2070; /* sminv16qi3 */
              break;

            case E_V4HImode:
              if (pattern31 (x3, 
E_V4HImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2076; /* sminv4hi3 */
              break;

            case E_V8HImode:
              if (pattern31 (x3, 
E_V8HImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2086; /* sminv8hi3 */
              break;

            case E_V2SImode:
              if (pattern31 (x3, 
E_V2SImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2092; /* sminv2si3 */
              break;

            case E_V4SImode:
              if (pattern31 (x3, 
E_V4SImode) == 0
                  && 
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2102; /* sminv4si3 */
              break;

            case E_V4HFmode:
              if (pattern31 (x3, 
E_V4HFmode) == 0
                  && (
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 172 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2656; /* sminv4hf3 */
              break;

            case E_V8HFmode:
              if (pattern31 (x3, 
E_V8HFmode) == 0
                  && (
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 173 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return 2658; /* sminv8hf3 */
              break;

            case E_V2SFmode:
              if (pattern31 (x3, 
E_V2SFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2660; /* sminv2sf3 */
              break;

            case E_V4SFmode:
              if (pattern31 (x3, 
E_V4SFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2662; /* sminv4sf3 */
              break;

            case E_V2DFmode:
              if (pattern31 (x3, 
E_V2DFmode) == 0
                  && 
#line 3348 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2664; /* sminv2df3 */
              break;

            case E_VNx32QImode:
              if (pattern32 (x3, 
E_VNx32QImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11384; /* *sminvnx32qi3 */
              break;

            case E_VNx16HImode:
              if (pattern32 (x3, 
E_VNx16HImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11388; /* *sminvnx16hi3 */
              break;

            case E_VNx8SImode:
              if (pattern32 (x3, 
E_VNx8SImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11392; /* *sminvnx8si3 */
              break;

            case E_VNx4DImode:
              if (pattern32 (x3, 
E_VNx4DImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11396; /* *sminvnx4di3 */
              break;

            case E_VNx64QImode:
              if (pattern32 (x3, 
E_VNx64QImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11400; /* *sminvnx64qi3 */
              break;

            case E_VNx32HImode:
              if (pattern32 (x3, 
E_VNx32HImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11404; /* *sminvnx32hi3 */
              break;

            case E_VNx16SImode:
              if (pattern32 (x3, 
E_VNx16SImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11408; /* *sminvnx16si3 */
              break;

            case E_VNx8DImode:
              if (pattern32 (x3, 
E_VNx8DImode) == 0
                  && 
#line 734 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return 11412; /* *sminvnx8di3 */
              break;

            default:
              break;
            }
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              return 1076; /* *aarch64_sminsi3_zero */

            case 1:
              return 1078; /* *aarch64_smindi3_zero */

            default:
              return -1;
            }

        case 1:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7392; /* *post_ra_sminvnx16qi3 */

        case 2:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7397; /* *post_ra_sminvnx8qi3 */

        case 3:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7402; /* *post_ra_sminvnx4qi3 */

        case 4:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7407; /* *post_ra_sminvnx2qi3 */

        case 5:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7412; /* *post_ra_sminvnx8hi3 */

        case 6:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7417; /* *post_ra_sminvnx4hi3 */

        case 7:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7422; /* *post_ra_sminvnx2hi3 */

        case 8:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7427; /* *post_ra_sminvnx4si3 */

        case 9:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7432; /* *post_ra_sminvnx2si3 */

        case 10:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7437; /* *post_ra_sminvnx2di3 */

        case 11:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7442; /* *post_ra_sminv2di3 */

        case 12:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11417; /* aarch64_sve_single_sminvnx32qi */

        case 13:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11422; /* aarch64_sve_single_sminvnx16hi */

        case 14:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11427; /* aarch64_sve_single_sminvnx8si */

        case 15:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11432; /* aarch64_sve_single_sminvnx4di */

        case 16:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11437; /* aarch64_sve_single_sminvnx64qi */

        case 17:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11442; /* aarch64_sve_single_sminvnx32hi */

        case 18:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11447; /* aarch64_sve_single_sminvnx16si */

        case 19:
          if (!
#line 744 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11452; /* aarch64_sve_single_sminvnx8di */

        default:
          return -1;
        }

    case SMAX:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[1] = x9;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern950 (x3, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6615 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3988; /* aarch64_sqshrun_nhi_insn */

                case 65535L:
                  if (pattern950 (x3, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6615 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3989; /* aarch64_sqshrun_nsi_insn */

                case 4294967295L:
                  if (pattern950 (x3, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6615 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3990; /* aarch64_sqshrun_ndi_insn */

                default:
                  return -1;
                }

            case PLUS:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != SIGN_EXTEND)
                return -1;
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              x12 = XEXP (x9, 1);
              operands[3] = x12;
              switch (XWINT (x5, 0))
                {
                case 255L:
                  if (pattern1061 (x3, 
E_SImode, 
E_HImode) != 0
                      || !aarch64_simd_shift_imm_offset_hi (operands[2], E_SImode)
                      || !
#line 6686 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4000; /* aarch64_sqrshrun_nhi_insn */

                case 65535L:
                  if (pattern1061 (x3, 
E_DImode, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_offset_si (operands[2], E_SImode)
                      || !
#line 6686 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4001; /* aarch64_sqrshrun_nsi_insn */

                case 4294967295L:
                  if (!register_operand (operands[0], E_TImode)
                      || GET_MODE (x3) != E_TImode
                      || GET_MODE (x4) != E_TImode
                      || pattern1060 (x6, 
E_TImode, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_offset_di (operands[2], E_SImode)
                      || !
#line 6686 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 4002; /* aarch64_sqrshrun_ndi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern311 (x3))
            {
            case 0:
              if (!
#line 785 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11503; /* aarch64_sve_sclampvnx16qi */

            case 1:
              if (!
#line 785 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11505; /* aarch64_sve_sclampvnx8hi */

            case 2:
              if (!
#line 785 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11507; /* aarch64_sve_sclampvnx4si */

            case 3:
              if (!
#line 785 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 11509; /* aarch64_sve_sclampvnx2di */

            case 4:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11519; /* aarch64_sve_sclamp_singlevnx32qi */

            case 5:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11521; /* aarch64_sve_sclamp_singlevnx16hi */

            case 6:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11523; /* aarch64_sve_sclamp_singlevnx8si */

            case 7:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11525; /* aarch64_sve_sclamp_singlevnx4di */

            case 8:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11527; /* aarch64_sve_sclamp_singlevnx64qi */

            case 9:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11529; /* aarch64_sve_sclamp_singlevnx32hi */

            case 10:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11531; /* aarch64_sve_sclamp_singlevnx16si */

            case 11:
              if (!
#line 828 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 11533; /* aarch64_sve_sclamp_singlevnx8di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern308 (x3))
        {
        case 0:
          if (!(
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 172 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5285; /* *aarch64_faminmax_fused */

        case 1:
          if (!(
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 173 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 5287; /* *aarch64_faminmax_fused */

        case 2:
          if (!
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5289; /* *aarch64_faminmax_fused */

        case 3:
          if (!
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5291; /* *aarch64_faminmax_fused */

        case 4:
          if (!
#line 9844 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
            return -1;
          return 5293; /* *aarch64_faminmax_fused */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_528 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (XVECLEN (x3, 0) == 1)
    {
      res = recog_481 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V16QImode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1300; /* aarch64_simd_mov_from_v16qilow */
      if (!vect_par_cnst_hi_half (operands[2], E_V16QImode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1306; /* aarch64_simd_mov_from_v16qihigh */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8HImode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1301; /* aarch64_simd_mov_from_v8hilow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8HImode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1307; /* aarch64_simd_mov_from_v8hihigh */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V4SImode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1302; /* aarch64_simd_mov_from_v4silow */
      if (!vect_par_cnst_hi_half (operands[2], E_V4SImode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1308; /* aarch64_simd_mov_from_v4sihigh */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8HFmode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1303; /* aarch64_simd_mov_from_v8hflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8HFmode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1309; /* aarch64_simd_mov_from_v8hfhigh */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x2) != E_V4BFmode
          || !register_operand (operands[1], E_V8BFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8BFmode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1304; /* aarch64_simd_mov_from_v8bflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8BFmode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1310; /* aarch64_simd_mov_from_v8bfhigh */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V4SFmode)
          && 
#line 295 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1305; /* aarch64_simd_mov_from_v4sflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V4SFmode)
          || !
#line 314 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1311; /* aarch64_simd_mov_from_v4sfhigh */

    case E_V16QImode:
      if (pattern652 (x2, 
E_VNx16QImode, 
E_V16QImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
        return -1;
      return 11057; /* aarch64_sve_get_neonq_vnx16qi */

    case E_V8HImode:
      if (pattern652 (x2, 
E_VNx8HImode, 
E_V8HImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
        return -1;
      return 11058; /* aarch64_sve_get_neonq_vnx8hi */

    case E_V4SImode:
      if (pattern652 (x2, 
E_VNx4SImode, 
E_V4SImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
        return -1;
      return 11059; /* aarch64_sve_get_neonq_vnx4si */

    case E_V2DImode:
      if (pattern652 (x2, 
E_VNx2DImode, 
E_V2DImode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
        return -1;
      return 11060; /* aarch64_sve_get_neonq_vnx2di */

    case E_V8BFmode:
      if (pattern652 (x2, 
E_VNx8BFmode, 
E_V8BFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
        return -1;
      return 11061; /* aarch64_sve_get_neonq_vnx8bf */

    case E_V8HFmode:
      if (pattern652 (x2, 
E_VNx8HFmode, 
E_V8HFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
        return -1;
      return 11062; /* aarch64_sve_get_neonq_vnx8hf */

    case E_V4SFmode:
      if (pattern652 (x2, 
E_VNx4SFmode, 
E_V4SFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
        return -1;
      return 11063; /* aarch64_sve_get_neonq_vnx4sf */

    case E_V2DFmode:
      if (pattern652 (x2, 
E_VNx2DFmode, 
E_V2DFmode) != 0
          || !
#line 11152 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
        return -1;
      return 11064; /* aarch64_sve_get_neonq_vnx2df */

    default:
      return -1;
    }
}

 int
recog_534 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 6932 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 982; /* extendsfdf2 */

            case E_HFmode:
              if (!register_operand (operands[1], E_HFmode)
                  || !
#line 6948 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 984; /* extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 6940 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 983; /* extendhfsf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !
#line 3188 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2639; /* extendv2sfv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4HFmode)
              || !
#line 3188 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2640; /* extendv4hfv4sf2 */

        case E_VNx8SFmode:
          if (!aligned_register_operand (operands[0], E_VNx8SFmode)
              || GET_MODE (x3) != E_VNx8SFmode
              || !register_operand (operands[1], E_VNx8HFmode)
              || !
#line 3338 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME_F16F16))
            return -1;
          return 12576; /* extendvnx8hfvnx8sf2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern651 (x3, 
E_V8HFmode, 
E_V4HFmode, 
E_V4SFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[2], E_V8HFmode)
              && 
#line 3112 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2615; /* aarch64_simd_vec_unpacks_lo_v8hf */
          if (!vect_par_cnst_hi_half (operands[2], E_V8HFmode)
              || !
#line 3168 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2637; /* aarch64_simd_vec_unpacks_hi_v8hf */

        case E_V2DFmode:
          if (pattern651 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0)
            return -1;
          if (vect_par_cnst_lo_half (operands[2], E_V4SFmode)
              && 
#line 3112 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2616; /* aarch64_simd_vec_unpacks_lo_v4sf */
          if (!vect_par_cnst_hi_half (operands[2], E_V4SFmode)
              || !
#line 3168 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2638; /* aarch64_simd_vec_unpacks_hi_v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_545 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10171; /* while_wrsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10181; /* while_wrdivnx2bi_ptest */
}

 int
recog_548 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10111; /* while_wrsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10121; /* while_wrdivnx16bi_ptest */
}

 int
recog_552 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10031; /* *while_wrsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10041; /* *while_wrdivnx16bi_cc */
}

 int
recog_556 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10110; /* while_rwsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10120; /* while_rwdivnx16bi_ptest */
}

 int
recog_564 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10109; /* while_ugesivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10119; /* while_ugedivnx16bi_ptest */
}

 int
recog_572 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10108; /* while_ugtsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10118; /* while_ugtdivnx16bi_ptest */
}

 int
recog_582 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10067; /* *while_gtsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10077; /* *while_gtdivnx4bi_cc */
}

 int
recog_592 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10026; /* *while_gesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10036; /* *while_gedivnx16bi_cc */
}

 int
recog_602 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern675 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9948; /* while_ugtsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9958; /* while_ugtdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9968; /* while_ugtsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9978; /* while_ugtdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9988; /* while_ugtsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9998; /* while_ugtdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10008; /* while_ugtsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10018; /* while_ugtdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_607 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          switch (GET_CODE (x10))
            {
            case PLUS:
              switch (pattern1236 (x1))
                {
                case 0:
                  return 124; /* addsi3_compare0 */

                case 1:
                  return 125; /* adddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1174 (x1, 
PLUS) != 0
                  || !aarch64_plus_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return -1;
              return 126; /* *addsi3_compare0_uxtw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Cmode
              || GET_MODE (x3) != E_CC_Cmode)
            return -1;
          switch (pattern1236 (x1))
            {
            case 0:
              return 129; /* addsi3_compareC */

            case 1:
              return 130; /* adddi3_compareC */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          operands[2] = x6;
          if (pattern1083 (x2) != 0)
            return -1;
          switch (pattern1253 (x1))
            {
            case 0:
              if (pattern1322 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 135; /* addsi3_compareV_imm */

            case 1:
              if (pattern1322 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 136; /* adddi3_compareV_imm */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern1083 (x2) != 0)
            return -1;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          switch (pattern1253 (x1))
            {
            case 0:
              if (pattern1323 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 137; /* addsi3_compareV */

            case 1:
              if (pattern1323 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 138; /* adddi3_compareV */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          switch (pattern1238 (x1))
            {
            case 0:
              return 151; /* *adds_extendqi_si */

            case 1:
              return 155; /* *adds_extendhi_si */

            case 2:
              return 159; /* *adds_extendsi_si */

            case 3:
              return 153; /* *adds_extendqi_di */

            case 4:
              return 157; /* *adds_extendhi_di */

            case 5:
              return 161; /* *adds_extendsi_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern903 (x1, 
ASHIFT) != 0)
        return -1;
      x16 = XEXP (x5, 1);
      operands[2] = x16;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x13 = XEXP (x11, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x17 = XEXP (x10, 1);
      if (!rtx_equal_p (x17, operands[3]))
        return -1;
      x14 = XEXP (x5, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[1] = x14;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (pattern905 (x1))
            {
            case 0:
              return 139; /* *adds_shift_imm_si */

            case 1:
              return 142; /* *adds_shift_imm_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern1285 (x1, 
SIGN_EXTEND))
            {
            case 0:
              return 175; /* *adds_extendqi_shift_si */

            case 1:
              return 179; /* *adds_extendhi_shift_si */

            case 2:
              return 183; /* *adds_extendsi_shift_si */

            case 3:
              return 177; /* *adds_extendqi_shift_di */

            case 4:
              return 181; /* *adds_extendhi_shift_di */

            case 5:
              return 185; /* *adds_extendsi_shift_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1285 (x1, 
ZERO_EXTEND))
            {
            case 0:
              return 176; /* *adds_zero_extendqi_shift_si */

            case 1:
              return 180; /* *adds_zero_extendhi_shift_si */

            case 2:
              return 184; /* *adds_zero_extendsi_shift_si */

            case 3:
              return 178; /* *adds_zero_extendqi_shift_di */

            case 4:
              return 182; /* *adds_zero_extendhi_shift_di */

            case 5:
              return 186; /* *adds_zero_extendsi_shift_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern907 (x1, 
ASHIFTRT))
        {
        case 0:
          return 140; /* *adds_shift_imm_si */

        case 1:
          return 143; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern907 (x1, 
LSHIFTRT))
        {
        case 0:
          return 141; /* *adds_shift_imm_si */

        case 1:
          return 144; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern903 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern1238 (x1))
        {
        case 0:
          return 152; /* *adds_zero_extendqi_si */

        case 1:
          return 156; /* *adds_zero_extendhi_si */

        case 2:
          return 160; /* *adds_zero_extendsi_si */

        case 3:
          return 154; /* *adds_zero_extendqi_di */

        case 4:
          return 158; /* *adds_zero_extendhi_di */

        case 5:
          return 162; /* *adds_zero_extendsi_di */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x5;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          if (!const_scalar_int_operand (operands[4], E_VOIDmode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1297 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3115 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 253; /* *addsi3_carryinC_zero */

            case E_TImode:
              if (pattern1297 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3115 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 254; /* *adddi3_carryinC_zero */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x19 = XEXP (x18, 0);
          operands[3] = x19;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1324 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 257; /* *addsi3_carryinV_zero */

            case E_TImode:
              if (pattern1324 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 258; /* *adddi3_carryinV_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[3] = x14;
      x16 = XEXP (x5, 1);
      switch (GET_CODE (x16))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x3, 1);
          operands[5] = x7;
          if (!const_scalar_int_operand (operands[5], E_VOIDmode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1332 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3135 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 255; /* *addsi3_carryinC */

            case E_TImode:
              if (pattern1332 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3135 "../../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 256; /* *adddi3_carryinC */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x22 = XEXP (x19, 0);
          operands[4] = x22;
          x23 = XEXP (x19, 1);
          if (!rtx_equal_p (x23, operands[1]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1350 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 259; /* *addsi3_carryinV */

            case E_TImode:
              if (pattern1350 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 260; /* *adddi3_carryinV */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_614 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x4, 1))
        {
        case 17:
          if (pattern766 (x1) != 0
              || !
#line 8278 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1205; /* tstart */

        case 157:
          if (pattern766 (x1) != 0
              || !
#line 8287 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1206; /* ttest */

        case 20:
          if (pattern767 (x1, 
20) != 0
              || !
#line 8314 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1209; /* aarch64_rndr */

        case 21:
          if (pattern767 (x1, 
21) != 0
              || !
#line 8324 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1210; /* aarch64_rndrrs */

        case 66:
          if (pattern768 (x1, 
65) != 0
              || !
#line 8445 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1219; /* st64bv */

        case 68:
          if (pattern768 (x1, 
67) != 0
              || !
#line 8457 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1220; /* st64bv0 */

        case 23:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XINT (x7, 1) != 23
              || !register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (XVECLEN (x7, 0))
            {
            case 2:
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_QImode)
                      || GET_MODE (x7) != E_QImode
                      || !aarch64_reg_or_zero (operands[2], E_QImode))
                    return -1;
                  return 5521; /* aarch64_store_exclusiveqi */

                case E_HImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_HImode)
                      || GET_MODE (x7) != E_HImode
                      || !aarch64_reg_or_zero (operands[2], E_HImode))
                    return -1;
                  return 5522; /* aarch64_store_exclusivehi */

                case E_SImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_SImode)
                      || GET_MODE (x7) != E_SImode
                      || !aarch64_reg_or_zero (operands[2], E_SImode))
                    return -1;
                  return 5523; /* aarch64_store_exclusivesi */

                case E_DImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_DImode)
                      || GET_MODE (x7) != E_DImode
                      || !aarch64_reg_or_zero (operands[2], E_DImode))
                    return -1;
                  return 5524; /* aarch64_store_exclusivedi */

                default:
                  return -1;
                }

            case 3:
              if (GET_MODE (x7) != E_TImode
                  || !aarch64_sync_memory_operand (operands[1], E_TImode))
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              if (!aarch64_reg_or_zero (operands[2], E_DImode))
                return -1;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!aarch64_reg_or_zero (operands[3], E_DImode))
                return -1;
              x11 = XVECEXP (x7, 0, 2);
              operands[4] = x11;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              return 5525; /* aarch64_store_exclusive_pair */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[1] = x12;
      x13 = XVECEXP (x4, 0, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x5 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      switch (XINT (x4, 1))
        {
        case 32:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1140 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5396; /* aarch64_atomic_iorqi_lse */

            case E_HImode:
              if (pattern1140 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5400; /* aarch64_atomic_iorhi_lse */

            case E_SImode:
              if (pattern1140 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5404; /* aarch64_atomic_iorsi_lse */

            case E_DImode:
              if (pattern1140 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5408; /* aarch64_atomic_iordi_lse */

            default:
              return -1;
            }

        case 33:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1140 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5397; /* aarch64_atomic_bicqi_lse */

            case E_HImode:
              if (pattern1140 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5401; /* aarch64_atomic_bichi_lse */

            case E_SImode:
              if (pattern1140 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5405; /* aarch64_atomic_bicsi_lse */

            case E_DImode:
              if (pattern1140 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5409; /* aarch64_atomic_bicdi_lse */

            default:
              return -1;
            }

        case 34:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1140 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5398; /* aarch64_atomic_xorqi_lse */

            case E_HImode:
              if (pattern1140 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5402; /* aarch64_atomic_xorhi_lse */

            case E_SImode:
              if (pattern1140 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5406; /* aarch64_atomic_xorsi_lse */

            case E_DImode:
              if (pattern1140 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5410; /* aarch64_atomic_xordi_lse */

            default:
              return -1;
            }

        case 35:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1140 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5399; /* aarch64_atomic_addqi_lse */

            case E_HImode:
              if (pattern1140 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5403; /* aarch64_atomic_addhi_lse */

            case E_SImode:
              if (pattern1140 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5407; /* aarch64_atomic_addsi_lse */

            case E_DImode:
              if (pattern1140 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5411; /* aarch64_atomic_adddi_lse */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 22
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern769 (x6, 
E_DImode, 
22, 
2, 
UNSPEC_VOLATILE) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!aarch64_sync_memory_operand (operands[2], E_TImode))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 1);
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[3]))
        return -1;
      return 5520; /* aarch64_load_exclusive_pair */

    default:
      return -1;
    }
}

 int
recog_622 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 5:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (scratch_operand (operands[4], E_DImode))
            {
              res = recog_544 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UNSPEC_VOLATILE
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 31)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          operands[1] = x5;
          x12 = XVECEXP (x8, 0, 1);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1264 (x1))
            {
            case 0:
              return 5416; /* aarch64_atomic_fetch_addqi */

            case 1:
              return 5421; /* aarch64_atomic_fetch_addhi */

            case 2:
              return 5426; /* aarch64_atomic_fetch_addsi */

            case 3:
              return 5431; /* aarch64_atomic_fetch_adddi */

            case 4:
              return 5417; /* aarch64_atomic_fetch_subqi */

            case 5:
              return 5422; /* aarch64_atomic_fetch_subhi */

            case 6:
              return 5427; /* aarch64_atomic_fetch_subsi */

            case 7:
              return 5432; /* aarch64_atomic_fetch_subdi */

            case 8:
              return 5418; /* aarch64_atomic_fetch_orqi */

            case 9:
              return 5423; /* aarch64_atomic_fetch_orhi */

            case 10:
              return 5428; /* aarch64_atomic_fetch_orsi */

            case 11:
              return 5433; /* aarch64_atomic_fetch_ordi */

            case 12:
              return 5419; /* aarch64_atomic_fetch_xorqi */

            case 13:
              return 5424; /* aarch64_atomic_fetch_xorhi */

            case 14:
              return 5429; /* aarch64_atomic_fetch_xorsi */

            case 15:
              return 5434; /* aarch64_atomic_fetch_xordi */

            case 16:
              return 5420; /* aarch64_atomic_fetch_andqi */

            case 17:
              return 5425; /* aarch64_atomic_fetch_andhi */

            case 18:
              return 5430; /* aarch64_atomic_fetch_andsi */

            case 19:
              return 5435; /* aarch64_atomic_fetch_anddi */

            case 20:
              return 5452; /* atomic_fetch_nandqi */

            case 21:
              return 5453; /* atomic_fetch_nandhi */

            case 22:
              return 5454; /* atomic_fetch_nandsi */

            case 23:
              return 5455; /* atomic_fetch_nanddi */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 66
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != SET)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != UNSPEC
              || XVECLEN (x13, 0) != 2)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_BLKmode)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x11 = XEXP (x2, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x7, 0);
          operands[0] = x16;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_DImode)
              || GET_MODE (x13) != E_BLKmode)
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x19 = XEXP (x15, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          switch (XINT (x13, 1))
            {
            case 8:
              if (!
#line 1908 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 84; /* *aarch64_cpymemdi */

            case 70:
              if (!
#line 1954 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 85; /* *aarch64_movmemdi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 98)
            return -1;
          x11 = XEXP (x2, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern439 (x7, 
30, 
E_DImode, 
CLOBBER) != 0)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (pattern1229 (x10, 
29, 
USE) != 0)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          operands[0] = x20;
          if (!aarch64_valid_symref (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!scratch_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x11))
            {
            case E_SImode:
              if (GET_MODE (x5) != E_SImode
                  || !(
#line 7807 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                return -1;
              return 1135; /* tlsdesc_small_advsimd_si */

            case E_DImode:
              if (GET_MODE (x5) != E_DImode
                  || !(
#line 7807 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 164 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                return -1;
              return 1136; /* tlsdesc_small_advsimd_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_618 (x1, insn, pnum_clobbers);

    case 3:
      return recog_620 (x1, insn, pnum_clobbers);

    case 4:
      return recog_619 (x1, insn, pnum_clobbers);

    case 6:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || pattern354 (x5, 
E_TImode, 
682) != 0
          || pattern442 (x1, 
17, 
CLOBBER, 
16, 
E_TImode, 
0) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (pattern1209 (x4, 
18) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 4);
      if (pattern1229 (x10, 
30, 
CLOBBER) != 0)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x21) != CLOBBER)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 66
          || GET_MODE (x22) != E_CCmode)
        return -1;
      return 12903; /* aarch64_get_sme_state */

    case 26:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1)
        return -1;
      x23 = XVECEXP (x2, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != USE
          || pattern562 (x1, 
32, 
67, 
CLOBBER) != 0
          || pattern1023 (x1, 
E_V4x16QImode, 
48, 
44, 
40, 
36) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern1352 (x24, 
E_V4x16QImode, 
52) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 8);
      if (pattern686 (x25, 
E_V4x16QImode, 
56) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x26) != CLOBBER)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 60
          || GET_MODE (x27) != E_V4x16QImode)
        return -1;
      x28 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x28) != CLOBBER)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 68
          || GET_MODE (x29) != E_VNx16BImode)
        return -1;
      x30 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x30) != CLOBBER)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 69
          || GET_MODE (x31) != E_VNx16BImode)
        return -1;
      x32 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x32) != CLOBBER)
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 70
          || GET_MODE (x33) != E_VNx16BImode)
        return -1;
      x34 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x34) != CLOBBER)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 71
          || GET_MODE (x35) != E_VNx16BImode)
        return -1;
      x36 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x36) != CLOBBER)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 72
          || GET_MODE (x37) != E_VNx16BImode)
        return -1;
      x38 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x38) != CLOBBER)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 73
          || GET_MODE (x39) != E_VNx16BImode)
        return -1;
      x40 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x40) != CLOBBER)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 74
          || GET_MODE (x41) != E_VNx16BImode)
        return -1;
      x42 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x42) != CLOBBER)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 75
          || GET_MODE (x43) != E_VNx16BImode)
        return -1;
      x44 = XVECEXP (x1, 0, 18);
      if (GET_CODE (x44) != CLOBBER)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 76
          || GET_MODE (x45) != E_VNx16BImode)
        return -1;
      x46 = XVECEXP (x1, 0, 19);
      if (GET_CODE (x46) != CLOBBER)
        return -1;
      x47 = XEXP (x46, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 77
          || GET_MODE (x47) != E_VNx16BImode)
        return -1;
      x48 = XVECEXP (x1, 0, 20);
      if (GET_CODE (x48) != CLOBBER)
        return -1;
      x49 = XEXP (x48, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 78
          || GET_MODE (x49) != E_VNx16BImode)
        return -1;
      x50 = XVECEXP (x1, 0, 21);
      if (GET_CODE (x50) != CLOBBER)
        return -1;
      x51 = XEXP (x50, 0);
      if (GET_CODE (x51) != REG
          || REGNO (x51) != 79
          || GET_MODE (x51) != E_VNx16BImode)
        return -1;
      x52 = XVECEXP (x1, 0, 22);
      if (GET_CODE (x52) != CLOBBER)
        return -1;
      x53 = XEXP (x52, 0);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 80
          || GET_MODE (x53) != E_VNx16BImode)
        return -1;
      x54 = XVECEXP (x1, 0, 23);
      if (GET_CODE (x54) != CLOBBER)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != REG
          || REGNO (x55) != 81
          || GET_MODE (x55) != E_VNx16BImode)
        return -1;
      x56 = XVECEXP (x1, 0, 24);
      if (GET_CODE (x56) != CLOBBER)
        return -1;
      x57 = XEXP (x56, 0);
      if (GET_CODE (x57) != REG
          || REGNO (x57) != 82
          || GET_MODE (x57) != E_VNx16BImode)
        return -1;
      x58 = XVECEXP (x1, 0, 25);
      if (GET_CODE (x58) != CLOBBER)
        return -1;
      x59 = XEXP (x58, 0);
      if (GET_CODE (x59) != REG
          || REGNO (x59) != 83
          || GET_MODE (x59) != E_VNx16BImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 684:
          return 12905; /* aarch64_smstart_sm */

        case 685:
          return 12906; /* aarch64_smstop_sm */

        default:
          return -1;
        }

    case 8:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 688
          || pattern563 (x5, 
89) != 0)
        return -1;
      x60 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x60) != REG
          || REGNO (x60) != 90
          || GET_MODE (x60) != E_DImode)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 91
          || GET_MODE (x11) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern562 (x1, 
15, 
14, 
CLOBBER) != 0
          || pattern1023 (x1, 
E_DImode, 
30, 
18, 
17, 
16) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern1352 (x24, 
E_CCmode, 
66) != 0)
        return -1;
      return 12907; /* aarch64_tpidr2_save */

    case 9:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 92
          || GET_MODE (x11) != E_DImode
          || pattern687 (x1) != 0
          || GET_MODE (x5) != E_DImode)
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XINT (x5, 1) != 689)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 0
              || GET_MODE (x20) != E_DImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern1137 (x7) != 0)
            return -1;
          return 12915; /* aarch64_tpidr2_restore */

        case 4:
          if (XINT (x5, 1) != 693
              || pattern703 (x5) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern439 (x7, 
0, 
E_DImode, 
CLOBBER) != 0)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          operands[0] = x20;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          return 12916; /* aarch64_restore_za */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern970 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1091 (insn, operands);
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1124 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1102 (insn, operands);
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1135 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1113 (insn, operands);
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1146 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x6 = XVECEXP (x3, 0, 2);
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XVECEXP (x6, 0, 2);
      operands[2] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1257 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          x10 = XVECEXP (x6, 0, 0);
          operands[5] = x10;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && (
#line 6300 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6305 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1947 (insn, operands);
          if (rtx_equal_p (x5, operands[3])
              && (
#line 6354 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6359 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1950 (insn, operands);
          operands[5] = x4;
          operands[6] = x10;
          operands[4] = x5;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6408 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 6418 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1953 (insn, operands);

        case E_VNx4SFmode:
          if (pattern1257 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          x10 = XVECEXP (x6, 0, 0);
          operands[5] = x10;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && (
#line 6300 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6305 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1948 (insn, operands);
          if (rtx_equal_p (x5, operands[3])
              && (
#line 6354 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6359 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1951 (insn, operands);
          operands[5] = x4;
          operands[6] = x10;
          operands[4] = x5;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6408 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 6418 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1954 (insn, operands);

        case E_VNx2DFmode:
          if (pattern1257 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          x10 = XVECEXP (x6, 0, 0);
          operands[5] = x10;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && (
#line 6300 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6305 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1949 (insn, operands);
          if (rtx_equal_p (x5, operands[3])
              && (
#line 6354 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6359 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1952 (insn, operands);
          operands[5] = x4;
          operands[6] = x10;
          operands[4] = x5;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6408 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 6418 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1955 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern854 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1100 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1133 (insn, operands);

    case E_VNx4SFmode:
      if (pattern854 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1111 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1144 (insn, operands);

    case E_VNx2DFmode:
      if (pattern854 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1122 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1155 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1241 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1248 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2909 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1268 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1273 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2917 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2925 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1241 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1248 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2906 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1268 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1273 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2914 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1307 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2922 (insn, operands);
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2791 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2836 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2876 (insn, operands);
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2778 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2825 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2865 (insn, operands);
}

 rtx_insn *
split_36 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2812 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2853 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2893 (insn, operands);
}

 rtx_insn *
split_41 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2798 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2842 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2882 (insn, operands);
}

 rtx_insn *
split_46 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2785 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2831 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2871 (insn, operands);
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2772 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2820 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2860 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1091 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1647 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1720 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1772 (insn, operands);

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1660 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1733 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1785 (insn, operands);

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1673 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1746 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1798 (insn, operands);

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1686 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1759 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1811 (insn, operands);

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1935 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6140 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1938 (insn, operands);

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1936 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6140 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1939 (insn, operands);

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1937 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6140 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1940 (insn, operands);

        default:
          return NULL;
        }

    case 1L:
      x6 = XVECEXP (x2, 0, 2);
      operands[4] = x6;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return NULL;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1027 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
                  || !((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1824 (insn, operands);

            case E_VNx8HFmode:
              if (pattern1027 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1837 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1027 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1850 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1027 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1863 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case CONST:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1243 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 6176 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1941 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1243 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 6176 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1942 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1243 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 6176 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1943 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      return split_67 (x1, insn);

    case 2:
      return split_66 (x1, insn);

    case 4:
      return split_68 (x1, insn);

    case 5:
      x4 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x4) != CONST_INT)
        return NULL;
      x5 = XVECEXP (x3, 0, 2);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 3);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 4);
      operands[4] = x7;
      switch (XINT (x3, 1))
        {
        case 375:
          switch (pattern1094 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1979 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1995 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2011 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1983 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1999 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2015 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1987 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2003 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2019 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1991 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2007 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2023 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2027 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2031 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2035 (insn, operands);

            default:
              return NULL;
            }

        case 376:
          switch (pattern1094 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1980 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1996 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2012 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1984 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2000 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2016 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1988 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2004 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2020 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1992 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2008 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2024 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2028 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2032 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2036 (insn, operands);

            default:
              return NULL;
            }

        case 380:
          switch (pattern1094 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1981 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1997 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2013 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1985 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2001 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2017 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1989 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2005 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2021 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1993 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2009 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2025 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2029 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2033 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2037 (insn, operands);

            default:
              return NULL;
            }

        case 381:
          switch (pattern1094 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1982 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1998 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2014 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1986 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2002 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2018 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1990 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2006 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2022 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_1994 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2010 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 484 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2026 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2030 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2034 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2038 (insn, operands);

            default:
              return NULL;
            }

        case 359:
          switch (pattern1095 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2039 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2051 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2043 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2055 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2047 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2059 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2067 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2071 (insn, operands);

            default:
              return NULL;
            }

        case 360:
          switch (pattern1095 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2040 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2052 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2044 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2056 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2048 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2060 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2064 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2068 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2072 (insn, operands);

            default:
              return NULL;
            }

        case 361:
          switch (pattern1095 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2041 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2053 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2045 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2057 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2049 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2061 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2065 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2069 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2073 (insn, operands);

            default:
              return NULL;
            }

        case 362:
          switch (pattern1095 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2042 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2054 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2046 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2058 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2050 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2062 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2066 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2070 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2074 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_84 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2524 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2534 (insn, operands);
}

 rtx_insn *
split_86 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2484 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2494 (insn, operands);
}

 rtx_insn *
split_89 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2424 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2434 (insn, operands);
}

 rtx_insn *
split_92 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2523 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2533 (insn, operands);
}

 rtx_insn *
split_95 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2463 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2473 (insn, operands);
}

 rtx_insn *
split_99 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2383 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2393 (insn, operands);
}

 rtx_insn *
split_103 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2462 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3435 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2472 (insn, operands);
}

 rtx_insn *
split_108 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2521 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2531 (insn, operands);
}

 rtx_insn *
split_114 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2401 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3434 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2411 (insn, operands);
}

 rtx_insn *
split_121 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2420 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3433 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2430 (insn, operands);
}

 rtx_insn *
split_129 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2419 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3432 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2429 (insn, operands);
}

 rtx_insn *
split_137 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern341 (x1))
        {
        case 0:
          if (!(
#line 4423 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4427 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 1:
          if (!(
#line 4423 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4427 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern341 (x1))
        {
        case 0:
          if (!(
#line 4423 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed) && 
#line 4427 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_20 (insn, operands);

        case 1:
          if (!(
#line 4423 "../../../gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed) && 
#line 4427 "../../../gcc/config/aarch64/aarch64.md"
( true)))
            return NULL;
          return gen_split_22 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern362 (x1, 
E_CCmode, 
66, 
CLOBBER) != 0)
        return NULL;
      x4 = XEXP (x3, 1);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SMAX:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_28 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_32 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_29 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_33 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_30 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_34 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern971 (x3))
            {
            case 0:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_31 (insn, operands);

            case 1:
              if (!(
#line 4964 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)) && 
#line 4966 "../../../gcc/config/aarch64/aarch64.md"
( 1)))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CC_NZVmode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern701 (x1, 
CLOBBER, 
E_CC_NZVmode) != 0)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (!register_operand (x7, E_SImode))
        return NULL;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          operands[1] = x9;
          operands[2] = x7;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !aarch64_mov_imm_operand (operands[1], E_SImode))
                return NULL;
              return gen_split_72 (insn, operands);

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !aarch64_mov_imm_operand (operands[1], E_DImode))
                return NULL;
              return gen_split_73 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_74 (insn, operands);

            case 1:
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_75 (insn, operands);

            case 1:
              return gen_split_80 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_76 (insn, operands);

            case 1:
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        case ROTATERT:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_77 (insn, operands);

            case 1:
              return gen_split_82 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          switch (pattern1097 (x1))
            {
            case 0:
              return gen_split_78 (insn, operands);

            case 1:
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NEG:
      switch (pattern342 (x1))
        {
        case 0:
          if (!(
#line 7012 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 1:
          if (!(
#line 7012 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 2:
          if (!(
#line 7012 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 3:
          if (!(
#line 7012 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 4:
          if (!(
#line 7012 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7014 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 5:
          if (!(
#line 7075 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 6:
          if (!(
#line 7075 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 7075 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 8:
          if (!(
#line 7075 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7077 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 7163 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 7165 "../../../gcc/config/aarch64/aarch64-simd.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 127
          || pattern547 (x2) != 0)
        return NULL;
      x10 = XVECEXP (x3, 0, 2);
      if (XWINT (x10, 0) == 1L)
        {
          x11 = XVECEXP (x3, 0, 3);
          switch (GET_CODE (x11))
            {
            case CONST:
              switch (pattern1077 (x1))
                {
                case 0:
                  if ((
#line 983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 987 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_525 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1035 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1039 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_529 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case SUBREG:
              switch (pattern1079 (x1))
                {
                case 0:
                  if ((
#line 1009 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_526 (insn, operands);
                  break;

                case 1:
                  if ((
#line 1009 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_527 (insn, operands);
                  break;

                case 2:
                  if ((
#line 1009 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1013 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_528 (insn, operands);
                  break;

                case 3:
                  if ((
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_530 (insn, operands);
                  break;

                case 4:
                  if ((
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_531 (insn, operands);
                  break;

                case 5:
                  if ((
#line 1061 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[2]) || !CONSTANT_P (operands[3])))))
                    return gen_split_532 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case UNSPEC:
              res = split_132 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
        }
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 3)
        return NULL;
      x12 = XVECEXP (x3, 0, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !aarch64_sve_ptrue_flag (x10, E_SImode))
        return NULL;
      x13 = XVECEXP (x11, 0, 1);
      if (!aarch64_sve_ptrue_flag (x13, E_SImode))
        return NULL;
      return split_135 (x1, insn);

    case VEC_DUPLICATE:
      switch (pattern347 (x1))
        {
        case 0:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1000 (insn, operands);

        case 1:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1019 (insn, operands);

        case 2:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1001 (insn, operands);

        case 3:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1002 (insn, operands);

        case 4:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1003 (insn, operands);

        case 5:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1004 (insn, operands);

        case 6:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1020 (insn, operands);

        case 7:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1005 (insn, operands);

        case 8:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1006 (insn, operands);

        case 9:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1007 (insn, operands);

        case 10:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1021 (insn, operands);

        case 11:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1008 (insn, operands);

        case 12:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1009 (insn, operands);

        case 13:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1022 (insn, operands);

        case 14:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1010 (insn, operands);

        case 15:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1024 (insn, operands);

        case 16:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1011 (insn, operands);

        case 17:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1012 (insn, operands);

        case 18:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1013 (insn, operands);

        case 19:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1023 (insn, operands);

        case 20:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1014 (insn, operands);

        case 21:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1015 (insn, operands);

        case 22:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1016 (insn, operands);

        case 23:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1025 (insn, operands);

        case 24:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1017 (insn, operands);

        case 25:
          if (!(
#line 2699 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2705 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1018 (insn, operands);

        case 26:
          if (!(
#line 2732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !BYTES_BIG_ENDIAN) && 
#line 2745 "../../../gcc/config/aarch64/aarch64-sve.md"
( MEM_P (operands[1]))))
            return NULL;
          return gen_split_1026 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      return split_136 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V16QImode))
    {
      switch (pattern921 (
E_V16QImode))
        {
        case 0:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_92 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_93 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_94 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_95 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_96 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_97 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_98 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_99 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode))
    return NULL;
  switch (pattern975 ())
    {
    case 0:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_156 (insn, operands);

    case 1:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_157 (insn, operands);

    case 2:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_158 (insn, operands);

    case 3:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_159 (insn, operands);

    case 4:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_160 (insn, operands);

    case 5:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_161 (insn, operands);

    case 6:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_162 (insn, operands);

    case 7:
      if (!
#line 111 "../../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_163 (insn, operands);

    default:
      return NULL;
    }
}
